app.DateTool = {
	//判断是否闰年
	IsLeapYear: function(iYear) {
		if(iYear % 4 == 0 && iYear % 100 != 0) {
			return true;
		} else {
			if(iYear % 400 == 0) {
				return true;
			} else {
				return false;
			}
		}
	},

	//---------------------------------------------------
	// 日期格式化
	// 格式 YYYY/yyyy/YY/yy 表示年份
	// MM/M 月份
	// W/w 星期
	// dd/DD/d/D 日期
	// hh/HH/h/H 时间
	// mm/m 分钟
	// ss/SS/s/S 秒
	//---------------------------------------------------
	DateFormat: function(formatStr, datestr) {
		var date = new Date(datestr);
		var str = formatStr;
		var Week = ['周日', '周一', '周二', '周三', '周四', '周五', '周六'];
		str = str.replace(/yyyy|YYYY/, date.getFullYear());
		str = str.replace(/yy|YY/, (date.getYear() % 100) > 9 ? (date.getYear() % 100).toString() : '0' + (date.getYear() % 100));
		str = str.replace(/MM/, date.getMonth() > 8 ? (date.getMonth() + 1).toString() : '0' + (date.getMonth() + 1));
		str = str.replace(/M/g, date.getMonth());
		str = str.replace(/w|W/g, Week[date.getDay()]);
		str = str.replace(/dd|DD/, date.getDate() > 9 ? date.getDate().toString() : '0' + date.getDate());
		str = str.replace(/d|D/g, date.getDate());
		str = str.replace(/hh|HH/, date.getHours() > 9 ? date.getHours().toString() : '0' + date.getHours());
		str = str.replace(/h|H/g, date.getHours());
		str = str.replace(/mm/, date.getMinutes() > 9 ? date.getMinutes().toString() : '0' + date.getMinutes());
		str = str.replace(/m/g, date.getMinutes());
		str = str.replace(/ss|SS/, date.getSeconds() > 9 ? date.getSeconds().toString() : '0' + date.getSeconds());
		str = str.replace(/s|S/g, date.getSeconds());
		return str;
	},
	//+---------------------------------------------------
	//| 求两个时间的天数差 日期格式为 YYYY-MM-dd
	//+---------------------------------------------------
	daysBetween: function(DateOne, DateTwo) {
		var OneMonth = DateOne.substring(5, DateOne.lastIndexOf('-'));
		var OneDay = DateOne.substring(DateOne.length, DateOne.lastIndexOf('-') + 1);
		var OneYear = DateOne.substring(0, DateOne.indexOf('-'));

		var TwoMonth = DateTwo.substring(5, DateTwo.lastIndexOf('-'));
		var TwoDay = DateTwo.substring(DateTwo.length, DateTwo.lastIndexOf('-') + 1);
		var TwoYear = DateTwo.substring(0, DateTwo.indexOf('-'));

		var cha = ((Date.parse(OneMonth + '/' + OneDay + '/' + OneYear) - Date.parse(TwoMonth + '/' + TwoDay + '/' + TwoYear)) / 86400000);
		return Math.abs(cha);
	},

	//+---------------------------------------------------
	//| 日期计算
	//+---------------------------------------------------
	DateAdd: function(strInterval, Number, dateStr) {
		var dtTmp = dateStr;
		switch(strInterval) {
			case 's':
				return new Date(Date.parse(dtTmp) + (1000 * Number));
			case 'n':
				return new Date(Date.parse(dtTmp) + (60000 * Number));
			case 'h':
				return new Date(Date.parse(dtTmp) + (3600000 * Number));
			case 'd':
				return new Date(Date.parse(dtTmp) + (86400000 * Number));
			case 'w':
				return new Date(Date.parse(dtTmp) + ((86400000 * 7) * Number));
			case 'q':
				return new Date(dtTmp.getFullYear(), (dtTmp.getMonth()) + Number * 3, dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
			case 'm':
				return new Date(dtTmp.getFullYear(), (dtTmp.getMonth()) + Number, dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
			case 'y':
				return new Date((dtTmp.getFullYear() + Number), dtTmp.getMonth(), dtTmp.getDate(), dtTmp.getHours(), dtTmp.getMinutes(), dtTmp.getSeconds());
		}
	},
	//+---------------------------------------------------
	//| 日期输出字符串，重载了系统的toString方法
	//+---------------------------------------------------
	DateToString: function(showWeek, dateStr) {
		var myDate = new Date(dateStr);
		var str = myDate.toLocaleDateString();
		if(showWeek) {
			var Week = ['日', '一', '二', '三', '四', '五', '六'];
			str += ' 星期' + Week[myDate.getDay()];
		}
		return str;
	},
	//+---------------------------------------------------
	//| 比较日期差 dtEnd 格式为日期型或者 有效日期格式字符串
	//+---------------------------------------------------
	DateDiff: function(strInterval, dateStart, dtEnd) {
		var dtStart = new Date(dateStart);
		if(typeof dtEnd == 'string') //如果是字符串转换为日期型
		{
			dtEnd = new Date(dtEnd);
		}
		switch(strInterval) {
			case 's':
				return parseInt((dtEnd - dtStart) / 1000);
			case 'n':
				return parseInt((dtEnd - dtStart) / 60000);
			case 'h':
				return parseInt((dtEnd - dtStart) / 3600000);
			case 'd':
				return parseInt((dtEnd - dtStart) / 86400000);
			case 'w':
				return parseInt((dtEnd - dtStart) / (86400000 * 7));
			case 'm':
				return(dtEnd.getMonth() + 1) + ((dtEnd.getFullYear() - dtStart.getFullYear()) * 12) - (dtStart.getMonth() + 1);
			case 'y':
				return dtEnd.getFullYear() - dtStart.getFullYear();
		}
	},
	//+---------------------------------------------------
	//| 日期合法性验证
	//| 格式为：YYYY-MM-DD或YYYY/MM/DD
	//+---------------------------------------------------
	IsValidDate: function(DateStr) {
		var sDate = DateStr.replace(/(^\s+|\s+$)/g, ''); //去两边空格;
		if(sDate == '') return true;
		//如果格式满足YYYY-(/)MM-(/)DD或YYYY-(/)M-(/)DD或YYYY-(/)M-(/)D或YYYY-(/)MM-(/)D就替换为''
		//数据库中，合法日期可以是:YYYY-MM/DD(2003-3/21),数据库会自动转换为YYYY-MM-DD格式
		var s = sDate.replace(/[\d]{ 4,4 }[\-/]{ 1 }[\d]{ 1,2 }[\-/]{ 1 }[\d]{ 1,2 }/g, '');
		if(s == '') //说明格式满足YYYY-MM-DD或YYYY-M-DD或YYYY-M-D或YYYY-MM-D
		{
			var t = new Date(sDate.replace(/\-/g, '/'));
			var ar = sDate.split(/[-/:]/);
			if(ar[0] != t.getYear() || ar[1] != t.getMonth() + 1 || ar[2] != t.getDate()) {
				//alert('错误的日期格式！格式为：YYYY-MM-DD或YYYY/MM/DD。注意闰年。');
				return false;
			}
		} else {
			//alert('错误的日期格式！格式为：YYYY-MM-DD或YYYY/MM/DD。注意闰年。');
			return false;
		}
		return true;
	},
	//+---------------------------------------------------
	//| 取得日期数据信息
	//| 参数 interval 表示数据类型
	//| y 年 m月 d日 w星期 ww周 h时 n分 s秒
	//+---------------------------------------------------
	DatePart: function(interval, datestr) {
		var myDate = new Date(datestr);
		var partStr = '';
		var Week = ['周日', '周一', '周二', '周三', '周四', '周五', '周六'];
		switch(interval) {
			case 'y':
				partStr = myDate.getFullYear();
				break;
			case 'm':
				partStr = myDate.getMonth() + 1 < 10 ? "0" + (myDate.getMonth() + 1) : myDate.getMonth() + 1;
				break;
			case 'd':
				partStr = myDate.getDate() < 10 ? "0" + myDate.getDate() : myDate.getDate();
				break;
			case 'w':
				partStr = Week[myDate.getDay()];
				break;
			case 'ww':
				partStr = myDate.WeekNumOfYear();
				break;
			case 'h':
				partStr = myDate.getHours();
				break;
			case 'n':
				partStr = myDate.getMinutes();
				break;
			case 's':
				partStr = myDate.getSeconds();
				break;
		}
		return partStr;
	},
	//+---------------------------------------------------
	//| 取得当前日期所在月的最大天数
	//+---------------------------------------------------
	MaxDayOfDate: function(dateStr) {
		var myDate = dateStr;
		var ary = app.DateTool.DatetoArray(myDate);
		month = parseInt(ary[1], 10);
		var d = new Date(ary[0], ary[1], 0);
		return d.getDate();
	},
	//+---------------------------------------------------
	//| 把日期分割成数组
	//+---------------------------------------------------
	DatetoArray: function(dateStr) {
		var myDate = new Date(dateStr);
		var myArray = Array();
		myArray[0] = myDate.getFullYear();
		myArray[1] = myDate.getMonth() + 1;
		myArray[2] = myDate.getDate();
		myArray[3] = myDate.getHours();
		myArray[4] = myDate.getMinutes();
		myArray[5] = myDate.getSeconds();
		return myArray;
	},
	getCurrentMonthFirst: function(dateStr) {
		var date = new Date(dateStr);
		date.setDate(1);
		return date;
	},
	DateToWeek: function(dateStr, SystemTime) {
		var self = app.DateTool;
		var starts = dateStr.toLocaleDateString();
		var ends = SystemTime.toLocaleDateString();
		var iday = self.datedifference(starts, ends);
		if(iday == 0) {
			return "今天";
		} else if(iday == 1) {
			return "明天";
		} else {
			var Week = ['日', '一', '二', '三', '四', '五', '六'];
			return '周' + Week[new Date(dateStr).getDay()];
		}
	},
	datedifference: function(sDate1, sDate2) { //sDate1和sDate2是2006-12-18格式  
		var dateSpan,
			tempDate,
			iDays;
		var self = app.DateTool;
		var starts = self.DatetoArray(sDate1.toString().replace(/-/g, "/"));
		var ends = self.DatetoArray(sDate2.toString().replace(/-/g, "/"));

		var start = starts[0] + "/" + starts[1] + "/" + starts[2];
		var end = ends[0] + "/" + ends[1] + "/" + ends[2];

		sDate1 = Date.parse(start);
		sDate2 = Date.parse(end);
		dateSpan = sDate2 - sDate1;
		dateSpan = Math.abs(dateSpan);

		iDays = Math.floor(dateSpan / (24 * 3600 * 1000));
		return iDays;
	}
}