(function(window, $) {
	window.TripDate = (function() {
		var changeCallback;
		var nowDateList;

		function initDate(callback, dateList) {
			nowDateList = dateList;
			changeCallback = callback;
			app.GetServicesTime(initDateJson);
		}

		function initDateJson(data) {
			var selectDate;
			var nowDate = new Date();
			if(app.GetResultState(data)) {
				try {
					nowDate = new Date(data.Now.replace(/-/g, "/"));
				} catch(e) {
					nowDate = new Date();
				}
			} else {
				nowDate = new Date();
			}

			//验证日期有效性
			loadDates(nowDate, nowDateList);
			var jsonDate = window.CustomDate.initDate(nowDateList, nowDate, 0, 12);
			var render = template.compile(dateControlTpl);
			$("#indexContent").remove();
			$(document.body).append("<div id='indexContent'></div>");
			$("#indexContent").html(render(jsonDate));

			mui("#dateScroll").scroll();

			$(".newdateback").off().on("tap", function() {
				$(".newdateback").hide();
				$(".datecalendar").slideToggle(200);
			});

			$(".datecalendar").on("touchmove", function(event) {
				event.preventDefault();
			});

			$(".newdateback").on("touchmove", function(event) {
				event.preventDefault();
			});

			//自动选中
			loadBind();

			$(".check-select-date").off().on("tap", function() {
				if($(".check-select-date.day-active").length == 2) {
					$(".box-color").html("");
					$(".check-select-date.day-active").removeClass("das-no");
					$(".check-select-date.day-active").removeClass("day-active");
					$(".check-select-date.dayg-active").removeClass("dayg-active");
					$(".check-select-date.day-active-start").removeClass("day-active-start");
					$(".check-select-date.day-active-end").removeClass("day-active-end");
				}
				$(this).addClass("day-active");

				if($(".check-select-date.day-active").length == 2) {
					var items = $(".check-select-date.day-active");
					var startItem = $(items[0]);
					startItem.addClass("day-active-start");
					if(startItem.find(".day-ac").hasClass("day-right")) {
						startItem.addClass("das-no");
					}

					startItem.find(".box-color").html("出发");
					var endItem = $(items[1]);
					endItem.addClass("day-active-end");
					if(endItem.find(".day-ac").hasClass("day-left")) {
						endItem.addClass("das-no");
					}
					endItem.find(".box-color").html("返回");
					startItem.nextUntil(".day-active").addClass("dayg-active");
					endItem.prevUntil(".day-active").addClass("dayg-active");

					var startdate = startItem.attr("data-fulldate");
					var enddate = endItem.attr("data-fulldate");
					var iday = app.DateTool.datedifference(startdate, enddate);

					var nea = new Array();
					nea.push(startdate);
					nea.push(enddate);
					nowDateList = nea;
					if(changeCallback && typeof(changeCallback) == "function") {
						changeCallback(nea);
					}

					$(".newdateback").hide();
					$(".datecalendar").slideToggle(200);
				}
			});
		}

		function loadBind() {
			var items = $(".check-select-date.day-active");

			var startItem = $(items[0]);
			startItem.addClass("day-active-start");
			if(startItem.find(".day-ac").hasClass("day-right")) {
				startItem.addClass("das-no");
			}

			startItem.find(".box-color").html("出发");
			var endItem = $(items[1]);
			endItem.addClass("day-active-end");
			if(endItem.find(".day-ac").hasClass("day-left")) {
				endItem.addClass("das-no");
			}
			endItem.find(".box-color").html("返回");
			startItem.nextUntil(".day-active").addClass("dayg-active");
			endItem.prevUntil(".day-active").addClass("dayg-active");
		}

		function loadDates(mydate, dates) {
			var startdate = '',
				enddate = '';

			if(!!dates && dates.length == 2 && !!dates[0]) {
				if(dates.length == 1 && dates[0].length > 0) {
					startdate = dates[0];
				} else if(dates.length > 1) {
					startdate = dates[0];
					enddate = dates[dates.length - 1];
				}

				var newstart = new Date(startdate.replace(/-/g, "/"));
				var newyears = newstart.getFullYear();
				var newmonth = newstart.getMonth() + 1;
				var newday = newstart.getDate();
				//当天日期
				var year = mydate.getFullYear();
				var month = mydate.getMonth() + 1;
				var day = mydate.getDate();
				var todayDate = new Date((year + "-" + month + "-" + day).replace(/-/g, "/"));

				if(newstart < todayDate || (newstart == todayDate && mydate.getHours() >= 18)) {
					var startStr = app.DateTool.DateAdd("d", 0, mydate);
					//					}
					var year2 = app.DateTool.DatePart('y', startStr);
					var month2 = app.DateTool.DatePart('m', startStr);
					var day2 = app.DateTool.DatePart('d', startStr);
					startdate = year2 + "-" + month2 + "-" + day2;
				}

				var newstartdate = new Date(startdate.replace(/-/g, "/"));
				var newstartyear = newstartdate.getFullYear();
				var newstartmonth = newstartdate.getMonth() + 1;
				var newstartday = newstartdate.getDate();

				var newend = new Date(enddate.replace(/-/g, "/"));
				var newendyears = newend.getFullYear();
				var newendmonth = newend.getMonth() + 1;
				var newendday = newend.getDate();

				if(newend <= newstartdate) {
					var endStr = app.DateTool.DateAdd("d", 5, mydate);
					var year = app.DateTool.DatePart('y', endStr);
					var month = app.DateTool.DatePart('m', endStr);
					var day = app.DateTool.DatePart('d', endStr);
					enddate = year + "-" + month + "-" + day;
				}
			} else {
				var startStr = app.DateTool.DateAdd("d", 0, mydate);
				var year = app.DateTool.DatePart('y', startStr);
				var month = app.DateTool.DatePart('m', startStr);
				var day = app.DateTool.DatePart('d', startStr);
				startdate = year + "-" + month + "-" + day;
				var endStr = app.DateTool.DateAdd("d", 5, mydate);
				year = app.DateTool.DatePart('y', endStr);
				month = app.DateTool.DatePart('m', endStr);
				day = app.DateTool.DatePart('d', endStr);
				enddate = year + "-" + month + "-" + day;
			}

			var nea = new Array();
			nea.push(startdate);
			nea.push(enddate);

			nowDateList = nea;

			if(changeCallback && typeof(changeCallback) == "function") {
				changeCallback(nea);
			}
		}

		return {
			initDate: initDate
		}
	})();
})(window, $);