(function (window, $) {
    window.CustomDate = (function () {
    	//默认加载多少月数据包括本
    	var defaultMonth=3;
    	var selectDate1;
    	var selectDate2;
    	var GroupType = 0;
    	var dateJson = {
    		nowYear:0,
    		nowMonth:0,
    		nowDay:0,
    		nowHours:0,
    		groupType:0,
    		dateList:[]
    	}
    	
		function initDate(dates,sysDate,Type,monthCount)
		{
			if(monthCount)
			{
				defaultMonth=monthCount;
			}
			
			//团房 14后预订
			GroupType = Type;
			//初始化dates数据
			loadDates(sysDate,dates);
			
			var now = new Date();
			if(sysDate)
				now = sysDate
			
			dateJson.groupType = GroupType;
			dateJson.nowYear = now.getFullYear();
			dateJson.nowDay = now.getDate();
			dateJson.nowHours = now.getHours();
			
			var newnow;
			if(dateJson.nowDay>28){
				newnow=app.DateTool.DateAdd("d",-5,now);
			}
			else{
				newnow=now;
			}
			dateJson.nowMonth = newnow.getMonth() +1;
			newnow=new Date(newnow)
			for (var i = 0; i < defaultMonth;i++) {
				if(i==0)
				newnow.setMonth(newnow.getMonth());
				else
				newnow.setMonth(newnow.getMonth()+1);
				var monthItem =  GetItems(newnow);
				dateJson.dateList.push(monthItem);
			}
			
			return dateJson;
		}
		
		function loadDates(mydate,dates){
			var startdate = '',
				enddate = '';
			if(!!dates && dates.length == 2 && !!dates[0]) {
				if(dates.length == 1 && dates[0].length > 0) {
					startdate = dates[0];
				} else if(dates.length > 1) {
					startdate = dates[0];
					enddate = dates[dates.length - 1];
				}
				
				var newstart = new Date(startdate.replace(/-/g, "/"));
				var newyears = newstart.getFullYear();
				var newmonth = newstart.getMonth() + 1;
				var newday = newstart.getDate();
				//当天日期
				var year = mydate.getFullYear();
				var month = mydate.getMonth()+1;
				var day = mydate.getDate();
				
				var todayDate = new Date((year+"-"+month+"-"+day).replace(/-/g, "/"));
				
				if(newstart.getTime() < todayDate.getTime()  || (newstart.getTime() == todayDate.getTime() && mydate.getHours() >= 14)){
					var startStr = app.DateTool.DateAdd("d", 0, mydate);
					if(GroupType == 2){
						if(mydate.getHours() >= 14){
							startStr = app.DateTool.DateAdd("d", 1, mydate);
						}
					}
					
					var year2 = app.DateTool.DatePart('y', startStr);
					var month2 = app.DateTool.DatePart('m', startStr);
					var day2 = app.DateTool.DatePart('d', startStr);
					startdate = year2 + "-" + month2 + "-" + day2;
				}
				
				var newstartdate = new Date(startdate.replace(/-/g, "/"));
				var newstartyear = newstartdate.getFullYear();
				var newstartmonth = newstartdate.getMonth() + 1;
				var newstartday = newstartdate.getDate();
				
				var newend = new Date(enddate.replace(/-/g, "/"));
				var newendyears = newend.getFullYear();
				var newendmonth = newend.getMonth() + 1;
				var newendday = newend.getDate();
				
				if(newend <= newstartdate){
					var endStr = app.DateTool.DateAdd("d", 1, mydate);
					if(GroupType == 2){
						if(mydate.getHours() >= 14){
							endStr = app.DateTool.DateAdd("d", 2, mydate);
						}
					}
					
					var year = app.DateTool.DatePart('y', endStr);
					var month = app.DateTool.DatePart('m', endStr);
					var day = app.DateTool.DatePart('d', endStr);
					enddate = year + "-" + month + "-" + day;
				}
			} else {
				var year = app.DateTool.DatePart('y', startStr);
				var month = app.DateTool.DatePart('m', startStr);
				var day = app.DateTool.DatePart('d', startStr);
				startdate = year + "-" + month + "-" + day;
				endStr = app.DateTool.DateAdd("d", 1, mydate);
				year = app.DateTool.DatePart('y', endStr);
				month = app.DateTool.DatePart('m', endStr);
				day = app.DateTool.DatePart('d', endStr);
				enddate = year + "-" + month + "-" + day;
			}
			
			selectDate1 = new Date(startdate.replace(/-/g, "/"));
			selectDate2 = new Date(enddate.replace(/-/g, "/"));
			
		}
		
		function GetItems(date)
		{
			var dateListItem = {
	    		year:0,
	    		month:0,
	    		days:[]
	    	}
			
			dateListItem.year = date.getFullYear();
			dateListItem.month = date.getMonth()+1;
			
			//填充空数
			var firstDayOfWeek = getFirstDayOfWeek(dateListItem.year,dateListItem.month);
			if(firstDayOfWeek > 0)
			{
				for (var i = 0; i < firstDayOfWeek; i++) {
					var dayItem = {
		    			fulldate:"",
		    			day:0,
		    			week:"",
		    			isSelect:false
		    		}
			        dateListItem.days.push(dayItem);
			    }
			}
			
			//遍历该月数据
			const thisMonthDays = getThisMonthDays(date.getFullYear(),date.getMonth()+1);
			for (var i = 1; i <= thisMonthDays; i++) {
				var dayItem = {
		    			fulldate:"",
		    			day:0,
		    			week:"",
		    			isSelect:false
		    		}
				var ndate = new Date(date.getFullYear(),date.getMonth(),i);
				var sday;
				if(i<10)
				{
					sday = "0"+i;
				}else{
					sday = i;
				}
				
				var nmonth = date.getMonth()+1;
				var nmstr;
				if(nmonth < 10){
					nmstr = "0"+nmonth;
				}else{
					nmstr = nmonth;
				}
				
				dayItem.fulldate = date.getFullYear()+"-"+ nmstr +"-"+sday;
				dayItem.day = i;
				
				dayItem.week = GetWeekStr(ndate.getDay());
				if(date.getFullYear() == selectDate1.getFullYear() && date.getMonth() == selectDate1.getMonth() && i == selectDate1.getDate())
				{
					dayItem.isSelect = true;
				}
				
				if(date.getFullYear() == selectDate2.getFullYear() && date.getMonth() == selectDate2.getMonth() && i == selectDate2.getDate())
				{
					dayItem.isSelect = true;
				}
				
		        dateListItem.days.push(dayItem);
		    }
			
			return dateListItem;
		}
		
		function GetWeekStr(n)
		{
			var str = "";
			switch(n)
			{
				case 0:
					str = "周日";
				    break;
				case 1:
					str = "周一";
				    break;
				case 2:
					str = "周二";
				    break;
				case 3:
					str = "周三";
				    break;
				case 4:
					str = "周四";
				    break;
				case 5:
					str = "周五";
				    break;
				case 6:
					str = "周六";
				    break;
				default:
			}
			return str;
		}
		
		function getThisMonthDays(year, month) {
		    return new Date(year, month, 0).getDate();
		  
		}
		
		function getFirstDayOfWeek(year, month) {
			return new Date(Date.UTC(year, month - 1, 1)).getDay();
		}
		
        return {
            initDate: initDate,
            GetWeekStr:GetWeekStr,
            defaultMonth:defaultMonth
        }
    })();
})(window,$);