﻿(function (window, $) {
    var qipanUtils = (function () {
        // 浮点数加法 a + b
        function accAdd(a, b) {
            var c, d, e;
            try {
                c = a.toString().split(".")[1].length;
            } catch (f) {
                c = 0;
            }
            try {
                d = b.toString().split(".")[1].length;
            } catch (f) {
                d = 0;
            }
            return e = Math.pow(10, Math.max(c, d)), (accMul(a, e) + accMul(b, e)) / e;
        }

        // 浮点数减法 a - b
        function accSub(a, b) {
            var c, d, e;
            try {
                c = a.toString().split(".")[1].length;
            } catch (f) {
                c = 0;
            }
            try {
                d = b.toString().split(".")[1].length;
            } catch (f) {
                d = 0;
            }
            return e = Math.pow(10, Math.max(c, d)), (accMul(a, e) - accMul(b, e)) / e;
        }

        // 浮点数乘法 a * b
        function accMul(a, b) {
            var c = 0,
                d = a.toString(),
                e = b.toString();
            try {
                c += d.split(".")[1].length;
            } catch (f) {
            }
            try {
                c += e.split(".")[1].length;
            } catch (f) {
            }
            return Number(d.replace(".", "")) * Number(e.replace(".", "")) / Math.pow(10, c);
        }

        // 浮点数除法 a / b
        function accDiv(a, b) {
            var c, d, e = 0,
                f = 0;
            try {
                e = a.toString().split(".")[1].length;
            } catch (g) {
            }
            try {
                f = b.toString().split(".")[1].length;
            } catch (g) {
            }
            return c = Number(a.toString().replace(".", "")), d = Number(b.toString().replace(".", "")), accMul(c / d, Math.pow(10, f - e));
        }

        return {
            accAdd: accAdd,
            accSub: accSub,
            accMul: accMul,
            accDiv: accDiv
        }
   
    })();


    window.sikeCart = (function () {
        var cartName = '_sike_cart_data_';

        // 设置购物车数据
        //  {id:'',rooms:[],products:[]}
        function _setCartData(data) {
            if (typeof data == 'string') {
                data = $.parseJSON(data);
            }
            data.lastTime = (new Date());
            window.localStorage.setItem(cartName, JSON.stringify(data));
        }

        // 获取购物车数据
        function _getCartData() {
            if (!!window.localStorage.getItem(cartName)) {
                return $.parseJSON(window.localStorage.getItem(cartName));
            }
            return false;
        }

        // 此处刷新购物车。
        // 根据价格变动  和 id是否存在来改变数据
        function _refreshProducts(data, products) {
            var result = [];
            var roomsData = data.rooms;
            $.each(products, function (n, product) {
                var Id = product.code;
                $.each(roomsData, function (i, rooms) {
                    $.each(rooms.policies, function (j, policies) {
                        var isDel = true;
                        if (policies.IsShow == 1 && policies.IsCanBook == 1) {
                            isDel = false;
                        }
                        $.each(policies.BreakList, function (k, BreakList) {
                            //判断对不对应商品
                            if (Id == BreakList.Id && BreakList.MinCount == product.minNum && BreakList.MaxCount == product.maxNum) {
                                if (!isDel && product.type == BreakList.Name && BreakList.RoomCountType == product.roomCountType && BreakList.Price[1] == product.price) {
                                    result.push(product);
                                }
                            }
                        });
                    });
                });
            });
            return result;
        };

        function saveRoomsData(id, data,date) {
            var d = {
                id: id,
                rooms: data,
                date: date,
                products: []
            };
            var _d = _getCartData();
            if (!!_d && _d.id == id) {
                d.products = _refreshProducts(d, _d.products);
            } else {
                destoryCart();
            }
            d.date = date;
            _setCartData(d);
        }

        function getRoomData(id) {
            var roomsData = _getCartData().rooms;
            var result = null;
            $.each(roomsData, function (i, rooms) {
                if (rooms.Id == id) result = rooms;
            });
            return result;
        }

        function _getDataByElId(Id,_num) {
            var _result = [];
            var roomsData = _getCartData().rooms;
            var result;
            var code = _getBreakListCode(Id);
            $.each(roomsData, function (i, rooms) {
                $.each(rooms.policies, function (j, policies) {
                    $.each(policies.BreakList, function (k, BreakList) {
                    	var bcode = rooms.Id+"_"+BreakList.Type;
                        if (bcode == code) {
                            _result.push({
                                code: BreakList.Id,
                                moneyIcon: BreakList.Price[0],
                                price: BreakList.Price[1],
                                leavePrice: BreakList.LeavePrice[1],
                                BasicPrice: !!BreakList.BasicPrice ? BreakList.BasicPrice[1]:0,
                                desc: rooms.Desc,
                                name: rooms.Name,
                                policiesName:policies.Name,
                                tips: BreakList.Tips,
                                type: BreakList.Name,
                                pic: rooms.ImageSrc,
                                minNum: BreakList.MinCount,
                                ELTypeId: BreakList.ELTypeId,
                                maxNum: BreakList.MaxCount || null,
                                bookMax: (BreakList.Amount == 0) ? BreakList.MaxCount : BreakList.Amount,
                                roomCountType: policies.RoomCountType
                            });
                        }
                    });
                });
            });
            $.each(_result, function (i, item) { // 未处理上限房间数量
                if (_num <= item.maxNum && _num >= item.minNum) {
                    result = item;
                }
            })

            return result;
        }
		
		/**
		 * 做特殊处理
		 * @param {Object} Id
		 */
		function _getBreakListCode(Id){
			var _result = [];
            var roomsData = _getCartData().rooms;
            var result;
            $.each(roomsData, function (i, rooms) {
                $.each(rooms.policies, function (j, policies) {
                    $.each(policies.BreakList, function (k, BreakList) {
                        if (Id == BreakList.Id) {
                            _result.push({
                                code: rooms.Id+"_"+BreakList.Type
                            });
                        }
                    });
                });
            });
            
            $.each(_result, function (i, item) { // 未处理上限房间数量
                    result = item.code;
            })
            return result;
		}
		
        // 保存商品
        // 默认一次只能保存一个商品，商品个数不限
        // {{json}} data {
        //    code: 唯一编号
        //    num: 个数
        //    price: 单价
        //    leavePrice: 节省金额
        //    name: 名称信息
        //    maxNum: 商品允许的最大个数

        //    attr:商品属性  [{name:'颜色'，value:'白色'}]

        //    pic: 商品图片路径
        //    desc: 详细描述
        //    sumPrice: 房型总价格
        //    isBuy: 购物车中是否勾选购买
        // }
        function save(elid,num) {
            var data = _getDataByElId(elid,num);
            if (!data) {
                return false;
            }
            var _d = _getCartData();
            var prodNum = num || 1; // 加入购物车的商品数量，默认为 1 件
            // 如果购物车中存在数据
            if (!!_d.products) {
                // 如果购物车中已存在要添加的商品  更新需要改变的字段 累加数量
                if (_isHaveProduct(data.code)) {
                    _d.total = parseInt(_d.total) + parseInt(prodNum);
                    _d.totalPrice = qipanUtils.accAdd(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(prodNum), parseFloat(data.price)));
                    $.each(_d.products, function (i, product) {
                        if (product.code == data.code) {
                            //if (parseInt(_d.products[i].num) + parseInt(prodNum) > _d.products[i].bookMax) return;
                            _d.products[i].num = parseInt(_d.products[i].num) + parseInt(prodNum);
                            _d.products[i].sumPrice = qipanUtils.accMul(parseFloat(_d.products[i].num), parseFloat(_d.products[i].price));
                            _d.products[i].price = data.price;
                            _d.products[i].leavePrice = data.leavePrice;
                            _d.products[i].type = data.type;
                            _d.products[i].roomCountType = data.roomCountType;
                            _d.products[i].minNum = data.minNum;
                            _d.products[i].maxNum = data.maxNum;
                            _d.products[i].bookMax = data.bookMax;
                            _d.products[i].desc = data.desc;
                            _d.products[i].moneyIcon = data.moneyIcon;
                        }
                    });
                } else { // 如果购物车中不存在要添加的商品
                    _d.total = parseInt(_d.total) + parseInt(prodNum);
                    _d.totalPrice = qipanUtils.accAdd(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(prodNum), parseFloat(data.price)));
                    _d.products.push({
                        code: data.code,
                        num: prodNum,
                        moneyIcon:data.moneyIcon,
                        price: data.price,
                        leavePrice: data.leavePrice || 0,
                        desc:data.desc,
                        name: data.name,
                        type: data.type,
                        roomCountType:data.roomCountType,
                        pic: data.pic,
                        ELTypeId:data.ELTypeId,
                        attr: data.attr || null,
                        minNum:data.minNum,
                        maxNum: data.maxNum || null,//商品可购买的最大数量
                        bookMax:data.bookMax,
                        sumPrice: qipanUtils.accMul(parseFloat(prodNum), parseFloat(data.price)),
                        isBuy: true // 默认添加购物车即为勾选购买状态
                    });
                }
                //_d.lastTime = (new Date());
                _setCartData(_d);
            } else {
                // 如果购物车为空，则直接向购物车添加数据
                _d.products.push({
                    total: prodNum, // 购物车物品总数量
                    totalPrice: qipanUtils.accMul(parseFloat(prodNum), parseFloat(data.price)), // 购物车内商品总价格
                    products: [ // 商品集合
                        {
                            code: data.code,  // 商品编号
                            num: prodNum,    // 商品个数
                            moneyIcon:data.moneyIcon,
                            price: data.price,  // 商品单价
                            leavePrice: data.leavePrice || 0,
                            name: data.name,    // 商品名字
                            type: data.type || '',
                            roomCountType: data.roomCountType||'',
                            desc: data.desc,    // 商品描述
                            pic: data.pic,    // 商品图片路径
                            ELTypeId:data.ELTypeId,
                            attr: data.attr || null,
                            minNum: data.minNum,
                            maxNum: data.maxNum || null,//商品可购买的最大数量
                            bookMax:data.bookMax,
                            sumPrice: qipanUtils.accMul(parseFloat(prodNum), parseFloat(data.price)),  // 商品总价格
                            isBuy: true // 购物车中是否勾选购买
                        }
                    ]
                });

                _setCartData(_d);
            }
        }

        // 根据商品编号查询购物车中是否已经存在该商品
        // {{string}} code 商品编号
        function _isHaveProduct(code) {
            var _d = _getCartData();
            // 如果不存在购物车，或者购物车中没有商品集合，则返回false
            if (!_d || !_d.products) {
                return false;
            }

            var result = false;
            // 查找是否存在指定编号的商品
            $.each(_d.products, function (i, product) {
                if (product.code == code) {
                    result = true;
                }
            });
            return result;
        }

        // 删除一个商品
        // {{string}} code 商品编号
        function del(code) {
            if (_isHaveProduct(code)) {
                var _d = _getCartData();
                // 如果购物车中商品类型超过1种
                // 则删除指定类型商品
                // 否则清空购物车
                if (_d.products.length > 1) {
                    $.each(_d.products, function (i, product) {
                        if (!!product && (product.code == code)) {
                            _d.total = parseInt(_d.total) - parseInt(product.num);
                            _d.totalPrice = qipanUtils.accSub(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(product.num), parseFloat(product.price)));
                            _d.products.splice(i, 1);
                        }
                    });
                    _setCartData(_d);
                } else {
                    clearCart();
                }
            } else {
                return false;
            }
        }

        // 删除已经购买的商品数据
        function delAllBuy() {
            var _d = _getCartData();
            if (!_d || !_d.products) {
                return;
            }
            var noBuyProducts = []; // 未购买的商品
            _d.total = 0;
            _d.totalPrice = 0;
            $.each(_d.products, function (i, product) {
                if (!!product && !product.isBuy) {
                    _d.total = parseInt(_d.total) + parseInt(product.num);
                    _d.totalPrice = qipanUtils.accAdd(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(product.num), parseFloat(product.price)));
                    noBuyProducts.push(product);
                }
            });
            _d.products = noBuyProducts;
            _setCartData(_d);
            try{
                window.setCartRoomNum(0);
            }catch(e){}
        }

        // 给一个指定商品数量减1
        function decrease(code) {
            if (_isHaveProduct(code)) {
                var _d = _getCartData();
                // 如果购物车中有多个商品分类
                // 则找到指定商品分类，进行数量减操作
                if (_d.products.length > 1) {
                    $.each(_d.products, function (i, product) {
                        if (product.code == code) {
                            if (parseInt(product.num) > 1) {
                                _d.total = parseInt(_d.total) - 1;
                                _d.totalPrice = qipanUtils.accSub(parseFloat(_d.totalPrice), qipanUtils.accMul(1, parseFloat(product.price)));
                                _d.products[i].num = parseInt(_d.products[i].num) - 1;
                                _d.products[i].sumPrice = qipanUtils.accMul(parseFloat(_d.products[i].num), parseFloat(_d.products[i].price));
                            } else {
                                _d.total = parseInt(_d.total) - 1;
                                _d.totalPrice = qipanUtils.accSub(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(product.num), parseFloat(product.price)));
                                _d.products.splice(i, 1);
                            }
                        }
                    });
                    _setCartData(_d);
                } else {
                    // 如果购物车中只有一个商品分类
                    if (_d.products[0].num > 1) {
                        _d.total = parseInt(_d.total) - 1;
                        _d.totalPrice = qipanUtils.accSub(parseFloat(_d.totalPrice), qipanUtils.accMul(1, parseFloat(_d.products[0].price)));
                        _d.products[0].num = parseInt(_d.products[0].num) - 1;
                        _d.products[0].sumPrice = qipanUtils.accMul(parseFloat(_d.products[0].num), parseFloat(_d.products[0].price));
                        _setCartData(_d);
                    } else {
                        clearCart();
                    }
                }
            } else {
                return false;
            }
        }

        // 给一个指定商品数量加1
        function increase(code) {
            var _d = _getCartData();
            if (parseInt(_d.total) + 1 > _d.maxNum) return;
            _d.total = parseInt(_d.total) + 1;
            $.each(_d.products, function (i, product) {
                if (product.code == code) {
                    _d.products[i].num = parseInt(product.num) + 1;
                    _d.products[i].sumPrice = qipanUtils.accMul(parseFloat(product.num), parseFloat(product.price));
                    _d.totalPrice = qipanUtils.accAdd(parseFloat(_d.totalPrice), qipanUtils.accMul(parseFloat(1), parseFloat(product.price)));
                }
            });
            _setCartData(_d);
        }

        // 获取所有商品
        function setProducts(data) {
            if (!data)
                return;
            var cartData = {};
            cartData.total = 0;
            cartData.totalPrice = 0;
            cartData.products = data;
            $.each(data, function (i, product) {
                cartData.total += product.num;
                cartData.totalPrice = qipanUtils.accAdd(cartData.totalPrice, qipanUtils.accMul(product.num, product.price));
                cartData.products[i].sumPrice = qipanUtils.accMul(product.num, product.price);
                cartData.products[i].isBuy = true;
            });
            _setCartData(cartData);
        }

        // 获取所有商品
        function getProducts() {
            var d = _getCartData();
            if (!!d && !!d.products) {
                return d;
            } else {
                return null;
            }
        }

        // 获取商品分类
        function getProductsCategory() {
            var d = _getCartData();
            if (!!d && !!d.products) {
                return d.products.length;
            } else {
                return 0;
            }
        }

        // 获取购物车中所有商品总数量
        function getProductsNum() {
            var d = _getCartData();
            if (!!d && !!d.products) {
                return d.total;
            } else {
                return 0;
            }
        }

        // 获取购物车中所有商品总价格
        function getTotalPrice() {
            var d = _getCartData();
            if (!!d && !!d.products) {
                return d.totalPrice;
            } else {
                return '0.00';
            }
        }

        // 获取指定商品号的商品数量
        function getProductNumByPrd(prd) {
            return parseInt(prd.num || 0);
        }

        function getProductNum(code) {
            return getProduct(code).num || 0;
        }

        // 获取当前产品
        function getProduct(code) {
            var _d = _getCartData();
            var thisProduct = {};
            if (!_d && !_d.products) {
                return;
            }
            $.each(_d.products, function (i, product) {
                if (product.code == code) {
                    thisProduct = product;
                }
            });
            return thisProduct;
        }

        // 获取当前产品价格
        function getPriceByPrd(prd) {
            return parseFloat(prd.price || 0);
        }

        function getPrice(code) {
            return getProduct(code).price || 0;
        }

        //获取当前产品最大购买数量
        function getMaxNum(code) {
            return getProduct(code).maxNum || 0;
        }

        // 获取当前产品名称
        function getNameByPrd(prd) {
            return prd.name || '';
        }

        function getName(code) {
            return getProduct(code).name || '';
        }

        // 获取所有可以购买的商品数据
        function getAllBuy() {
            var _d = _getCartData();
            var allBuy = [];
            if (!!_d && !!_d.products) {
                $.each(_d.products, function (i, product) {
                    if (!!product.isBuy) {
                        allBuy.push(product);
                    }
                });
            }
            return allBuy;
        }

        function getAllBuyPrice() {
            var _d = _getCartData();
            var d = getAllBuy();
            var result = 0;
            if (!!d && d.length > 0) {
                $.each(d, function (i, item) {
                    result = qipanUtils.accAdd(result,qipanUtils.accMul(item.num, $.isArray(item.price)?item.price[1]:item.price));
                });
            }
            return result * _d.date.count;
        }
       function getAllBuyleavePrice() {
       	    var countDay = app.GetRoomListV2.GetRoomListV2Enity.cartDate.count;
            var _d = _getCartData();
            var d = getAllBuy();
            var result = 0;
            if (!!d && d.length > 0) {
                $.each(d, function (i, item) {
                    result = qipanUtils.accAdd(result,qipanUtils.accMul(item.num, $.isArray(item.leavePrice)?item.leavePrice[1]:item.leavePrice));
                });
            }
             return result * _d.date.count;
        }
        // 获取可以购买商品总个数
        function getAllBuyProdNumbs() {
            var allBuyProds = getAllBuy();
            var result = 0;
            for (var i = 0, len = allBuyProds.length; i < len; i++) {
                result += parseInt(allBuyProds[i].num);
            }
            return result;
        }

        // 获取付款金额
        function getPayFee() {
            var allBuyProds = getAllBuy();
            var payFee = 0;
            for (var i = 0, len = allBuyProds.length; i < len; i++) {
                payFee = qipanUtils.accAdd(payFee, qipanUtils.accMul(allBuyProds[i].price, allBuyProds[i].num));
            }
            return payFee;
        }

        // 设置当前产品是否可以购买
        function setBuy(code, isBuy) {
            var _d = _getCartData();
            if (!_d && !_d.products) {
                return;
            }
            $.each(_d.products, function (i, product) {
                if (product.code == code) {
                    _d.products[i].isBuy = isBuy;
                }
            });
            _setCartData(_d);
        }

        // 设置所有商品在购买状态
        function setAllBuy(isBuy) {
            var _d = _getCartData();
            if (!_d && !_d.products) {
                return;
            }
            for (var i = 0, len = _d.products.length; i < len; i++) {
                _d.products[i].isBuy = isBuy;
            }
            _setCartData(_d);
        }

        // 判断商品是否选中购买
        function isBuy() {
            var _d = _getCartData();
            var isBuy = false;
            if (!_d && !_d.products) {
                return;
            }
            if (_d.products.length > 0) {
                for (var i = 0, len = _d.products.length; i < len; i++) {
                    if (_d.products[i].isBuy) {
                        isBuy = true;
                    }
                }
            }
            return isBuy;
        }

        // 获取购物车最近一次操作时间
        function getLastTime() {
            var _d = _getCartData();
            if (!_d) {
                return;
            }
            if (!!_d.lastTime) {
                return _d.lastTime;
            }
            return null;
        }

        // 购物车是否过期  判断规则，离上次最近操作时间间隔超过30min
        // 过期返回真，否则返回假
        function isOverdue() {
            var overdue = 30 * 60 * 1000;
            //var overdue = 3000;
            var nowDate = (new Date()).getTime();
            var gDate = getLastTime();
            if (!!gDate) {
                if (Math.abs((nowDate - (new Date(gDate)).getTime())) > overdue) {
                    return true;
                }
            }
            return false;
        }

        // 清空购物车
        function clearCart() {
            var _d = _getCartData();
            _d.products = [];
            _setCartData(_d);
        }

        // 销毁购物车
        function destoryCart() {
            window.localStorage.removeItem(cartName);
        }

        function getBookDate() {
            return _getCartData().date || null;
        }

        function getHotelId() {
            return _getCartData().id || null;
        }

        return {
            saveRoomsData: saveRoomsData, // 保存房间原始数据和房间id
            getRoomData: getRoomData,
            getBookDate: getBookDate,
            getHotelId:getHotelId,
            getDataByIdAndNum:_getDataByElId,
            isHaveProduct: _isHaveProduct,
            save: save,
            del: del,
            decrease: decrease,
            increase: increase,
            clearCart: clearCart,
            setProducts: setProducts,
            getProducts: getProducts,
            getProduct: getProduct,
            getProductsCategory: getProductsCategory,
            getProductsNum: getProductsNum,
            getProductNumByPrd: getProductNumByPrd,
            getProductNum: getProductNum,
            getPriceByPrd: getPriceByPrd,
            getPrice: getPrice,
            getNameByPrd: getNameByPrd,
            getName: getName,
            getTotalPrice: getTotalPrice,
            setBuy: setBuy,
            setAllBuy: setAllBuy,
            getAllBuy: getAllBuy,
            getAllBuyPrice:getAllBuyPrice,
            getAllBuyProdNumbs: getAllBuyProdNumbs,
            getPayFee: getPayFee,
            delAllBuy: delAllBuy,
            isBuy: isBuy,
            isOverdue: isOverdue,
            getMaxNum: getMaxNum,
            getAllBuyleavePrice:getAllBuyleavePrice,
        }
    })();


})(window,$);