(function(window, $) {
	window.SchemeDetail = (function() {

		var scroll = null;

		var Req = {
			url: "Scheme/GetSchemeDemandDetail",
			data: {
				SerialNo: 0
			}
		}

		/**
		 * 首页 plusReady 初始化
		 * @example
		 * @constructor
		 */
		function plusReady() {
			//判读是否是 沉浸式如果不是设置头部背景样式 针对IOS
			var bi = plus.navigator.isImmersedStatusbar();
			if(!bi) {
				app.StatusBarBackground("#13b1fe");
			}

			var wv = plus.webview.currentWebview();
			if(!!wv) {
				if(!!wv.SerialNo) {
					Req.data.SerialNo = wv.SerialNo;
				}
				//				Req.data.SerialNo = 170316116686;
			}

			init();
		}

		/**
		 * 初始化
		 * @example
		 * @constructor
		 */
		function init() {
			//初始化js模板格式化
			template.helper("_PersonsFormat", _PersonsFormat);

			_init();

			scroll = mui("#plan-contentScroll").scroll();
			document.querySelector('.mui-scroll-wrapper').addEventListener('scroll', function(e) {　　
				var y = scroll.y;
				var showHeight = 0;
				if(y < showHeight) {
					$("#float-move").fadeIn(200);
				} else {
					$("#float-move").fadeOut(200);
				}
			})
		}

		function _init() {
			app.Loading($("#scheme-detail"), "50%", "show");
			var callback = function(data) {
				if(app.GetResultState(data)) {
					var html = template("index-scheme-detail-template", data);
					$("#scheme-detail").html(html);
					initEvent();
				} else {
					app.renderNoResult(data.Msg, "", "", null, $("#scheme-detail"));
				}
			}
			app.Post(Req, null, callback);
		}

		function initEvent() {
			$("#float-move").off().on("tap", function() {
				mui('#plan-contentScroll').scroll().scrollTo(0, 0, 200);
			});
		}

		function initHeaderScroll($header, $photo) {
			var showHeight = 0;
			var count = 0,
				timer = null;
			var oldTop = newTop = $(window).scrollTop(); //为了方便起见，使用jquery或者zepto框架
			function log() {
				if(timer) clearTimeout(timer);
				newTop = $(window).scrollTop();
				if(newTop === oldTop) {
					clearTimeout(timer);
					//已停止，写入业务代码
					if(oldTop > showHeight) {
						$header.show();
					} else {
						$header.hide();
					}
				} else {
					oldTop = newTop;
					timer = setTimeout(log, 100);
					if(oldTop > showHeight) {
						$header.show();
					} else {
						$header.hide();
					}
				}
			}
			$(window).on('touchmove', log);

		}

		/**
		 * template 格式化
		 */
		function _PersonsFormat(Persons) {
			var str = "";
			$.each(Persons, function(index, item) {
				if(str == "") {
					str += item.PersonCount + item.TypeName;
				} else {
					str += "," + item.PersonCount + item.TypeName;
				}
			})
			return str;
		}

		return {
			plusReady: plusReady,
			init: init
		}
	})();

})(window, $);