app.yyLogin = {
	id: {
		tab: 'login_tab',
		account: 'account_login',
		sms: 'sms_login',
		smsCode: 'getSmsCode',
		register: 'go_register',
		forgetpwd: 'go_forgetPwd',
		login: 'login_btn'

	},
	css: {
		form: 'login-form',
		curr: 'curr',
		close: 'close-trigger',
		after: 'icon-after'
	},
	init: function() {
		var self = app.yyLogin;
		self.initTab();
		self.initLogin();
		self.goRegister();
		self.goForgetPwd();
		self.initSendSms();
		self.initHideOrShowCloseBtn();
	},
	// 登录方式切换
	initTab: function() {
		var self = app.yyLogin;
		var $tab = app.$el(self.id.tab);
		var $forms = app.$el(self.css.form);

		$tab.off().on('tap', 'li', function() {
			var $this = $(this);
			var type = $this.attr('data-type');
			if(!$this.hasClass(self.css.curr)) {
				$this.addClass(self.css.curr).siblings().removeClass(self.css.curr);
				$forms.removeClass(self.css.curr);
				app.$el('login-type-' + type).addClass(self.css.curr);
			}
		})

	},
	// 显示 隐藏 快速删除输入框中内容的按钮
	initHideOrShowCloseBtn: function() {
		var self = app.yyLogin;
		var _hide = function(scope, type) {
			if(scope && type) {
				$(scope).parent().find('.' + self.css.after)[type]();
			} else {
				app.$el(self.css.after).hide();
			}
		};
		app.$el(self.css.close).off().on('input', function() {
			if($(this).val().length == 0) {
				_hide(this, 'hide');
			} else {
				_hide(this, 'show');
			}
		});
		app.$el(self.css.after).off().on('tap', function() {
			var $this = $(this);
			$this.parent().find('.' + self.css.close).val('');
			$this.hide();
		});
	},
	// 发送验证码的事件
	initSendSms: function() {
		var self = app.yyLogin;
		var $getSms = app.$el(self.id.smsCode);
		$getSms.off().on('tap', function() {
			var mobile = $(this).parent().find('.mobile');
			if(mobile.val().length <= 0) {
				plus.nativeUI.toast('请输入手机号!');
				return false;
			} else {
				if(!app.checkMobile(mobile.val())) {
					plus.nativeUI.toast('手机号格式不正确!');
					return false;
				}
			}
			app.sendSMSCode(mobile.val(), 1); //发送Ajax请求
			app.setSMSSendTime(self.id.smsCode); //实现读秒的效果
		});
	},
	// 登录的事件
	initLogin: function() {
		var self = app.yyLogin;
		app.$el(self.id.login).off().on('tap', yyFramework.debounce(function() {
			var type = app.$el(self.id.tab).find('.' + self.css.curr).attr('data-type') + '';
			var $form = app.$el('login-type-' + type);
			switch(type) {
				case '1': // 短信登录
					self.smsLogin($form);
					break;
				case '2': // 账号登录
					self.accountLogin($form);
					break;
				default:
					break;

			}
		},600));
	},
	// 帐户登录
	accountLogin: function($form) {
		var $phone = $form.find('input[name="phone"]');
		var $pwd = $form.find('input[name="password"]');
		var phone = $phone.val() + '',
			pwd = $pwd.val() + '';
		if(phone.length <= 0) {
			plus.nativeUI.toast('请输入登录帐号!');
			return false;
		}
		if(!app.checkMobile(phone)) {
			plus.nativeUI.toast('手机号格式不正确!');
			return false;
		}
		if(pwd.length < 6 || pwd.length > 16) {
			plus.nativeUI.toast('密码长度为6-16位!');
			return false;
		}
		var data = {
			url: projectConfig.apiName.Login,
			data: {
				phone: phone,
				type: 2,
				password: pwd,
				code: ""
			} 
		};
		app.Post(data, {
			$mobile:$phone
		}, app.yyLogin.loginCallback);
	},
	// 短信登录
	smsLogin: function($form) {
		var $phone = $form.find('input[name="phone"]');
		var $code = $form.find('input[name="code"]');
		var phone = $phone.val() + '',
			code = $code.val() + '';
		if(phone.length <= 0) {
			plus.nativeUI.toast('请输入登录帐号!');
			return false;
		}
		if(!app.checkMobile(phone)) {
			plus.nativeUI.toast('手机号格式不正确!');
			return false;
		}
		if(code.length != 4) {
			plus.nativeUI.toast('短信验证码必须为四位数字!');
			return false;
		} else {
			if(!app.checkNum(code)) {
				plus.nativeUI.toast('短信验证码错误!');
				return false;
			}
		}
		app.InitRequestParam();
		app.RequestParam.phone = phone;
		app.RequestParam.type = 1;
		app.RequestParam.code = code;
		var data = {
			url: projectConfig.apiName.Login,
			data: {
				phone: phone,
				type: 1,
				password: "",
				code: code
			}
		};
		app.Post(data, {$mobile:$phone}, app.yyLogin.loginCallback);
	},
	loginCallback: function(data,opts) {
		if(data.Code == '0000') {
			var mobile = opts.$mobile;
			var settings = app.getSettings();
			settings.Token = data.Token;
			settings.MemberId = data.MemberId;
			settings.LoginType = data.LoginType;
			settings.phone = mobile.val();
			app.setSettings(settings);
			app.ToMain();
		} else {
			plus.nativeUI.toast(data.Msg);
		}	
	},
	goRegister: function() {
		var self = app.yyLogin;
		app.$el(self.id.register).off().on('tap', function() {
			app.OpenWindow(projectConfig.viewId.Customer.RegisterStep1.Id,
				projectConfig.viewId.Customer.RegisterStep1.url, 'slide-in-right');
		})
	},
	goForgetPwd: function() {
		var self = app.yyLogin;
		app.$el(self.id.forgetpwd).off().on('tap', function() {
			app.OpenWindow(projectConfig.viewId.Customer.forgetPwdStep1.Id, 
				projectConfig.viewId.Customer.forgetPwdStep1.url, 'slide-in-right');
		})
	}
}