app.yyRegisterStep2 = {
	init: function(mobile) {
		var self = app.yyRegisterStep2;
		self.render(mobile);
	},
	render: function(mobile) {
		var self = app.yyRegisterStep2;
		self.initMobile(mobile);
		self.initGetVcode();
		self.initSubRegister();
		self.initProvision();
	},
	initMobile: function(mobile) {
		var $pContent = $('.p_yy_registerStep2');
		var $mobile = $pContent.find('.title-box .mobile');
		$mobile.html(mobile);
	},
	initGetVcode: function() {
		var self = app.yyRegisterStep2;
		var $pContent = $('.p_yy_registerStep2');
		var $mobile = $pContent.find('.title-box .mobile');
		var $subCode = $pContent.find('.get-vCode');
		$subCode.on('tap', function() {
			var mobile = $mobile.text();
			//获取验证码
			app.sendSMSCode(mobile, 2); //发送Ajax请求
			app.setSMSSendTime("getSmsCode"); //实现读秒的效果
		});
	},
	initSubRegister: function() {
		var self = app.yyRegisterStep2;
		var $pContent = $('.p_yy_registerStep2');
		var $mobile = $pContent.find('.title-box .mobile');
		var $vcode = $pContent.find('.v-code input');
		var $userName = $pContent.find('.user-name input');
		var $companyName = $pContent.find('.company-name input');
		var $loginPwd = $pContent.find('.login-pwd input');
		var $loginPwdAgain = $pContent.find('.loginPwd-again input');
		var $invitationCode = $pContent.find('.Invitation-code input');
		var $subBtn = $pContent.find('.sub-btn a');
		var $provisionTip = $pContent.find('.provision-tip');

		$subBtn.off().on('tap', function() {
			if(!$mobile.text()) {
				plus.nativeUI.toast('您的电话号码有误，请退回重新输入');
				return false;
			};
			if(!$vcode.val()) {
				plus.nativeUI.toast('请输入验证码');
				return false;
			}
			if(!$userName.val()) {
				plus.nativeUI.toast('请输入姓名');
				return false;
			}
			if(!$userName.val().length>100) {
				plus.nativeUI.toast('姓名过长');
				return false;
			}
			if(!$companyName.val()) {
				plus.nativeUI.toast('请输入企业名称');
				return false;
			}
			if(!$companyName.val().length>100) {
				plus.nativeUI.toast('企业名称过长');
				return false;
			}
			if(!$loginPwd.val()) {
				plus.nativeUI.toast('请输入登录密码');
				return false;
			}
			if($loginPwd.val().length<6 || $loginPwd.val().length>16){
				plus.nativeUI.toast('密码长度为6-16位');
				return false;
			}
			if(!$loginPwdAgain.val()) {
				plus.nativeUI.toast('请再次输入登录密码');
				return false;
			}
			
			if($loginPwd.val() != $loginPwdAgain.val()) {
				plus.nativeUI.toast('您两次输入的密码不一致');
				return false;
			}
			if(!$provisionTip.hasClass('checked')) {
				plus.nativeUI.toast('请阅读并同意服务条款');
				return false;
			}
			//提交注册
			app.Post({
				url: projectConfig.apiName.HouseKeeperRegister,
				data: {
					"phone": $mobile.text(),
					"code": $vcode.val(),
					"CustomerName": $userName.val(),
					"CompanyName": $companyName.val(),
					"password": $loginPwd.val(),
					"passwordA": $loginPwdAgain.val(),
					"CompanyNature": '',
					"ExtensionCode": $invitationCode.val()
				}
			}, null, function(data) {
				console.log('data=>' + JSON.stringify(data));
				if(data.Code == '0000') {
					var settings = app.getSettings();
					settings.Token = data.Token;
					settings.MemberId = data.MemberId;
					settings.LoginType = data.LoginType;
					settings.phone = $mobile.text();
					app.setSettings(settings);
					app.ToMain();
				} else {
					plus.nativeUI.toast(data.Msg);
				}
			});

		});
	},
	initProvision: function() {
		var self = app.yyRegisterStep2;
		var $pContent = $('.p_yy_registerStep2');
		var $provisionDetail = $pContent.find('.provision-detail');
		var $provisionTip = $pContent.find('.provision-tip');
		var $toProvision = $pContent.find('.to-provision');
		var $closeProvision = $pContent.find('.close-provision');
		$toProvision.off().on('tap', function() {
			$provisionDetail.show();
			$closeProvision.show();
		});
		$closeProvision.off().on('tap', function() {
			$provisionDetail.hide();
			$closeProvision.hide();
		})
		$provisionTip.off().on('tap', function() {
			var $this = $(this);
			if($this.hasClass('checked')) {
				$this.removeClass('checked');
			} else {
				$this.addClass('checked');
			}
		})
	}
}