app.DemandCheckPrice = {
	data: {
		price: {
			minval: 0,
			maxval: 0,
			name: "",
			id: ""
		},
		StarRateList: {
			stars: [],
			showstar: ""
		}
	},
	ViewPriceId: "../Demand/DemandCheckPrice.html",
	PriceId: "price_",
	init: function() {
		var self = app.DemandCheckPrice;

		//加载列表数据
		self.loadList();

		//绑定事件left菜单显示
		$("#leftView li").off().on("tap", function() {
			$("#leftView li").removeClass("current");
			$(this).addClass("current");
			var val = $(this).attr("val");
			$("#rightView div").each(function() {
				if($(this).attr("val") == val) {
					$(this).show();
				} else {
					$(this).hide();
				}
			});
		});

		//绑定价格选中事件
		$("#priceList li").off().on("tap",  function() {
			var self = app.DemandCheckPrice;
			var id = self.data.price.id;
			var isSelect = self.GetSelectType(1, 1);
			var noSelect = self.GetSelectType(1, 0);

			var minval = $(this).attr("minval");
			var maxval = $(this).attr("maxval");
			var name = $(this).html().replace("<i></i>", "");

			$("#" + id).removeClass(isSelect).addClass(noSelect);
			$(this).removeClass(noSelect).addClass(isSelect);

			self.ShowIcon(1, minval, maxval);
			self.data.price.minval = minval;
			self.data.price.maxval = maxval;
			self.data.price.name = name;
			self.data.price.id = $(this).attr("id");

		});

		//绑定星级
		$("#starList li").off().on("tap", function() {
			var self = app.DemandCheckPrice;
			var $this = $(this);
			if($(this).hasClass("is-che")){
				$(this).removeClass("is-che");
				$(this).addClass("che-no");
			}else {
				if($(this).attr("val") == 0) {
					$("#starList li").removeClass("is-che");
					$("#starList li").addClass("che-no");
				}
				$(this).addClass("is-che");
				$(this).removeClass("che-no");
			}

			var lis = $("#starList li.is-che");
			var starDefault = app.model.StarId + "0";
			if(lis.length >= 2) {
				if($("#" + starDefault).hasClass("is-che")) {
					$("#" + starDefault).removeClass("is-che");
					$("#" + starDefault).addClass("che-no");
				}
			}

			if(lis.length == 0) {
				$("#" + starDefault).addClass("is-che");
				$("#" + starDefault).removeClass("che-no");
			}
			self.ShowIcon(2, 0, 0);

			var stars = new Array();
			var showstar = new Array();
			$("#starList li.is-che").each(function() {
				stars.push($(this).attr("val"));
				var name = $(this).html().replace("<i></i>", "");
				showstar.push(name);
			});

			self.data.StarRateList.showstar = showstar.join(",");
			self.data.StarRateList.stars = stars;
		});

		//确定事件绑定
		$("#btnSubmitPrice").off().on("tap", function() {
			var self = app.DemandCheckPrice;
			var currentViewSon = plus.webview.getWebviewById('Sub_HotelList.html');
			var price = self.data.price;
			var StarRateList = self.data.StarRateList;
			mui.fire(currentViewSon, 'setPrice', {
				price: price,
				StarRateList: StarRateList
			});
			var hotelviewId="../Demand/NewHotelList.html";
			var currentView = plus.webview.getWebviewById(hotelviewId);
			mui.fire(currentView, 'setPriceShow', {
				price: price,
				StarRateList: StarRateList
			});

			app.HideWebView(app.DemandCheckPrice.ViewPriceId);
		});
	},
	loadList: function() {
		var self = app.DemandCheckPrice;

		//加载列表数据
		var settings = app.getSettings();
		var searchCondition = settings.HotelSearchCondition;
		if(searchCondition.StarRateList.stars[0]==null)
		searchCondition.StarRateList.stars.shift();
		if(searchCondition.StarRateList.stars[0]!="0">1&&searchCondition.StarRateList.stars.length>0&&searchCondition.Prices.maxval==0){
			$("#leftView li").removeClass("current");
			$("#rightView div").hide();
			$("#star").addClass("current");
			$("#starList").show();
		}
		var Prices = {
			minval: 0,
			maxval: 0,
			name: "不限"
		}
		var StarRateList = {
			stars: [0],
			showstar: '不限'
		}

		if(!!searchCondition) {
			if(!searchCondition.Prices || searchCondition.Prices.length <= 0){
				searchCondition.Prices = Prices;
			}
			searchCondition.StarRateList.stars.remove(null);
			if(searchCondition.StarRateList.stars[0]==undefined){
				searchCondition.StarRateList.stars[0]=0;
			}
			if(!searchCondition.StarRateList || searchCondition.StarRateList.length <= 0){
				searchCondition.StarRateList = StarRateList;
			}
		} else {
			searchCondition = {
				Prices: Prices,
				StarRateList: StarRateList
			}
		}

		//加载价格
		var defaultminval = parseInt(searchCondition.Prices.minval);
		var defaultmaxval = parseInt(searchCondition.Prices.maxval);
		var defaultshowprice = searchCondition.Prices.name;

		self.data.price.minval = defaultminval;
		self.data.price.maxval = defaultmaxval;
		self.data.price.name = defaultshowprice;

		var priceTmp = '<li minval="{0}" maxval="{1}" class="{2}" id="{4}"><i></i>{3}</li>';
		var priceHtml = new Array();
		priceHtml.push("<ul>");
		var Prices = app.model.Prices || {};
		for(var i = 0; i < Prices.length; i++) {
			if(Prices[i].minval == defaultminval && Prices[i].maxval == defaultmaxval) {
				self.data.price.id = app.model.PriceId + Prices[i].sort;
			}
			priceHtml.push(app.format(priceTmp, Prices[i].minval, Prices[i].maxval, self.GetDefaultPrice(Prices[i], defaultminval, defaultmaxval), Prices[i].name, app.model.PriceId + Prices[i].sort));
		}
		priceHtml.push("</ul>");
		$("#priceList").html(priceHtml.join(""));
		self.ShowIcon(1, defaultminval, defaultmaxval);

		//加载星级
		var defaultstar = searchCondition.StarRateList.stars;
		var defaultshowstar = searchCondition.StarRateList.showstar;

		var starTmp = '<li val="{0}" class="{1}" id="{3}"><i></i>{2}</li>';
		var starHtml = new Array();
		starHtml.push("<ul>");
		var Stars = app.model.Stars || {};
		for(var i = 0; i < Stars.length; i++) {
			var id = app.model.StarId + Stars[i].sort;
			starHtml.push(app.format(starTmp, Stars[i].val, self.GetDefaultStar(Stars[i], defaultstar.join(",")), Stars[i].name, id));
		}
		starHtml.push("</ul>");
		$("#starList").html(starHtml.join(""));
		self.ShowIcon(2, 0, 0);

		self.data.StarRateList.showstar = defaultshowstar;
		self.data.StarRateList.stars = defaultstar;

	},
	ShowIcon: function(selectType, minval, maxval) {
		if(selectType == 1) {
			var htm = $("#price").html();
			if(minval == 0 && maxval == 0) {
				$("#price").html(htm.replace("<i></i>", ""));
			} else {
				if(htm.indexOf("<i></i>") < 0) {
					$("#price").html(htm + "<i></i>");
				}
			}
		} else {
			var htm = $("#star").html();
			var starDefault = app.model.StarId + "0";
			if($("#" + starDefault).hasClass("is-che")) {
				$("#star").html(htm.replace("<i></i>", ""));
			} else {
				if(htm.indexOf("<i></i>") < 0) {
					$("#star").html(htm + "<i></i>");
				}
			}
		}
	},
	GetDefaultPrice: function(price, defaultminval, defaultmaxval) {
		var self = app.DemandCheckPrice;

		if(price.minval == defaultminval && price.maxval == defaultmaxval) {
			return self.GetSelectType(1, 1);

		} else {
			return self.GetSelectType(1, 0);

		}
	},
	GetDefaultStar: function(star, defaultstar) {
		var self = app.DemandCheckPrice;
		if(defaultstar.indexOf(star.val) >= 0) {
			return self.GetSelectType(2, 1);
		} else {
			return self.GetSelectType(2, 0);
		}
	},
	GetSelectType: function(selectType, isSelect) {
		var css = "";
		if(selectType == 2 && isSelect == 1)
			css = "is-che";
		else if(selectType == 2 && isSelect == 0)
			css = "che-no";
		else if(selectType == 1 && isSelect == 0)
			css = "sel-no";
		else if(selectType == 1 && isSelect == 1)
			css = "is-sel";
		return css;
	}
}