(function(window, $){
	var isShowMore = false;
	var customPackage = app.getSettings().customPackage;
	window.DemandManyDest = {
		init:function(){
			var that = this;
			var wv = plus.webview.currentWebview();
			var Dest = wv.Dest;
			
			template.helper('checkExistId',checkExistId);
			
			this.initSearchHistory(Dest);
			this.initHotSearch();
			this.initHistory();
			if(plus.os.name.toLowerCase() == 'ios'){
				var headerHeight = $("#header").height();
				var btmHeight = $("#search-btm").height();
				var documentHeight = $(document).height();
				var diffHeight = documentHeight - btmHeight - headerHeight - 100;
				$("#search-key-result").css({
					'min-height':diffHeight,
					'height':'auto'
				});
				$("#searchKey").bind('focus',function(){
					//$(".null").css('height','2rem');
					$(".btm").css('position','relative');
					that.handleFixed();
				}).bind('blur',function(){
					$(".null").css('height','10rem');
					$(".btm").css('position','fixed');
				});
			}
			function checkExistId(id){
				var flag = false;
				customPackage.endPlace.forEach(function(v, i){
					if(v.Id == id){
						flag = true;
					}
				});
				return flag;
			}
			
			$("#submit-need").off().on('tap',function(){
				var settings = app.getSettings();
				settings.customPackage.endPlace = customPackage.endPlace;
				var res = that.addHistoryCache(customPackage.endPlace);
				settings.customPackage.searchHistory = res;
				app.setSettings(settings);
				var webViewChildren = plus.webview.currentWebview();
				var webViewParent = webViewChildren.opener();
				var isFromTravel = webViewChildren.isFromTravel;
				if(isFromTravel){
					//从行程需求那来的
					webViewParent.evalJS("window.travelDemand.callManyDest()");
				}else{
					//从首页来的
					webViewParent.evalJS("window.Trip.callManyDest()");
				}
				
				webViewChildren.close();
			});
			
			$("#action").off().on('tap',function(){
				var webViewChildren = plus.webview.currentWebview();
				var webViewParent = webViewChildren.opener();
				webViewChildren.close();
			});
			
			$(".search-result-container").on('touchmove',function(e){
				e.stopPropagation();
				e.preventDefault();
			});
			
			
			var isEndInput = true;
			$('#searchKey').on("input", function() {
				if(isEndInput) {
					that.getManyDestData($(this).val());
				}
			});
			$('#searchKey').on("compositionstart", function() {
				isEndInput = false;
			});
			$('#searchKey').on("compositionend", function() {
				isEndInput = true;
				if(isEndInput) {
					that.getManyDestData($(this).val());
				}
			});
			$('#searchKey').keyup(function(event) {
				if(event.keyCode == 13) {
					that.getManyDestData($(this).val());
				}
			});
			$("#form").on('submit',function(e){
				e.preventDefault();
				return false;
			});
			
			$(".tab-list-history").off().on('tap',function(){
				$("#history-search-content").show();
				$("#hot-search-content").hide();
				$(".tab-list-hot").removeClass('active');
				$(this).addClass('active');
			});
			
			$(".tab-list-hot").off().on('tap',function(){
				$("#history-search-content").hide();
				$("#hot-search-content").show();
				$(".tab-list-history").removeClass('active');
				$(this).addClass('active');
			});
		},
		addHistoryCache:function(data){
			var that = this;
			var historyCache = customPackage.searchHistory ? customPackage.searchHistory : [];
			var hasSelectData = customPackage.endPlace;
			var arr = [];
			hasSelectData.forEach(function(value, index){
				var id = value.Id;
				if(that.checkInArray(id,historyCache) == false){
					arr.push(value);
				}
			});
			historyCache = historyCache.concat(arr);
			return historyCache;
		},
		checkInArray:function(id, historyCache){
			var flag = false;
			historyCache.forEach(function(vv, ii){
				if(vv.Id == id){
					flag = true;
				}
			});
			return flag;
		},
		initHistory:function(){
			var historyData = customPackage.searchHistory ? customPackage.searchHistory : [];
			var tmpl = template('history-search-template',{
				DestList:historyData
			});
			$("#history-search-content").html(tmpl);
			this.initEvent();
		},
		getManyDestData:function(key){
			var that = this;
			if(key == ''){
				$("#default-page").show();
				$("#search-key-result").hide();
			}else{
				$("#default-page").hide();
				$("#search-key-result").show();
				var postParam = {
					url: projectConfig.apiName.SearchDestinationList,
					data: {
						Type: 1,
						Key: key
					}
				};
				$(".btm").css("opacity",'0');
				app.Post(postParam,null,function(data){
					$(".btm").css("opacity",'1');
					if(data.Code == '0001'){
						if(plus.os.name.toLowerCase() == 'ios'){

							var tmpl = template('search-result-template',data);
							$("#search-key-result").html(tmpl);
							var noData = '<div class="no-data">无搜索结果</div>';
							$("#search-key-result").append(noData);
						}else{
							var tmpl = template('search-result-template',data);
							$("#search-key-result").html(tmpl);
							var noData = '<div class="no-data">无搜索结果</div>';
							$("#search-key-result").append(noData);
						}
						
					}else{
						if(plus.os.name.toLowerCase() == 'ios'){
							var headerHeight = $("#header").height();
							var btmHeight = $("#search-btm").height();
							var documentHeight = $(document).height();
							var diffHeight = documentHeight - btmHeight - headerHeight - 100;
							var tmpl = template('search-result-template',data);
							$("#search-key-result").html(tmpl);
						}else{
							var tmpl = template('search-result-template',data);
							$("#search-key-result").html(tmpl);
						}
						
						that.initEvent();
					}
				});
			}
			
		},
		initHotSearch:function(){
			var that = this;
			var searchHot = {
				url: projectConfig.apiName.GetDestinationList,
				data: {
					DestReqType: "hot",
					DestList: []
				}
			}
			app.Post(searchHot,null,function(data){
				that.initTemplate(data);
			})
		},
		initTemplate:function(data){
			var tmpl = template('search-hot-template',data);
			$("#hot-search-content").html(tmpl);
			this.initEvent();
		},
		initEvent:function(){
			var that = this;
			$(".search-list").off().on('tap',function(){
				$("#searchKey").blur();
				var Name = $(this).attr('data-name');
				var Id = $(this).attr('data-id');
				var Type = $(this).attr('data-type');
				var CityId = $(this).attr('data-city-id');
				var Desc = $(this).attr('data-desc');
				var Amount = $(this).attr('data-amount');
				var list = {
					Type:Type,
					Id:Id,
					Name:Name,
					CityId:CityId,
					Desc:Desc,
					Amount:Amount
				}
				var state = that.checkHasSelect(Id);
				if(state.flag == true){
					//已存在，那么取消
					that.cancleSearchHistory(state.index);
					$(".search-list").each(function(vv,ii){
						if($(this).attr('data-id') == Id){
							$(this).find('i').removeClass('icon-duoxuan1');
							$(this).find('i').removeClass('selectd');
							$(this).find('i').addClass('icon-duoxuan');
						}
					});
				}else{
					//不存在，那么添加
					if(customPackage.endPlace.length >= 15){
						plus.nativeUI.toast('最多只能选择15个哦~');
					}else{
						$(".search-list").each(function(vv,ii){
							if($(this).attr('data-id') == Id){
								$(this).find('i').removeClass('icon-duoxuan');
								$(this).find('i').addClass('icon-duoxuan1');
								$(this).find('i').addClass('selectd');
							}
						});
						
						that.addSearchHistory(list);
					}
					
				}
				if(isShowMore == true && customPackage.endPlace.length>3){
					that.reloadSearchHistory(1);
				}else{
					that.reloadSearchHistory();
				}
			});
		},
		initSearchHistoryEvent:function(){
			var that = this;
			$(".close-icon").on('touchend',function(e){
				e.preventDefault();
			});
			$(".close-icon").off().on('tap',function(e){
				e.stopPropagation();
				e.preventDefault();
				var id = $(this).attr('data-id');
				var index = -1;
				customPackage.endPlace.forEach(function(v,i){
					if(id == v.Id){
						index = i;
					}
				});
				var _index = $('.close-icon').index(this);
				$(".search-result-list-container").eq(_index).remove();
				that.removeSearchListStyle(id);
				that.cancleSearchHistory(index);
				if(isShowMore == true && customPackage.endPlace.length > 3){
					that.reloadSearchHistory(1);
				}else{
					isShowMore = false;
					that.reloadSearchHistory();
				}
				
				//that.handleIcon();
			});
			$(".more").on('touchend',function(e){
				e.preventDefault();
			});
			$(".more").off().on('tap',function(e){
				e.stopPropagation();
				e.preventDefault();
				if(isShowMore == false){
					that.reloadSearchHistory(1);
					isShowMore = true;
					$(".more").find('i').removeClass('icon-diankai-copy');
					$(".more").find('i').addClass('icon-shouqi');
				}else{
					that.reloadSearchHistory();
					isShowMore = false;
					$(".more").find('i').addClass('icon-diankai-copy');
					$(".more").find('i').removeClass('icon-shouqi');
				}
				
			});
		},
		removeSearchListStyle:function(id){
			$('.search-list').each(function(value, index){
				var thisId = $(this).attr('data-id');
				if(id == thisId){
					$(this).find('i').removeClass('icon-duoxuan1');
					$(this).find('i').removeClass('selectd');
					$(this).find('i').addClass('icon-duoxuan');
				}
			})
		},
		reloadSearchHistory:function(stateNum){
			if(!stateNum){
				var arr = [];
				if(customPackage.endPlace.length>3){
					arr.push(customPackage.endPlace[customPackage.endPlace.length-3]);
					arr.push(customPackage.endPlace[customPackage.endPlace.length-2]);
					arr.push(customPackage.endPlace[customPackage.endPlace.length-1]);
				}else{
					arr = customPackage.endPlace;
				}
				var tmpl = template('search-history-template',{
					endPlace:arr
				});
				$("#search-history-content").html(tmpl);
				this.initSearchHistoryEvent();
			}else{
				var tmpl = template('search-history-template',{
					endPlace:customPackage.endPlace
				});
				$("#search-history-content").html(tmpl);
				this.initSearchHistoryEvent();
				
				if(isShowMore == true){
					$(".more").find('i').removeClass('icon-diankai-copy');
					$(".more").find('i').addClass('icon-shouqi');
				}
			}
			if(customPackage.endPlace.length<=3){
				$(".more").hide();
			}else{
				$('.more').show();
			}
		},
		cancleSearchHistory:function(index){
			
			customPackage.endPlace.splice(index,1);
			if(customPackage.endPlace.length == 0){
				this.hideSeachHistory();
			}
		},
		addSearchHistory:function(list){
			customPackage.endPlace.push(list);
			//this.reloadSearchHistory();
			this.showSeachHistory(); 
			
		},
		checkHasSelect:function(id){
			
			var endPlace = customPackage.endPlace;
			var obj = {
				index:-1,
				flag:false
			}
			endPlace.forEach(function(value, i){
				if(id == value.Id){
					obj.flag = true;
					obj.index = i;
				}
			});
			return obj;
		},
		initSearchHistory:function(data){
			if(data.length == 0){
				this.hideSeachHistory();
			}else{
				this.reloadSearchHistory();
				this.showSeachHistory();
			}
		},
		hideSeachHistory:function(){
			$(".search-result-container").hide();
			$(".null").css('height','5rem');
		},
		showSeachHistory:function(){
			$(".search-result-container").show();
			$(".null").css('height','10rem');
		},
		handleFixed:function(){
			if($(".tab-list-history").hasClass('active')){
				var headerHeight = $("#header").height();
				var btmHeight = $("#search-btm").height();
				var documentHeight = $(document).height();
				var h = $(".tab-list-container").height();
				var diffHeight = documentHeight - btmHeight - headerHeight -h;
				if($("#history-search-content").height()<diffHeight){
					$("#history-search-content").height(diffHeight);
				}
			}
		},
		handleIcon:function(){
			if(customPackage.endPlace.length>3){
				isShowMore = true;
				$(".more").find('i').removeClass('icon-diankai-copy');
				$(".more").find('i').addClass('icon-shouqi');
			}else{
				isShowMore = false;
				$(".more").find('i').addClass('icon-diankai-copy');
				$(".more").find('i').removeClass('icon-shouqi');
				$(".more").hide();
			}
		}
	}
})(window, $)
