app.hotelIndex = {
	GetListInfoEnity: {
		url: projectConfig.apiName.GetRoomList,
		data: {
			Hid: "",
			Did: ""
		}
	},
	GetDetailInfoEnity: {
		url: projectConfig.apiName.GetHotelInfo,
		data: {
			Hid: "",
			Sid: "",
			Did: ""
		}
	},
	pageConfig: {
		headerId: 'detail-header',
		detailId: 'detail-container',
		photoId: 'photo-container',
		listId: 'list-container',
		footerId: 'hotel-footer',
		hotelName: ''
	},
	init: function() {
		var self = app.hotelIndex;
		self.renderDetail();
		self.renderList();
	},
	renderDetail: function() {
		var self = app.hotelIndex;
		var ajaxOptions = self.GetDetailInfoEnity;
		var $detail = app.gEl(self.pageConfig.detailId);
		var $header = app.gEl(self.pageConfig.headerId);
		var $photo = app.gEl(self.pageConfig.photoId);
		self.ajaxData(ajaxOptions, function(data) {
			var _data = data.HotelInfo;
			var tmp = '<strong>{0} {1} {2} {3} </strong>{5}' +
				'<p><a href="javascript:void(0)" class="right-arrow-last go-router map">地图</a><span style="display:inline-block;width:80%;">{4}</span></p>';

			var facilitiesTmp = '<div>' +
				'<a href="javascript:void(0)" class="right-arrow-last go-router facilities">详情</a>' +
				'{0}</div>';

			var facilitiesItemTmp = '<span><i class="facfont {0}"></i></span>';
			var photoTmp = '<div class="img-container"><img src="{0}" /></div>' +
				'<a href="javascript:void(0)" class="hotel-par-toppic-up header-gback  mui-action-back"></a><div class="hotel-name_num"><h3>{1}</h3><font>{2}</font></div>';

			var facilitiesListHtml = '';

			var facilitiesHtml = '';

			if(!!_data.FacilityList && _data.FacilityList.length > 0) {
				$.each(_data.FacilityList, function(i, d) {
					facilitiesListHtml += app.format(facilitiesItemTmp, app.GetNewIcon(d));
				});
				facilitiesHtml = app.format(facilitiesTmp, facilitiesListHtml);
			}
			$header.find('h2').html(_data.Name);
			self.pageConfig.hotelName = _data.Name;

			$photo.html(app.format(photoTmp, _data.ImageSrc, _data.Name, app.format('1/{0}', parseInt(_data.ImageAmount))))
	        self.initDetail($("#detail-container"));
			$detail.html(app.format(tmp,
				_data.ReviewScore || '',
				_data.Type || '',
				_data.RenovationDate || '',
				_data.Amount || '',
				_data.Desc || '',
				facilitiesHtml));
			self.renderFooter(_data.ButtonList, _data.HasCollection == 1);
			self.initDetail($detail);
	
			self.initHeaderScroll($header, $photo);
			self.initPhoto($photo)
		}, $detail);
	},
	initDetail: function($detail) {
		var self = app.hotelIndex;
		var Hid = self.GetDetailInfoEnity.data.Hid;
		$detail.on('click', '.go-router', function() {
			var $this = $(this);
			if($this.hasClass('map')) {
				app.ShowWebView(projectConfig.ViewId.Hotel.map.url, {
					Hid: Hid
				});
			}
			if($this.hasClass('facilities')) {
				app.ShowWebView(projectConfig.ViewId.Hotel.detail.url, {
					Hid: Hid
				});
			}
		})
	},
	initPhoto: function($photo) {
		var self = app.hotelIndex;
		$photo.on('click', function() {
			app.ShowWebView(projectConfig.ViewId.Hotel.photoAlbum.url, {
				Hid: self.GetDetailInfoEnity.data.Hid
			});
		});
	},
	initHeaderScroll: function($header, $photo) {

		var showHeight = $photo.height();

		$(window).on('scroll', function() {
			if($(this).scrollTop() > showHeight) {
				$header.show();
			} else {
				$header.hide();
			}
		});
	},
	renderList: function() {
		var self = app.hotelIndex;
		var ajaxOptions = self.GetListInfoEnity;
		var $list = app.gEl(self.pageConfig.listId);
		var tmp = '		<div class="hotel-par-title"><span>{1}<i class="current"></i></span>{0}</div>' +
			'		<div class="hotel-par-room-list">{2}</div>';
		var itemTmp = '<div><img src="{0}" />' +
			'				<p>{1}' +
			'					<font>{2}<br />{3}</font>' +
			'				</p><span>{4}<font>{5}</font></span>' +
			'			</div>';
		var listHtml = '';
		var tHtml = '';
		self.ajaxData(ajaxOptions, function(data) {
			$.each(data.RoomTypeList, function(i, hotel) {
				tHtml += app.format(tmp, hotel.Name, hotel.Amount, (function(rooms) {
					$.each(rooms, function(j, room) {
						listHtml += app.format(itemTmp,
							room.ImageSrc,
							room.Name,
							room.Desc,
							room.Facilites,
							room.OfferPrice.join(''),
							room.OfferMinAmount
						)
					});
					return listHtml;
				})(hotel.RoomList))
			});
			$list.html(tHtml);
			self.initList($list);
		});
	},
	initList: function($list) {
		var self = app.hotelIndex;
		var curr = 'current';
		$list.on('click', '.hotel-par-title', function() {
			var $this = $(this);
			var $after = $this.next();
			var $i = $this.find('i');
			if($i.hasClass(curr)) {
				$i.removeClass(curr);
				$after.hide();
			} else {
				$i.addClass(curr);
				$after.show();
			}
		});
	},
	renderFooter: function(data, isCollect) {
		if(!data) return;
		var self = app.hotelIndex;
		var $footer = app.gEl(self.pageConfig.footerId);
		var tmp_1 = '<div class="hotel-par-footbuy">{0}</div>';
		var tmp_2 = '<div class="hotel-par-footbuy-yd">{0}</div>';
		var tmp_3 = '<div class="hotel-par-price-load">{0}</div>';
		var shareTmp = '<a href="javascript:void(0)" class="hotel-par-share"><i></i>{0}</a>'; // 分享
		var collectTmp = '<a href="javascript:void(0)" class="hotel-par-collection {1}"><i></i>{0}</a>'; // 收藏
		var addInquiryTmp = '<a href="javascript:void(0)" data-type="{2}" class="hotel-par-add {1}">{0}</a>'; // 加入询价
		var inquiriesNowTmp = '<a href="javascript:void(0)" data-type="{2}"  class="hotel-par-now {1}">{0}</a>'; // 立即询价
		var defaultTmp = '<a href="javascript:void(0)" data-type="{1}" class="{2}">{0}</a>'; // 立即预订

		var quotedPricesTmp = '{0}'; // 正在报价中
		var len = data.length;
		var tHtml = shareHtml = collectHtml = addInquiryHtml = inquiriesNowHtml = '';
		$.each(data, function(i, link) {
			switch(link.Type + '') {
				case '2':
					tHtml = app.format(tmp_3, link.Name);
					break;
				case '7':
					collectHtml = app.format(collectTmp, link.Name, isCollect ? 'isCollect' : '');
					break;
				case '8':
					shareHtml = app.format(shareTmp, link.Name);
					break;
				case '9': // 加入询价
					addInquiryHtml = app.format(addInquiryTmp, link.Name, len == 3 ? 'hotel-par-btn' : '', link.Type);
					break;
				case '10': // 我要询价
					addInquiryHtml = app.format(addInquiryTmp, link.Name, len == 3 ? 'hotel-par-btn' : '', link.Type);
					break;
				case '11':
					inquiriesNowHtml = app.format(inquiriesNowTmp, link.Name, len == 3 ? 'hotel-par-btn' : '', link.Type);
					break;
				case '12':
					tHtml = app.format(tmp_2, app.format(defaultTmp, link.Name, link.Type, 'reservations-now'));
					break;
				case '300':
				case '400':
					tHtml = app.format(tmp_2, app.format(defaultTmp, link.Name, link.Type, 'bind-hotel'));
					break;
				case '301':
					tHtml = app.format(tmp_2, app.format(defaultTmp, link.Name, link.Type, 'online-hotel'));
					break;
				case '302':
					tHtml = app.format(tmp_2, app.format(defaultTmp, link.Name, link.Type, 'offline-hotel'));
					break;
				default:
					break;
			}
		});
		tHtml = len > 1 ? app.format(tmp_1, (addInquiryHtml + inquiriesNowHtml + shareHtml + collectHtml)) : tHtml;
		$footer.html(tHtml);
		self.initFooter($footer, data, isCollect);
	},
	initFooter: function($footer, data, isCollect) {
		var self = app.hotelIndex;
		$footer.on('click', 'a', function() {
			var $this = $(this);
			var type = $this.attr('data-type');
			if($this.hasClass('hotel-par-share')) { // 分享
				//app.share(id,..);
				app.framework.share($this);
			}

			if($this.hasClass('hotel-par-collection')) { // 收藏
				app.framework.collect(_Hid, isCollect, function(result) {
					if(result) {
						$this.addClass('isCollect');
						isCollect = true;
					} else {
						$this.removeClass('isCollect');
						isCollect = false;
					}
				});
			}

			if($this.hasClass('hotel-par-add')) {
				if(type == 9) { // 加入询价
					app.SearchHotelHistory.SetSearchHotel(_Sid, _Hid, 1);
				} else { // 我要询价
					app.OfferHotelPrice.SubmitDemandInfo(_Sid);
				}
			}
			if($this.hasClass('reservations-now')) {
				var param={};
				param.Hid=self.GetListInfoEnity.data.Hid;
				param.Did=self.GetListInfoEnity.data.Did;
				app.ShowWebView(projectConfig.ViewId.Payment.OrderWrite.url,param,null,projectConfig.ViewId.Payment.OrderWrite.Id);
			}

			if($this.hasClass('hotel-par-now')) { // 立即询价
				app.OfferHotelPrice.SubmitDemandInfo(_Sid, _Hid);
			}

			if($this.hasClass('offline-hotel')) { // 下线
				var offlineOptions = {
					url: projectConfig.apiName.SetHotelLine,
					data: {
						HotelId: _Hid,
						Type: 4
					}
				}
				app.Post(offlineOptions, null, function() {
					$this.removeClass('offline-hotel').addClass('online-hotel').html('上线');
					app.showMsg('酒店下线成功');

				})
			}

			if($this.hasClass('online-hotel')) { // 上线
				var offlineOptions = {
					url: projectConfig.apiName.SetHotelLine,
					data: {
						HotelId: _Hid,
						Type: 3
					}
				}
				app.Post(offlineOptions, null, function() {
					$this.removeClass('online-hotel').addClass('offline-hotel').html('下线');
					app.showMsg('酒店上线成功')
				})
			}

			if($this.hasClass('bind-hotel')) { // 认领
				var _bindInfo = projectConfig.ViewId.MyHotel.bindInfo;
				app.ShowWebView('../MyHotel/bindInfo.html', {
					hotelId: _Hid,
					hotelName: self.pageConfig.hotelName,
				}, null, _bindInfo.Id);
			}
		})
	},
	initShare: function() {
		var self = app.hotelIndex;
	},
	initCollect: function() {
		var self = app.hotelIndex;
	},
	ajaxData: function(ajaxOptions, callbackFn, $el) {
		var self = app.hotelIndex;
		var _render = function(data) {
			if(app.GetResultState(data)) {
				callbackFn(data);
			} else {
				app.renderNoResult(self.pageConfig.noPic);
			}
		};
		if(!!$el && !!$el.get(0)) app.Loading($el, '45%');
		app.Post(ajaxOptions, null, _render);
	}
};