app.hotelMap = {
	GetInfoEnity: {
		url: projectConfig.apiName.GetHotelGeo,
		data: {
			Hid: ""
		}
	},
	init: function() {
		var self = app.hotelMap;
		self.ajaxData();
	},
	initBMap: function(longitude, latitude, info) {
		// 百度地图API功能
		var map = new BMap.Map("hotelMapContainer"); // 创建Map实例
		var point = new BMap.Point(longitude, latitude);
		var marker = new BMap.Marker(point); // 创建标注
		map.addOverlay(marker); // 将标注添加到地图中
		map.panTo(point);
		map.centerAndZoom(point, 15); // 初始化地图,设置中心点坐标和地图级别
		var opts = {
			paddingTop: 10,
			width: 180, // 信息窗口宽度
			height: 50, // 信息窗口高度
			title: info.Name // 信息窗口标题
		};
		var infoWindow = new BMap.InfoWindow(info.Desc, opts);
		
		map.openInfoWindow(infoWindow, point);
		infoWindow.redraw(); 
		var top_left_navigation = new BMap.NavigationControl({
			anchor: BMAP_ANCHOR_BOTTOM_RIGHT,
			type: BMAP_NAVIGATION_CONTROL_SMALL
		}); //右上角
		map.addControl(top_left_navigation);

		marker.addEventListener("click", function() {
			map.openInfoWindow(infoWindow, point); //开启信息窗口
			infoWindow.redraw(); 
		});

	},
	ajaxData: function() {
		var self = app.hotelMap;
		var _render = function(data) {
			if(app.GetResultState(data)) {
				var point = data.HotelInfo.Geo;
				self.initBMap(point.Lon, point.Lat, data.HotelInfo);
			} else {
				app.renderNoResult(self.pageConfig.noPic);
			}
		};
		app.Post(self.GetInfoEnity, null, _render);
	}
};