app.NewDetail = {
	GetInfoEnity: {
		url: projectConfig.apiName.GetHotelInfo,
		data: {
			Hid: "",
			Did: "",
			Sid: ""
		}
	},
	pageConfig: {
		infoId: 'hotel-info',
		noPic: 'hotel-info',
		header: 'HotelName',
		HideHeight: 'headerShow'
	},
	ArrivalDate: "",
	DepartureDate: "",
	GroupMin:[],
	GroupLeavePrice:[],
	GroupMinDesc:[],
	IsGroup:1,
	//初始化
	init: function() {
		var self = app.NewDetail;
		//加载基础数据旅店信息
		self.ajaxHotelInfoData();
		//初始化roomList数据
		var roomSelf = app.GetRoomListV2;
		roomSelf.init();
	},
	//加载基础数据旅店信息
	ajaxHotelInfoData: function() {
		var self = app.NewDetail;
		var _render = function(data) {
			if(app.GetResultState(data)) {
				self.renderDetail(data);
			} else {
				app.ShowResultErr(data.Msg, null, self.pageConfig.noPic);
			}
		};
		app.Post(self.GetInfoEnity, null, _render);
	},
	renderDetail: function(data) {
		var self = app.NewDetail;
		var _data = data.HotelInfo;
		
		//存储GroupMin信息
		app.NewDetail.GroupMin = _data.GroupMin;
		app.NewDetail.GroupLeavePrice = _data.GroupLeavePrice;
		app.NewDetail.GroupMinDesc = _data.GroupMinDesc;
		
		var hotelPictmp = '<div class="img-container"><img src="{0}" class="gopic"></div>' +
			'<div class="gopic">' +
			'	<span>{1}</span>' +
			'	<h1>{2}</h1>' +
			'</div>';

		$("#hotel-pic").html(app.format(hotelPictmp, _data.ImageSrc, _data.ImageAmount, _data.Name, _data.HasCollection));
		$("#HotelName").html(_data.Name);
		var svgCollection = "shoucang"+_data.HasCollection;
		$("#hascollectionIner i").addClass(svgCollection);
		
		var hotelinfotmp = '<p>{0} {1} {2} {3}</p>' +
			'<div style="height: 45px;">' +
			'	<a href="javascript:void(0);" class="go-router facilities">详情<b class="hotelfont icon-xiangqing" style="font-size:14px;"></b></a>' +
			'{4}</div>' +
			'<div class="hotel-info-address">' +
			'	<a href="javascript:void(0);" class="go-router map">地图<b class="hotelfont icon-xiangqing" style="font-size:14px;"></b></a>{5}' +
			'</div>';
		$("#hotel-info").html(app.format(hotelinfotmp, _data.ReviewScore || '', _data.Type || '', _data.Amount || '', _data.RenovationDate || '', self.GetFacility(_data.FacilityList), _data.Desc || ''));

		//绑定事件
		self.initDetail($("#hotel-info"));
		self.initPhoto($(".gopic"));
		app.ReplaceImgRequestHeader()
		//		//控制头部显示
		self.initHeaderScroll($("#" + self.pageConfig.header), $("#" + self.pageConfig.HideHeight));

		//事件
		$("#go-back").off().on('tap', function() {
			mui.back();
		});

	},
	initDetail: function($detail) {
		var self = app.NewDetail;
		var Hid = self.GetInfoEnity.data.Hid;
		$detail.on('tap', '.go-router', function() {
			var $this = $(this);
			if($this.hasClass('map')) {
				app.ShowWebView(projectConfig.ViewId.Hotel.map.url, {
					Hid: Hid
				});
			}
			if($this.hasClass('facilities')) {
				app.ShowWebView(projectConfig.ViewId.Hotel.detail.url, {
					Hid: Hid
				});
			}
		})
	},
	initPhoto: function($photo) {
		var self = app.NewDetail;
		var Hid = self.GetInfoEnity.data.Hid;
		$photo.on('tap', function() {
			app.ShowWebView(projectConfig.ViewId.Hotel.photoAlbum.url, {
				Hid: Hid
			});
		});
	},
	GetFacility: function(data) {
		var hotels = new Array();
		//hotels.push('<i class="hotelfont icon-newtingche"></i><i class="hotelfont icon-songcanfuwu"></i><i class="hotelfont icon-newduihuan"></i>');
		if(data != null) {
			for(var j = 0; j < data.length; j++) {
				if(j < 5) {
					var facility = data[j];
					var icon = app.GetNewIcon(facility);
					hotels.push('<i class="facfont ' + icon + '"></i>');
				}
			}
		}
		return hotels.join("");
	},
	initHeaderScroll: function($header, $photo) {
		var showHeight = $photo.height();
		//此种方法兼容安卓和苹果手机    耗性能
		var count = 0,
			timer = null;
		var oldTop = newTop = $(window).scrollTop(); //为了方便起见，使用jquery或者zepto框架
		function log() {
			if(timer) clearTimeout(timer);
			newTop = $(window).scrollTop();
			if(newTop === oldTop) {
				clearTimeout(timer);
				//已停止，写入业务代码
				if(oldTop > showHeight) {
					$header.show();
				} else {
					$header.hide();
				}
			} else {
				oldTop = newTop;
				timer = setTimeout(log, 100);
				if(oldTop > showHeight) {
					$header.show();
				} else {
					$header.hide();
				}
			}
		}
		$(window).on('touchmove', log);

	},
	renderNoResult: function(title, intro, showType, showobj, divstr) {
		var tmp = divstr + '<div class="zdy-network-no"><i class="' + showType + '"></i><h3>' + (title || '') + '</h3>';
		if(intro)
			tmp += "<font>" + intro + "</font>";
		tmp += "</div>";

		if(showobj)
			$(showobj).html(tmp);
		else
			$('header').after(tmp);
	}

}