(function(window, $) {
	window.HotelFacility = (function() {
		// 价格星级  1 
		var ProductType = 0;
		var checkId = []
		var data = {}

		function init(type) {
			var height = $(window).height() - 60;
			$(".hotel-facility-view").height(height)
			if(type == 1) {
				$("#title").html("酒店星级");
				loadPriceStar();
			} else if(type == 2) {
				$("#title").html("位置区域");
				loadArea();
			} else if(type == 3) {
				$("#title").html("筛选");
				loadFacility();
			}
		}

		function loadFacility() {
			app.showWaiting('加载中...', 1);
			var settings = app.getSettings()
			settings.HotelSearchParam.data.DataType = [3, 5]; // 
			app.Post(settings.HotelSearchParam, null, loadFacilityCallBack)
		}

		function loadFacilityCallBack(cdata) {
			if(app.GetResultState(cdata)) {
				cdata.FiterType.Facility.isShow = 1;
				cdata.FiterBrand.isShow = 0;
				cdata.FiterType.Protocol.isShow = 0;
				cdata.FiterType.Facility.type = 5;
				cdata.FiterBrand.type = 6;
				cdata.FiterBrand.Name = "连锁品牌";
				cdata.FiterBrand.IsSelect = cdata.FiterBrand.IsSelect || 0;
				cdata.FiterBrand.Result = []
				cdata.FiterBrand.Economical.isShow = 0;
				cdata.FiterBrand.Comfortable.isShow = 0;
				cdata.FiterBrand.High.isShow = 0;
				cdata.FiterBrand.Luxury.isShow = 0;
				//cdata.FiterBrand.Luxury.isShow = 0;
				cdata.FiterBrand.Result.push(cdata.FiterBrand.Economical)
				cdata.FiterBrand.Result.push(cdata.FiterBrand.Comfortable)
				cdata.FiterBrand.Result.push(cdata.FiterBrand.High)
				cdata.FiterBrand.Result.push(cdata.FiterBrand.Luxury)
				cdata.FiterType.Protocol.type = 7;
				data.list = []
				data.list.push(cdata.FiterType.Facility)
				data.list.push(cdata.FiterBrand)
				cdata.FiterType.Protocol.List.pop();
				data.list.push(cdata.FiterType.Protocol)

				var tmplHot1 = template('first-template', data);
				$(".hotel-facility-view").html(tmplHot1);
				initEvent();
			} else {
				$(".hotel-facility-view").html(LoadNoResult());
			}
		}

		function loadArea() {
			app.showWaiting('加载中...', 1);
			var settings = app.getSettings()
			settings.HotelSearchParam.data.DataType = [4];
			app.Post(settings.HotelSearchParam, null, LoadAreaCallBack)
		}

		function LoadAreaCallBack(cdata) {
			if(app.GetResultState(cdata)) {
				cdata.FiterArea.ComArea.isShow = 1;
				cdata.FiterArea.DisArea.isShow = 0;
				cdata.FiterArea.ComArea.type = 3;
				cdata.FiterArea.DisArea.type = 4;
				data.list = []
				data.list.push(cdata.FiterArea.ComArea)
				data.list.push(cdata.FiterArea.DisArea)

				var tmplHot1 = template('first-template', data);
				$(".hotel-facility-view").html(tmplHot1);
				initEvent();

				mui(".hotel-facility-right2").scroll();

			} else {
				$(".hotel-facility-view").html(LoadNoResult());
			}
		}

		//加载无结果样式
		function LoadNoResult() {
			return '<div class="no-list-msg">' +
				'<div class="no-icon">' +
				'	<img src="../images/no-list-icon.png" />' +
				'</div>' +
				'<div class="no-msg">' +
				'	搜索无结果' +
				'</div>' +
				'</div>';
		}

		function loadPriceStar() {
			var list = {}
			data.list = []
			var prices = app.model.Prices;
			var stars = app.model.Stars;
			list.Name = "价格"
			list.type = 1
			list.SeleteType = 1
			list.IsSelect = 0
			list.isShow = 1
			var settings = app.getSettings();
			var param = settings.HotelSearchParam.data;
			var _minPrice, _maxPrice;

			if(param.Price && param.Price.length == 2) {
				_minPrice = param.Price[0];
				_maxPrice = param.Price[1]
			}

			//价格
			if(param.Price.length == 0) {
				prices[0].IsSelect = 1;
			} else {
				for(var i = 0; i < prices.length; i++) {
					if(prices[i].minval == _minPrice && prices[i].maxval == _maxPrice) {
						prices[i].IsSelect = 1;
						if(_minPrice!=0 && _maxPrice!=0)
							list.IsSelect = 1;
					} else {
						prices[i].IsSelect = 0;
					}
				}
			}
			list.prices = prices;
			data.list.push(list)
			var liststar = {}
			liststar.Name = "星级"
			liststar.type = 2
			liststar.SeleteType = 2
			liststar.isShow = 0
			var flag = false,
				isCurrStar;

			for(var j = 0; j < stars.length; j++) {
				isCurrStar = false;
				if(stars[j].val != 0) {
					$.each(param.StarRateList, function(i, d) {
						if(stars[j].val == d) {
							isCurrStar = true;
						}
					});
					if(isCurrStar) {
						stars[j].IsSelect = 1;
						liststar.IsSelect = 1;
						flag = true
					} else {
						stars[j].IsSelect = 0;
					}
				} else {
					stars[j].IsSelect = 0;
				}
			}
			if(!flag) {
				stars[0].IsSelect = 1;
			}

			liststar.stars = stars
			data.list.push(liststar)

			var tmplHot1 = template('first-template', data);
			$(".hotel-facility-view").html(tmplHot1);

			initEvent();
		}

		function initEvent() {
			//选择筛选项
			$(".hotel-facility-left-item").off().on("tap", function() {
				var flag = false
				var type = $(this).attr("type");
				var selectType = $(this).attr("selectType");
				for(var i = 0; i < data.list.length; i++) {
					var _item = data.list[i];
					data.list[i].isShow = 0
					if(data.list[i].type == type) {
						data.list[i].isShow = 1
						if(type == 6) { // 连锁品牌
							var _curr = false;
							$.each(_item.Result, function(x, dx) {
								if(!_curr) { // 筛选的第一个显示，其余隐藏
									$.each(dx.List, function(m, dm) {
										if(dm.Id != 0) { // 过滤掉不限
											if(dm.IsSelect == 1) {
												_curr = true;
												data.list[i].Result[x].isShow = 1;
												data.list[i].Result[x].IsSelect = 1;
											}
										}
									})
								} else {
									data.list[i].Result[x].isShow = 0;
									data.list[i].Result[x].IsSelect = 0;
								}
							})
							if(!_curr) { // 没有选中的品牌，默认打开第一个的不限
								data.list[i].Result[0].isShow = 1;
								data.list[i].Result[0].IsSelect = 1;
							}
						}
					}
				}
				//隐藏品牌
				if(type != 6) {
					for(var j = 0; j < data.list.length; j++) {
						if(data.list[j].type == 6) {
							for(var k = 0; k < data.list[j].Result.length; k++) {
								data.list[j].Result[k].isShow = 0;
							}
						}
					}
				}
				if(!flag) {
					var tmplHot1 = template('first-template', data);
					$(".hotel-facility-view").html(tmplHot1);
					initEvent();
				}
			})
			//选择品牌类型
			$(".hotel-facility-mid-item").off().on("tap", function() {
				var pType = $(this).attr("pType");
				var list = {}
				var index = 0;
				var flag = false;
				for(var i = 0; i < data.list.length; i++) {
					if(data.list[i].type == 6) {
						index = i;
						list = data.list[i];
					}
				}
				for(var j = 0; j < list.Result.length; j++) {
					if(pType == list.Result[j].Type) {
						if(list.Result[j].isShow == 1) {
							flag = true
						} else {
							list.Result[j].isShow = 1;
							list.Result[j].IsSelect = 1;
						}
					} else {
						list.Result[j].isShow = 0;
						list.Result[j].IsSelect = 0;
					}
				}

				data.list[index] = list;
				if(!flag) {
					var tmplHot1 = template('first-template', data);
					$(".hotel-facility-view").html(tmplHot1);
					initEvent();
				}
			})
			//选择品牌
			$(".hotel-facility-right1-item").off().on("tap", function() {
				var type = $(this).attr("type");
				var val = $(this).attr("val");
				var index = 0;
				for(var i = 0; i < data.list.length; i++) {
					if(data.list[i].type == 6) {
						index = i;
						break;
					}
				}
				var brands = data.list[index];
				var checkCount = 0;
				var allCheckCount = 0;
				for(var j = 0; j < brands.Result.length; j++) {
					if(brands.Result[j].Type == type) {
						for(var k = 0; k < brands.Result[j].List.length; k++) {
							if(val == 0) {
								brands.Result[j].List[k].IsSelect = 0;
							} else if(val == brands.Result[j].List[k].Id) {
								if(brands.Result[j].List[k].IsSelect == 1) {
									brands.Result[j].List[k].IsSelect = 0;
								} else {
									brands.Result[j].List[k].IsSelect = 1;
								}
							}
							if(brands.Result[j].List[k].IsSelect == 1) {
								checkCount += 1;
								allCheckCount += 1;
							}
						}
						if(checkCount > 0) {
							brands.Result[j].List[0].IsSelect = 0;
						} else {
							brands.Result[j].List[0].IsSelect = 1;
						}
						break;
					} else {
						for(var k = 0; k < brands.Result[j].List.length; k++) {
							if(brands.Result[j].List[k].IsSelect == 1) {
								allCheckCount += 1;
							}
						}
					}
				}
				if(allCheckCount > 0) {
					brands.IsSelect = 1;
				} else {
					brands.IsSelect = 0;
				}
				data.list[index] = brands;
				var tmplHot1 = template('first-template', data);
				$(".hotel-facility-view").html(tmplHot1);
				initEvent();
				var topflag = false;
				var top2 = $(this).parent().scrollTop()
				$(".hotel-facility-right1").each(function(item, index) {
					if(!$(this).hasClass("none")) {
						var right = $(this)
						$(this).find(".hotel-facility-right-item").each(function(item1, index1) {
							if($(this).attr("val") == val && top2 > 0) {
								right.animate({
									scrollTop: top2
								}, 0);
								topflag = true
								return;
							}
						})

						if(topflag)
							return;
					}
				})
			});
			//选择服务设施、协议差标、价格星级、行政区、服务区
			$(".hotel-facility-right-item").off().on("tap", function() {
				var type = $(this).attr("type");
				var val = $(this).attr("val");
				var index = 0;
				var selectType = $(this).attr("selectType");

				for(var i = 0; i < data.list.length; i++) {
					if(data.list[i].type == type) {
						index = i;
						break;
					}
				}
				var entity = data.list[index];
				//价格
				if(type == 1) {
					for(var j = 0; j < entity.prices.length; j++) {
						entity.prices[j].IsSelect = 0;
						if(val == entity.prices[j].sort) {
							entity.prices[j].IsSelect = 1;
							entity.IsSelect = 1;
						}
					}
					if(val == 0) {
						entity.IsSelect = 0;
					}
					data.list[index] = entity;
				}
				//星级
				else if(type == 2) {
					if(val == 0) {
						for(var j = 0; j < entity.stars.length; j++) {
							entity.stars[j].IsSelect = 0;
						}
						entity.stars[0].IsSelect = 1;
						entity.IsSelect = 0;
					} else {

						var checkCount = 0;
						for(var j = 0; j < entity.stars.length; j++) {
							if(val == entity.stars[j].val) {
								if(entity.stars[j].IsSelect == 1) {
									entity.stars[j].IsSelect = 0;
								} else {
									entity.stars[j].IsSelect = 1;
								}
							}

							if(entity.stars[j].IsSelect == 1) {
								checkCount += 1;
							}
						}
						// 是否一个未选中
						if(checkCount == 0) {
							entity.stars[0].IsSelect = 1;
							entity.IsSelect = 0;
						} else {
							entity.stars[0].IsSelect = 0;
							entity.IsSelect = 1;
						}
					}
					data.list[index] = entity;
				}
				//商业区   
				if(type == 3 || type == 4) {
					var entity = data.list[0];
					var entity2 = data.list[1];
					if(type == 4) {
						entity = data.list[1];
						entity2 = data.list[0];
					}
					entity.IsSelect = 0;
					entity2.IsSelect = 0;
					if(val == 0) {
						for(var j = 0; j < entity.List.length; j++) {
							entity.List[j].IsSelect = 0;
						}
						entity.List[0].IsSelect = 1;
					} else {
						entity.List[0].IsSelect = 0;
						for(var j = 0; j < entity.List.length; j++) {
							if(selectType == 1) {
								entity.List[j].IsSelect = 0;
							}
							if(val == entity.List[j].Id) {
								entity.IsSelect = 1;
								entity.List[j].IsSelect = 1;
							}
						}
					}

					for(var k = 0; k < entity2.List.length; k++) {
						if(k == 0) {
							entity2.List[k].IsSelect = 1;
							entity2.isShow = 0;
						} else {
							entity2.List[k].IsSelect = 0;
						}
					}

					if(type == 3) {
						data.list[0] = entity;
						data.list[1] = entity2;
					} else if(type == 4) {
						data.list[0] = entity2;
						data.list[1] = entity;
					}
				} else if(type == 5) {
					if(val == 0) {
						for(var j = 0; j < entity.List.length; j++) {
							entity.List[j].IsSelect = 0;
						}
						entity.List[0].IsSelect = 1;
						entity.IsSelect = 0;
					} else {
						var checkCount = 0;
						for(var j = 0; j < entity.List.length; j++) {
							if(val == entity.List[j].Id) {
								if(entity.List[j].IsSelect == 1) {
									entity.List[j].IsSelect = 0;
								} else {
									entity.List[j].IsSelect = 1;
								}
							}

							if(entity.List[j].IsSelect == 1) {
								checkCount += 1;
							}
						}

						// 是否一个未选中
						if(checkCount == 0) {
							entity.List[0].IsSelect = 1;
							entity.IsSelect = 0;
						} else {
							entity.List[0].IsSelect = 0;
							entity.IsSelect = 1;
						}
					}
					data.list[index] = entity;
				} else if(type == 6) {

				} else if(type == 7) {
					if(val == 0) {
						for(var j = 0; j < entity.List.length; j++) {
							entity.List[j].IsSelect = 0;
						}
						entity.List[0].IsSelect = 1;
						entity.IsSelect = 0;
					} else {
						var checkCount = 0;
						for(var j = 0; j < entity.List.length; j++) {
							if(val == entity.List[j].Id) {
								if(entity.List[j].IsSelect == 1) {
									entity.List[j].IsSelect = 0;
								} else {
									entity.List[j].IsSelect = 1;
								}
							}

							if(entity.List[j].IsSelect == 1) {
								checkCount += 1;
							}
						}
						// 是否一个未选中
						if(checkCount == 0) {
							entity.List[0].IsSelect = 1;
							entity.IsSelect = 0;
						} else {
							entity.List[0].IsSelect = 0;
							entity.IsSelect = 1;
						}
					}
					data.list[index] = entity;
				}

				var top2 = $(this).parent().scrollTop()
				var tmplHot1 = template('first-template', data);
				$(".hotel-facility-view").html(tmplHot1);
				initEvent();
				var topflag = false
				$(".hotel-facility-right2").each(function(item, index) {
					if(!$(this).hasClass("none")) {
						var right = $(this)
						$(this).find(".hotel-facility-right-item").each(function(item1, index1) {
							if($(this).attr("val") == val && top2 > 0) {
								right.animate({
									scrollTop: top2
								}, 0);
								topflag = true
								return;
							}
						})

						if(topflag)
							return;
					}
				})
			});

			$(".hotel-facility-button").off().on("tap", function() {
				var price = [];
				var star = [];
				var dest = {};
				var fiter = [];
				var brand = [];
				var protocol = [];
				var settings = app.getSettings();
				var param = settings.HotelSearchParam.data;

				for(var i = 0; i < data.list.length; i++) {
					var list = data.list[i];
					if(list.type == 1) {
						for(var j = 0; j < list.prices.length; j++) {
							if(list.prices[j].IsSelect == 1) {
								price.push(list.prices[j].minval);
								price.push(list.prices[j].maxval);
								break;
							}
						}
						param.Price = price;
					} else if(list.type == 2) {
						for(var j = 0; j < list.stars.length; j++) {
							if(list.stars[j].IsSelect == 1) {
								star.push(list.stars[j].val)
							}
						}
						param.StarRateList = star;
					} else if(list.type == 3 || list.type == 4) {
						if(list.type == 3) {
							for(var j = 0; j < list.List.length; j++) {
								if(list.List[j].IsSelect == 1 && list.List[j].Id != 0) {
									dest.Type = list.Type;
									dest.Id = [];
									dest.Id.push(parseInt(list.List[j].Id))
									dest.Name = list.List[j].Name
								}
							}
							if(dest && dest.Id) {
								param.Dest = dest;
								break;
							}
						} else if(list.type == 4) {
							for(var j = 0; j < list.List.length; j++) {
								if(list.List[j].IsSelect == 1 && list.List[j].Id != 0) {
									dest.Type = list.Type;
									dest.Id = [];
									dest.Id.push(parseInt(list.List[j].Id))
									dest.Name = list.List[j].Name
								}
							}
							if(dest && dest.Id) {
								param.Dest = dest;
								break;
							}
						}
					} else if(list.type == 5) {
						var fiterSow = []
						for(var j = 0; j < list.List.length; j++) {
							if(list.List[j].IsSelect == 1) {
								var entity = {}
								if(list.List[j].Id != 0){
									fiter.push(list.List[j].Id)
									entity.id = list.List[j].Id;
									entity.name = list.List[j].Name;
									fiterSow.push(entity)
								}
							}
						}
						param.FacilityContion = fiterSow;
						param.FacilityList = fiter;
					} else if(list.type == 6) {
						var brandc = [];
						for(var j = 0; j < list.Result.length; j++) {
							for(var k = 0; k < list.Result[j].List.length; k++) {
								var entity = {}
								if(list.Result[j].List[k].IsSelect == 1 && list.Result[j].List[k].Id != 0) {
									entity.id = list.Result[j].List[k].Id;
									entity.name = list.Result[j].List[k].Name;
									brandc.push(entity);
									brand.push(list.Result[j].List[k].Id)
								}
							}
						}
						param.BrandList = brand;
						param.BrandContion = brandc;
					} else if(list.type == 7) {
						for(var j = 0; j < list.List.length; j++) {
							if(list.List[j].IsSelect == 1) {
								if(list.List[j].Id != 0)
									protocol.push(list.List[j].Id)
							}
						}
						param.ProtocolList = protocol;
					}
				}
				var settings = app.getSettings();
				settings.HotelSearchParam.data = param;
				app.setSettings(settings);

				var listView = plus.webview.getWebviewById(projectConfig.ViewId.Hotel.Sub_ScatteredList.Id);
				listView.evalJS("window.Sub_ScatteredHotelList.setParam()");
				app.HideWebView(plus.webview.currentWebview().id);
			});
		}

		return {
			init: init,
			ProductType: ProductType
		}
	})();
})(window, $);