(function(window, $) {
	window.Sub_ScatteredHotelList = (function() {
		//刷新控件Id
		var pullId = "#pullrefresh";
		//数据加载状态
		var LoadPage = false;
		//搜索参数
		var SearchHotelListEntity = {
			url: projectConfig.apiName.SearchHotelListV2,
			data: {
				Dest: {
					Type: "",
					Id: [],
					Name: ""
				},
				CheckList: [],
				RoomList: [],
				SpecialList: [],
				Price: [],
				StarRateList: [],
				Key: {
					Type: "",
					Id: [],
					Name: ''
				},
				FacilityList: [],
				Rank: 0,
				Dis: 4000,
				Page: {
					Index: 0,
					Size: 0,
				},
				DataType: [
					1, 2, 5
				],
				ProtocolList: [],
				CityId: 0,
				IsGroup: 0,
				ProtocolList: []
			},
			PageInfo: {
				Index: 0,
				Size: 0,
				Amount: 0,
				ResultAmount: 0
			}
		}

		var HotelCityId = 0;
		//搜索条件
		var SearchConditions = {
			List: [],
			Brands: [],
			Dests: {
				Name: "",
				Id: 0,
				Type: 0,
				CityName: "",
				CityId: 0
			},
			Facilitys: [],
			Prices: {
				minval: 0,
				maxval: 0,
				name: "",
				id: ""
			},
			StarRateList: {
				stars: [],
				showstar: ""
			},
			Date: {
				LeaveDate: "",
				ArriveDate: ""
			},
			Dis: [],
			Keys: []
		}

		function init() {
			initParam(1);
			LoadHotel();
		}

		function getParamByCache() {
			var settings = app.getSettings();
			return settings.searchparam1;
		}

		function initParam(type) {
			var settings = app.getSettings();
			var data = SearchHotelListEntity.data;
			var param = getParamByCache();
			if(settings.backUrl && settings.backUrl == "ScatteredDetail") {
				param = settings.HotelSearchParam.data;
				type = 2;
				SearchHotelListEntity.data = param;
				settings.backUrl=null;
				app.setSettings(settings);
			}
			
			if(param) {
				if(type == 1) {
					data.Dest.Type = param.Dest.Type == 0 ? 1 : param.Dest.Type;
					data.Dest.Id = param.Dest.Id;
					data.Dest.Name = param.Dest.Name;
					data.CheckList = param.CheckList;
					data.RoomList = param.RoomList;
					data.SpecialList = param.SpecialList;
					data.BrandContion=param.BrandContion;
					data.Price = param.Price;
					data.BrandList = param.Brands;
					data.StarRateList = param.StarRateList;
					data.Keywords = param.Keywords;
					data.Key = param.Key;
					data.Page.Index = 1;
					data.Page.Size = 10;
					data.CityId = param.CityId;
					data.IsGroup = param.IsGroup;

					SearchHotelListEntity.data = data;

					var settings = app.getSettings();
					settings.HotelSearchParam = SearchHotelListEntity
					app.setSettings(settings)
				}

				if(type == 2) {
					param = settings.HotelSearchParam.data;
				}

				SearchConditions.Keys = []
				//外显搜索条件加载
				if(param.Key && param.Key.Id) {
					var brand = {
						id: 0,
						name: ''
					};
					brand.id = param.Key.Id[0];
					brand.name = param.Key.Name;
					SearchConditions.Keys.push(brand);
				}

				if(param.Keywords) {
					SearchConditions.Keywords = param.Keywords;
				}

				SearchConditions.Brands = [];
				if(param.BrandContion && param.BrandContion.length > 0) {
					for(var i = 0; i < param.BrandContion.length; i++) {
						var entity = {};
						entity.id = param.BrandContion[i].id;
						entity.name = param.BrandContion[i].name;
						SearchConditions.Brands.push(entity)
					}
				}

				if(param.Dest) {
					SearchConditions.Dests.Id = param.Dest.Id[0];
					SearchConditions.Dests.Name = param.Dest.Name;
					SearchConditions.Dests.Type = param.Dest.Type;
					SearchConditions.Dests.CityId = param.CityId;
					SearchConditions.Dests.CityName = param.Dest.Name.split('，');

					HotelCityId = param.CityId;
				}

				//初始化时间
				if(param.CheckList && param.CheckList.length == 2) {
					var start = param.CheckList[0];
					var end = param.CheckList[1];
					SearchConditions.Date.LeaveDate = start;
					SearchConditions.Date.ArriveDate = end;
				}

				if(!!data.Price && data.Price.length == 2) {
					SearchConditions.Prices.minval = parseInt(data.Price[0]);
					SearchConditions.Prices.maxval = parseInt(data.Price[1]);
				}
				if(data.FacilityList && data.FacilityList.length > 0) {
					SearchConditions.FacilityContion = data.FacilityContion;
					SearchConditions.FacilityList = data.FacilityList;
				}
				else{
					SearchConditions.FacilityContion = [];
					SearchConditions.FacilityList = [];
				}
				SearchConditions.StarRateList.stars = data.StarRateList;
			} else {
				app.showMsg("参数异常")
			}
		}

		function LoadHotel() {
			app.showWaiting('加载中...', 1);
			app.Post(SearchHotelListEntity, null, LoadHotelCallBack)
			LoadPage=true;
		}

		function LoadHotelCallBack(data) {
			if(app.GetResultState(data)) {
				SetDefaultValue(data);
				if(data.HotelList && data.HotelList.length > 0) {
					for(var i = 0; i < data.HotelList.length; i++) {
						var item = data.HotelList[i]
						item.ReviewScore = item.ReviewScore.replace("分", '');
						item.RenovationDate = item.RenovationDate.split('-')[0] + "年装修";
						data.HotelList[i] = item;
					}
					var tmplHot = template('hotelList-template', data);
					if(data.PageInfo.Index == 1) {
						$(".hotel-search-list-view").html(tmplHot);
						var tmplHot1 = template('headercondition-template', data.FiterType.Protocol);
						$(".hotel-search-header").html(tmplHot1);
						InitHeaderEvent();
						var tmplHot2 = template('rank-template', data);
						$(".hotel-search-ranklist").html(tmplHot2);
						rankEvent();
						app.showMsg(data.PageInfo.ResultAmount + "家酒店");
						mui(pullId).pullRefresh().enablePullupToRefresh();

					} else {
						$(".hotel-search-list-view").append(tmplHot);
					}
					InitDetailEvent();
					SearchHotelListEntity.PageInfo = data.PageInfo;
					if(data.PageInfo.Index == data.PageInfo.Amount || data.PageInfo.Size > data.HotelList.length) {
						mui(pullId).pullRefresh().disablePullupToRefresh();
						LoadCondition();
					} else {
						LoadPage = false;
					}
				}
				SearchHotelListEntity.PageInfo = data.PageInfo;
				app.ReplaceImgRequestHeader();
			} else {
				if(data.Code == "0001") {
					$(".hotel-search-list-view").html(LoadNoResult());
					LoadPage = false;
					SetDefaultValue(data);
					var tmplHot1 = template('headercondition-template', data.FiterType.Protocol);
					$(".hotel-search-header").html(tmplHot1);
					InitHeaderEvent();
					LoadCondition();
					var tmplHot2 = template('rank-template', data);
					$(".hotel-search-ranklist").html(tmplHot2);
					rankEvent();
				} else {
					if(SearchHotelListEntity.PageInfo.Index == 1) {
						$(".hotel-search-list-view").html(LoadNoResult());
					}
					app.showMsg(data.Msg)
				}
				mui(pullId).pullRefresh().disablePullupToRefresh();
			}
		}
		//获取下一页数据
		function GetNextPageData() {
			if(LoadPage)
				return;
			LoadPage = true;
			SearchHotelListEntity.data.Page.Index = SearchHotelListEntity.PageInfo.Index + 1;
			SearchHotelListEntity.data.Page.Size = SearchHotelListEntity.PageInfo.Size;
			LoadHotel();
		}

		function InitHeaderEvent() {
			$(".hotel-search-header-title").on("tap", function() {
				if($(this).hasClass("current"))
					$(this).removeClass("current")
				else
					$(this).addClass("current")

				SearchHotelListEntity.data.ProtocolList = []

				$(".hotel-search-header-title").each(function(item, index) {
					if($(this).hasClass("current")) {
						SearchHotelListEntity.data.ProtocolList.push($(this).attr("id"))
					}
				})

				getList();
			})
		}

		function InitDetailEvent() {
			$(".hotel-search-detail-view").off().on("tap", function() {
				var id = $(this).attr("id");
				
				app.ShowWebView(projectConfig.ViewId.Hotel.ScatteredDetail.url,{
					Hid: id,
					cityId: HotelCityId
				},null,projectConfig.ViewId.Hotel.ScatteredDetail.Id);
//				app.CanSetOrder(projectConfig.ViewId.Hotel.ScatteredDetail,{
//					Hid: id,
//					cityId: HotelCityId
//				});
			});
		}

		//加载无结果样式
		function LoadNoResult() {
			return '<div class="no-list-msg">' +
				'<div class="no-icon">' +
				'	<img src="../images/no-list-icon.png" />' +
				'</div>' +
				'<div class="no-msg">' +
				'	搜索无结果' +
				'</div>' +
				'</div>';
		}
		//加载搜索条件
		function LoadCondition(type) {
			var conditions = [];
			var entity = SearchConditions;
			entity.List = []

			if(entity.Dests.Type != 0 && entity.Dests.Type != 1) {
				var condition = {}
				condition.Type = "dest";
				condition.Name = entity.Dests.Name;
				condition.Id = entity.Dests.Id;
				entity.List.push(condition);
			}

			if(entity.FacilityContion && entity.FacilityContion.length > 0) {
				for(k = 0; k < entity.FacilityContion.length; k++) {
					var condition = {}
					condition.Type = "facility";
					condition.Name = entity.FacilityContion[k].name;
					condition.Id = entity.FacilityContion[k].id;
					entity.List.push(condition);
				}
			}
			if(entity.Prices) {
				var Prices = app.model.Prices || {};
				for(var i = 0; i < Prices.length; i++) {
					if(Prices[i].minval == entity.Prices.minval && Prices[i].maxval == entity.Prices.maxval) {
						if(Prices[i].sort > 0) {
							var condition = {}
							condition.Type = "price";
							condition.Name = Prices[i].name;
							condition.Id = Prices[i].sort;
							entity.List.push(condition);
							entity.Prices.name = Prices[i].name;
						}
					}
				}
			}
			if(entity.StarRateList && entity.StarRateList.stars) {
				for(var n = 0; n < entity.StarRateList.stars.length; n++) {
					if(entity.StarRateList.stars[n] != 0 && entity.StarRateList.stars[n] != null) {
						var star = GetStarsModel(entity.StarRateList.stars[n]);
						var condition = {}
						condition.Type = "star";
						condition.Name = star.name;
						condition.Id = star.val;
						entity.List.push(condition);
						entity.StarRateList.showstar = star.name + "、";
					}
				}
				if(entity.StarRateList.showstar.length > 0)
					entity.StarRateList.showstar = entity.StarRateList.showstar.substr(entity.StarRateList.showstar.length - 1, 1)
			}
			if(entity.Keywords) {
				var condition = {}
				condition.Type = "key";
				condition.Name = entity.Keywords;
				condition.Id = 0;
				entity.List.push(condition);
			}
			if(entity.Keys && entity.Keys.length > 0 && entity.Keys[0].name) {
				var condition = {}
				condition.Type = "hotel";
				condition.Name = entity.Keys[0].name;
				condition.Id = entity.Keys[0].id;
				entity.List.push(condition);
			}
			if(entity.Brands && entity.Brands.length) {
				for(j = 0; j < entity.Brands.length; j++) {
					if(!!entity.Brands[j].name) {
						var condition = {}
						condition.Type = "brand";
						condition.Name = entity.Brands[j].name;
						condition.Id = entity.Brands[j].id;
						entity.List.push(condition);
					}
				}
			}

			if(entity.Dis > 0) {
				var condition = {}
				condition.Type = "dis";
				condition.Name = entity.Dis + "内";
				condition.Id = entity.Dis;
				entity.List.push(condition);
			}
			var tmplHot1 = template('condition-template', entity);
			$(".hotel-search-conditionview").html(tmplHot1)
			ConditionEvent();
		}

		function ConditionEvent() {
			$(".hotel-search-condition").on("tap", function() {
				var type = $(this).attr("type");
				var val = $(this).attr("id");
				SetCondition(type, val);
				getList();
			})
		}

		function SetCondition(type, val) {
			switch(type) {
				case "dest":
					SearchConditions.Dests.Name = SearchConditions.Dests.CityName;
					SearchConditions.Dests.Id = SearchConditions.Dests.CityId;
					SearchConditions.Dests.Type = 1;
					SearchHotelListEntity.data.Dest.Type = 1;
					SearchHotelListEntity.data.Dest.Id = []
					SearchHotelListEntity.data.Dest.Id.push(SearchConditions.Dests.CityId)
					break;
				case "facility":
					var facility1 = []
					var facility2 = []
					var facility3 = []

					for(var i = 0; i < SearchConditions.FacilityList.length; i++) {
						if(SearchConditions.FacilityList[i] != val) {
							facility1.push(SearchConditions.FacilityContion[i])
							facility3.push(SearchConditions.FacilityList[i])
						}
						if(SearchHotelListEntity.data.FacilityList[i] != val) {
							facility2.push(SearchHotelListEntity.data.FacilityList[i])
						}
					}
					SearchConditions.FacilityList = facility3
					SearchConditions.FacilityContion = facility1
					SearchHotelListEntity.data.FacilityList = facility2

					break;
				case "price":
					SearchHotelListEntity.data.Price = []
					SearchConditions.Prices = []
					break;
				case "star":
					var star1 = []
					var star2 = []
					for(var i = 0; i < SearchConditions.StarRateList.stars.length; i++) {
						if(SearchConditions.StarRateList.stars[i] != val) {
							star1.push(SearchConditions.StarRateList.stars[i])
						}
						if(SearchHotelListEntity.data.StarRateList[i] != val) {
							star2.push(SearchHotelListEntity.data.StarRateList[i])
						}
					}
					SearchHotelListEntity.data.StarRateList = star2
					SearchConditions.StarRateList.stars = star1
					break;
				case "brand":
					var brand1 = [];
					var brand2 = [];
					var brand3 = [];
					for(var i = 0; i < SearchConditions.Brands.length; i++) {
						if(SearchHotelListEntity.data.BrandList[i] != val) {
							brand1.push(SearchHotelListEntity.data.BrandList[i]);
							brand2.push(SearchConditions.Brands[i]);
						}
					}
					SearchConditions.Brands = brand2;
					//SearchConditions.BrandContion=brand3;
					SearchHotelListEntity.data.BrandList = brand1;
					break;
				case "dis":
					SearchConditions.Dis = 0
					SearchHotelListEntity.data.Dis = 0
					break;
				case "key":
					SearchConditions.Keywords = "";
					SearchHotelListEntity.data.Keywords = "";
					break;
				case "hotel":
					SearchConditions.Keys = []
					SearchHotelListEntity.data.Key = {}
					break;
			}

			var settings = app.getSettings();
			settings.HotelSearchParam = SearchHotelListEntity
			app.setSettings(settings)
		}

		function GetStarsModel(val) {
			var Stars = app.model.Stars;
			for(var i = 0; i < Stars.length; i++) {
				if(Stars[i].val == val) {
					return Stars[i];
				}
			}
		}

		function SetDefaultValue(data) {
			var defaultEntity = {}
			defaultEntity.CityId = SearchConditions.Dests.CityId;
			defaultEntity.CityName = SearchHotelListEntity.data.Dest.Name;
			defaultEntity.Dest = SearchHotelListEntity.Dest;
			defaultEntity.Rank = data.RankList;
			defaultEntity.price = SearchHotelListEntity.data.Price;
			defaultEntity.star = SearchHotelListEntity.data.StarRateList;

			defaultEntity.Facilitys = SearchHotelListEntity.data.FacilityList;
			defaultEntity.Brands = SearchHotelListEntity.data.BrandList;
			defaultEntity.Protocols = SearchHotelListEntity.data.ProtocolList;
			var parentWs = app.GetParentView();

			parentWs.evalJS('window.ScatteredHotelList.ShowDefault(' + JSON.stringify(defaultEntity) + ')');
		}

		function removeByValue(arr, val) {
			for(var i = 0; i < arr.length; i++) {
				if(arr[i] == val) {
					arr.splice(i, 1);
					break;
				}
			}
		}

		// 排序控制
		function showRankView() {
			$(".hotel-search-rankview").show();
			$(".hotel-search-rankback").show();
		}

		function hideRankView() {
			$(".hotel-search-rankview").hide();
			$(".hotel-search-rankback").hide();
		}

		function rankEvent() {
			$(".hotel-search-rankdetail").on("tap", function() {
				$(".hotel-search-rankdetail").removeClass("hotel-search-rankchecked");
				$(".hotel-search-rankdetail").find("img").hide();
				$(this).addClass("hotel-search-rankchecked");
				$(this).find("img").show();

				$(".hotel-search-rankview").hide();
				$(".hotel-search-rankback").hide();
				var pview = app.GetParentView();
				pview.evalJS("window.ScatteredHotelList.hideRank()");

				var val = $(this).attr("id");
				SearchHotelListEntity.data.Rank = val
				getList();
			})

			$(".hotel-search-rankback").on("tap", function() {
				$(".hotel-search-rankview").hide();
				$(".hotel-search-rankback").hide();
				var pview = app.GetParentView();
				pview.evalJS("window.ScatteredHotelList.hideRank()");
			})
		}

		//dest 回调
		function destReBack(id, name, type, cityId) {
			var settings = app.getSettings();
			SearchHotelListEntity.data.Dest.Type = type == 0 ? 1 : type;
			SearchHotelListEntity.data.Dest.Id = [];
			SearchHotelListEntity.data.Dest.Id.push(id);
			SearchHotelListEntity.data.Dest.Name = name;

			SearchHotelListEntity.Key = settings.searchparam1.Key; // 重置酒店名称查询条件

			SearchConditions.Dests.Id = id;
			SearchConditions.Dests.Name = name;
			SearchConditions.Dests.Type = type == 0 ? 1 : type;
			SearchConditions.Dests.CityId = cityId;
			SearchConditions.Dests.CityName = name.split('，');

			HotelCityId = cityId;
			getList();
		}

		function getList() {
			LoadPage = false
			$(".hotel-search-list-view").html("");
			$(".hotel-search-conditionview").html("");
			SearchHotelListEntity.PageInfo.Index = 0;
			mui('#pullrefresh').pullRefresh().refresh(true);

			var settings = app.getSettings();
			settings.HotelSearchParam = SearchHotelListEntity;
			app.setSettings(settings);
			GetNextPageData();
		}

		function setParam() {
			var settings = app.getSettings();
			SearchHotelListEntity = settings.HotelSearchParam;
			getList();
			initParam(2);
		}

		return {
			pullId: pullId,
			init: init,
			GetNextPageData: GetNextPageData,
			showRankView: showRankView,
			hideRankView: hideRankView,
			destReBack: destReBack,
			setParam: setParam,
			LoadNoResult: LoadNoResult
		}
	})();
})(window, $);