app.yyDestination = {
	isFisrt:false,
	tabType:0,
	id: {
		tab: 'yy_tab', // 热门搜索-国内国际切换容器
		history: 'yy_history_list', // 热门搜索-历史列表容器
		hot: 'yy_hot_list_', // 热门搜索-热门列表容器
		c: 'yy_scroll_body', // 页面总容器
		fuzzyC: 'fuzzy_search', // 模糊查询总容器
		hotC: 'hot_search', // 热门搜索总容器
		gotoFuzzy: 'goto_fuzzySearch', // 跳转模糊搜索
		gotoHot: 'goto_hotSearch', // 跳转热门搜索
		fuzzyInput: 'fuzzy_search_input', // 模糊搜索框
		clearInput: 'fuzzy_search_clear', // 清空模糊搜索框
		fuzzy: 'fuzzy_search_list' // 模糊查询 列表容器
	},
	css: {
		curr: 'curr', // 当前被选中元素
		tabItem: 'tab-content-item', // 和tab匹配的内容容器
		chooseItem: 'choose-item', // 所有可以选择的搜索项及历史
		history: 'history' // 历史容器
	},
	init: function(currId, setCityFnName, sore) {
		var self = app.yyDestination;
		self.setCityFnName = setCityFnName;
		self.sore = sore;
		if(sore == "m") {
			$(".yy-home-header-title").html("选择目的地");
			yyFramework.destinationHistroy.cookieName = "MICE_destinationHistroy";
		}
		else if(sore == "s") {
			$(".yy-home-header-title").html("选择出发地");
			$("#fuzzy_search_input").attr("placeholder","请输入出发地(如苏州/suzhou/sz)");
			$("#goto_fuzzySearch_input").html("请输入出发地(如苏州/suzhou/sz)");
			yyFramework.destinationHistroy.cookieName = "Trips_destinationHistroy";
		}
		else if(sore == "e") {
			$(".yy-home-header-title").html("选择目的地");
			yyFramework.destinationHistroy.cookieName = "Tripe_destinationHistroy";
		}

		self.render(function() {
			self.initTab();
			self.initChoose();
			self.setActive(currId);
			self.initSwitchSearch();
			self.initFuzzySearch();
			mui("#" + self.id.c).scroll();
		});
	},
	render: function(afterFn) {
		var self = app.yyDestination;
		self.getHotData(0, function(res) {
			self.renderHistory.call(self);
			self.renderHot.call(self, 0, res);
			afterFn.call(self);
		});
	},
	initFuzzySearch: function() {
		var self = app.yyDestination;
		var $list = app.$el(self.id.fuzzy);
		$list.html('');
		
		var $clear = app.$el(self.id.clearInput);
		var $input = app.$el(self.id.fuzzyInput);
		$input.off().on('input', yyFramework.debounce(function() {
			var key = $input.val();
			if(key.length == 0) {
				$clear.hide();
			} else {
				$clear.show();
			}
			self.fuzzySearchGUID = new yyFramework.GUID().newGUID(); // 防止重复渲染
			self.getFuzzyData(key, self.fuzzySearchGUID, function(data) {
				self.renderFuzzy(data);
			});
		}, 300)); // 300ms延时，防止搜索过快 
		
		$clear.off().on('tap', function() {
			var self = app.yyDestination;
			var $list = app.$el(self.id.fuzzy);
			$list.html('');
			$input.val('');
			$clear.hide();
		});
	},
	renderFuzzy: function(data) {
		var self = app.yyDestination;
		var $list = app.$el(self.id.fuzzy);
		$list.html('');
		var $input = app.$el(self.id.fuzzyInput);
		if(data.length == 0) {
			if($input.val().length == 0)
			{
				$list.html('');
			}else{
				$list.html('<li><p class="no-result">暂无匹配结果</p></li>');
			}
			
		} else {
			$list.html(template('t_yy_destination_fuzzy_item', {
				data: data
			}));
		}
	},
	renderHistory: function() {
		if(!yyFramework.destinationHistroy.isEmpty()) { // 存在历史记录
			app.$el(this.id.history).html(template('t_yy_destination_hot_item', {
				data: yyFramework.destinationHistroy.get()
			}));
			app.$el(this.css.history).show();
		}
	},
	renderHot: function(id, data) {
		app.$el(this.id.hot + id).html(template('t_yy_destination_hot_item', {
			data: data.DestList
		}));
	},
	initTab: function() {
		var self = app.yyDestination;
		var $items = app.$el(self.css.tabItem);
		app.$el(self.id.tab).off().on('tap', 'li', function() {
			var $this = $(this);
			var type = $this.attr('data-type');
			self.tabType = type;
			if(!$this.hasClass(self.css.curr)) {
				$this.addClass(self.css.curr).siblings().removeClass(self.css.curr);
				$items.hide();
				app.$el(self.id.hot + type).show();
				if(type == '1' && !$this.data('hasData')) { // 如果是国际，且未加载过数据
					self.getHotData(1, function(res) {
						$this.data('hasData', true);
						self.renderHot.call(self, 1, res);
					});
				}
			}
		});
	},
	initChoose: function() {
		var self = app.yyDestination;
		app.$el(self.id.c).off().on('tap', '.' + self.css.chooseItem, function() {
			var $this = $(this);
			var Type = $this.attr('data-type');
			var Id = $this.attr('data-id');
			var Name = $this.attr('data-name');
			var d = {
				Type: Type,
				Id: Id,
				Name: Name,
				sore: self.sore
			};

			yyFramework.destinationHistroy.set(d);

			var subView;
			if(self.sore == "m") {
				subView=plus.webview.getWebviewById(projectConfig.ViewId.MICE.index.Id);
			} else if(self.sore == "s") {
				subView=plus.webview.getWebviewById(projectConfig.ViewId.Trip.Index.Id);
			} else if(self.sore == "e") {
				subView=plus.webview.getWebviewById(projectConfig.ViewId.Trip.Index.Id);
			}

			var v = JSON.stringify(d);
			subView.evalJS(self.setCityFnName + "(" + v + ")");
			mui.back();

		});

	},
	gotoSearch: function() {
		var self = app.yyDestination;
	},
	setActive: function(currId) {
		var self = app.yyDestination;
		if(currId)
			app.$el(self.id.c).find('[data-id="' + currId + '"]').addClass(self.css.curr);
	},
	initSwitchSearch: function() {
		var self = app.yyDestination;
		var $fuzzy = app.$el(self.id.fuzzyC);
		var $hot = app.$el(self.id.hotC);
		var $gotofuzzy = app.$el(self.id.gotoFuzzy);
		var $gotohot = app.$el(self.id.gotoHot);
		$gotofuzzy.off().on('tap', function() {
			$hot.hide();
			$fuzzy.show();
		});
		$gotohot.off().on('tap', function() {
			$("#"+self.id.fuzzyInput).blur();
			$hot.show();
			$fuzzy.hide();
		});
	},
	getFuzzyData: function(key, guid, fn) {
		var self = app.yyDestination;
		
		var data = {
			url: projectConfig.apiName.SearchDestinationList,
			data: {
				Key: key,
				IsNeedForeign:self.tabType
			}
		};
		app.Post(data, null, function(res) {
			if(guid == self.fuzzySearchGUID) { // 防止重复渲染
				if(app.GetResultState(res)) {
					fn(res.DestList);
				} else {
					fn([]);
				}
			}
		});
	},
	getHotData: function(type, fn) {
		var data = {
			url: projectConfig.apiName.GetDestinationList,
			data: {
				DestReqType: 'hot',
				IsNeedForeign: type
			}
		};
		app.Post(data, null, function(res) {
			if(app.GetResultState(res)) {
				fn(res);
			} else {
				mui.alert(res.Msg, "提示", null, function() {})
			}
		});
	}
};