app.yyMICE = {
	idConfig: {
		city: 'Mice_city',
		dingwei: 'Mice_dingwei',
		time: 'Mice_time',
		peoples: 'Mice_peoples',
		username: 'Mice_username',
		mobile: 'Mice_mobile',
		subBtn: 'Mice_sub',
		back:'Mice_back'
	},
	init: function() {
		var self = app.yyMICE;
		self.initBack();
		self.initChooseCity();
		self.initSelectPeoples();
		self.initShowDelBtn();
		self.initDelInfo();
		self.initSub();
		self.initDialog();
		self.initDateRange({
			id: 'Mice_time'
		});

		self.currentPosition();
	},
	initBack: function() {
		var self = app.yyMICE;
		var $back = app.$el(self.idConfig.back);
		$back.off().on('tap',function(){
			mui.back();
		})
	},
	initDialog: function() {
		var self = app.yyMICE;
		var $peoplesRow = app.$el('.total-people');
		var $peoples = app.$el(self.idConfig.peoples);
		$peoplesRow.on('click', function() {
			var html = '';
			var listItem = self.getPeopleData().forEach(function(d, i) {
				html += app.format('<li class="{0}"><div class="name" data-people="{2}">{1}</div><div class="icon-box"><i class="icon icon-after ceekeefont danxuanzhong"></i></div></li>',
					d.value == $peoples.attr('data-people') ? 'active' : '', d.name, d.value);
			});
			layer.open({
				content: '<div class="p_yy_MICEHome_dialog">' +
					'			<ul class="peoples-list">' + html +
					'			</ul>' +
					'			<div class="close-peopleDialog">' +
					'				<span>关闭</span>' +
					'			</div>' +
					'		</div>',
				skin: 'footer'
			});
			app.$el('.p_yy_MICEHome_dialog').parent().css({
				background: 'none',
				padding: 'none'
			});
			self.initSelectPeoples();
		});
	},
	initSelectPeoples: function() {
		var self = app.yyMICE;
		var $peoplesItem = $('.p_yy_MICEHome_dialog ul li');
		var $peoplesClose = $('.p_yy_MICEHome_dialog .close-peopleDialog');
		var $peoples = app.$el(self.idConfig.peoples);
		$peoplesItem.off().on('tap', function() {
			var $this = $(this);
			$peoples.html($this.find('.name').text());
			$peoples.attr('data-people', $this.find('.name').attr('data-people'));
			console.log($peoples.attr('data-people'));
			layer.closeAll();
		});
		$peoplesClose.off().on('tap', function() {
			layer.closeAll();
		})
	},
	initChooseCity: function() {
		var self = app.yyMICE;
		app.$el(self.idConfig.city).off().on('tap', function() {
			var $this = $(this);
			app.ShowWebView(projectConfig.viewid.MICE.destination.url, {
				Id: $this.attr('data-id'),
				Type: $this.attr('data-type'),
				fnName: 'app.yyMICE.setCity'
			}, null, projectConfig.viewid.MICE.destination.Id);
		});
	},
	setCity: function(data) {
		var self = app.yyMICE;
		var $city = app.$el(self.idConfig.city);
		$city.attr('data-id', data.Id).attr('data-type', data.Type).find('.city-name').html(data.Name);
	},
	initShowDelBtn: function() {
		var self = app.yyMICE;
		var $pContent = $('.p_yy_MICEHome');
		var $inputRow = $pContent.find('.row-info input');
		$inputRow.on('input', function() {
			var $this = $(this);
			var $thisDelBtn = $this.parents('.row-info').eq(0).find('.flex-width .guanbi');
			if(!$this.val()) {
				$thisDelBtn.hide();
			} else {
				$thisDelBtn.show();
			}
		})
	},
	initDelInfo: function() {
		var self = app.yyMICE;
		var $pContent = $('.p_yy_MICEHome');
		var $del = $pContent.find('.row-info .guanbi').parent();
		$del.off().on('tap', function() {
			var $this = $(this);
			$this.parent().find('input').val('');
			$this.hide();
		});
	},
	initSub: function() {
		var self = app.yyMICE;
		var $pContent = $('.p_yy_MICEHome');
		var $city = app.$el(self.idConfig.city);
		var $time = app.$el(self.idConfig.time);
		var $peoples = app.$el(self.idConfig.peoples);
		var $username = app.$el(self.idConfig.username);
		var $mobile = app.$el(self.idConfig.mobile);
		var $sub = app.$el(self.idConfig.subBtn);
		$sub.off().on('tap', yyFramework.debounce(function() {
			var timeRange = $('#Mice_time').data('dateRange');
			var destId = $city.attr('data-id');
			var destType = $city.attr('data-type');
			var startTime = timeRange.JsonDate[0];
			var endTime = timeRange.JsonDate[1];
			var peoples = $peoples.attr('data-people');
			var username = $username.val();
			var mobile = $mobile.val();
			console.log(JSON.stringify($('#Mice_time').data('dateRange')))
			if(!destId || !destType) {
				plus.nativeUI.toast('请选择开会城市!');
				return;
			}
			if(!startTime || !endTime) {
				plus.nativeUI.toast('请选择开会时间!');
				return;
			}
			if(!$peoples) {
				plus.nativeUI.toast('请选择参会人数!');
				return;
			}
			if(!username) {
				plus.nativeUI.toast('请填写联系人!');
				$username.focus();
				return;
			}
			if(!mobile) {
				plus.nativeUI.toast('请填写手机号!');
				$mobile.focus();
				return;
			}
			if(!app.checkMobile(mobile)) {
				plus.nativeUI.toast('手机号格式不正确!');
				$mobile.focus();
				return false;
			}

			var data = {
				url: projectConfig.apiName.CreateMICEOrder,
				data: {
					Dest: {
						Id: destId,
						Type: destType
					},
					SchemeDate: {
						LeaveDate: startTime,
						GetBackDate: endTime
					},
					MeetingPerson: peoples,
					Contacts: username,
					ContactPhone: mobile
				}
			};
			app.Post(data, null, self.homeCallback);
		},300));
	},
	homeCallback: function(data) {
		var self = app.yyMICE;
		if(data.Code == '0000') {
			mui.confirm('会议需求单成功！', '', ['确定'], function(e) {
				var $peoples = app.$el(self.idConfig.peoples);
				$peoples.attr('data-people', self.getPeopleData()[1].value);
				$peoples.html(self.getPeopleData()[1].name);
				app.$el(self.idConfig.username).val('').parents('.row-info').eq(0).find('.guanbi').hide();
				app.$el(self.idConfig.mobile).val('').parents('.row-info').eq(0).find('.guanbi').hide();
			});
		} else {
			plus.nativeUI.toast(data.Msg);
		}

		console.log(data);
	},
	getPeopleData: function(data) {
		return [{
				name: '50人以下',
				value: '49'
			},
			{
				name: '50-100人',
				value: '100'
			},
			{
				name: '100-200人',
				value: '200'
			},
			{
				name: '200人以上',
				value: '201'
			},

		]
	},
	initDateRange: function(opts) {
		var dcScroll = null,
			wfScroll = null;
		var GroupType = 0;
		var sysDate;
		var sysDateJson;
		var $c = app.$el(opts.id);
		var _wfDate = (function() {
			(function(window, $) {
				window.WFCustomDate = (function() {
					//默认加载多少月数据包括本
					var defaultMonth = 3;
					var selectDate1;
					var selectDate2;
					var GroupType = 0;
					var dateJson = {
						nowYear: 0,
						nowMonth: 0,
						nowDay: 0,
						nowHours: 0,
						groupType: 0,
						dateList: []
					}

					function initDate(dates, sysDate, Type) {
						dateJson = {
							nowYear: 0,
							nowMonth: 0,
							nowDay: 0,
							nowHours: 0,
							groupType: 0,
							dateList: []
						}
						//团房 14后预订
						GroupType = Type;
						//初始化dates数据
						loadDates(sysDate, dates);

						var now = new Date();
						if(sysDate)
							now = sysDate

						dateJson.groupType = GroupType;
						dateJson.nowYear = now.getFullYear();
						dateJson.nowDay = now.getDate();
						dateJson.nowHours = now.getHours();

						var newnow;
						if(dateJson.nowDay > 28) {
							newnow = app.DateTool.DateAdd("d", -5, now);
						} else {
							newnow = now;
						}
						dateJson.nowMonth = newnow.getMonth() + 1;
						newnow = new Date(newnow)
						for(var i = 0; i < defaultMonth; i++) {
							if(i == 0)
								newnow.setMonth(newnow.getMonth());
							else
								newnow.setMonth(newnow.getMonth() + 1);
							var monthItem = GetItems(newnow, now);
							dateJson.dateList.push(monthItem);
						}
						return dateJson;
					}

					function loadDates(mydate, dates) {
						var startdate = '',
							enddate = '';
						if(!!dates && dates.length == 2 && !!dates[0]) {
							if(dates.length == 1 && dates[0].length > 0) {
								startdate = dates[0];
							} else if(dates.length > 1) {
								startdate = dates[0];
								enddate = dates[dates.length - 1];
							}

							var newstart = new Date(startdate.replace(/-/g, "/"));
							var newyears = newstart.getFullYear();
							var newmonth = newstart.getMonth() + 1;
							var newday = newstart.getDate();
							//当天日期
							var year = mydate.getFullYear();
							var month = mydate.getMonth() + 1;
							var day = mydate.getDate();

							var todayDate = new Date((year + "-" + month + "-" + day).replace(/-/g, "/"));

							if(newstart.getTime() < todayDate.getTime() || (newstart.getTime() == todayDate.getTime() && mydate.getHours() >= 14)) {
								var startStr = app.DateTool.DateAdd("d", 0, mydate);

								var year2 = app.DateTool.DatePart('y', startStr);
								var month2 = app.DateTool.DatePart('m', startStr);
								var day2 = app.DateTool.DatePart('d', startStr);
								startdate = year2 + "-" + month2 + "-" + day2;
							}

							var newstartdate = new Date(startdate.replace(/-/g, "/"));
							var newstartyear = newstartdate.getFullYear();
							var newstartmonth = newstartdate.getMonth() + 1;
							var newstartday = newstartdate.getDate();

							var newend = new Date(enddate.replace(/-/g, "/"));
							var newendyears = newend.getFullYear();
							var newendmonth = newend.getMonth() + 1;
							var newendday = newend.getDate();

							if(newend <= newstartdate) {
								var endStr = app.DateTool.DateAdd("d", 1, mydate);
								if(GroupType == 2) {
									if(mydate.getHours() >= 14) {
										endStr = app.DateTool.DateAdd("d", 2, mydate);
									}
								}

								var year = app.DateTool.DatePart('y', endStr);
								var month = app.DateTool.DatePart('m', endStr);
								var day = app.DateTool.DatePart('d', endStr);
								enddate = year + "-" + month + "-" + day;
							}
						} else {
							var year = app.DateTool.DatePart('y', mydate);
							var month = app.DateTool.DatePart('m', mydate);
							var day = app.DateTool.DatePart('d', mydate);
							startdate = year + "-" + month + "-" + day;
							endStr = app.DateTool.DateAdd("d", 1, mydate);
							year = app.DateTool.DatePart('y', endStr);
							month = app.DateTool.DatePart('m', endStr);
							day = app.DateTool.DatePart('d', endStr);
							enddate = year + "-" + month + "-" + day;
						}

						selectDate1 = new Date(startdate.replace(/-/g, "/"));
						selectDate2 = new Date(enddate.replace(/-/g, "/"));

						SetShowDate(selectDate1, selectDate2, mydate);
					}

					function GetItems(date, sysDate) {
						var dateListItem = {
							year: 0,
							month: 0,
							days: []
						}

						dateListItem.year = date.getFullYear();
						dateListItem.month = date.getMonth() + 1;

						//填充空数
						var firstDayOfWeek = getFirstDayOfWeek(dateListItem.year, dateListItem.month);
						if(firstDayOfWeek > 0) {
							for(var i = 0; i < firstDayOfWeek; i++) {
								var dayItem = {
									fulldate: "",
									day: 0,
									week: "",
									isSelect: false
								}
								dateListItem.days.push(dayItem);
							}
						}

						//遍历该月数据
						const thisMonthDays = getThisMonthDays(date.getFullYear(), date.getMonth() + 1);
						for(var i = 1; i <= thisMonthDays; i++) {
							var dayItem = {
								fulldate: "",
								day: 0,
								week: "",
								isSelect: false
							}
							var ndate = new Date(date.getFullYear(), date.getMonth(), i);
							var sday;
							if(i < 10) {
								sday = "0" + i;
							} else {
								sday = i;
							}

							var nmonth = date.getMonth() + 1;
							var nmstr;
							if(nmonth < 10) {
								nmstr = "0" + nmonth;
							} else {
								nmstr = nmonth;
							}

							dayItem.fulldate = date.getFullYear() + "-" + nmstr + "-" + sday;
							dayItem.day = i;

							dayItem.week = app.DateTool.DateToWeek(ndate, sysDate);
							if(date.getFullYear() == selectDate1.getFullYear() && date.getMonth() == selectDate1.getMonth() && i == selectDate1.getDate()) {
								dayItem.isSelect = true;
							}

							if(date.getFullYear() == selectDate2.getFullYear() && date.getMonth() == selectDate2.getMonth() && i == selectDate2.getDate()) {
								dayItem.isSelect = true;
							}

							dateListItem.days.push(dayItem);
						}

						return dateListItem;
					}

					function getThisMonthDays(year, month) {
						return new Date(year, month, 0).getDate();

					}

					function getFirstDayOfWeek(year, month) {
						return new Date(Date.UTC(year, month - 1, 1)).getDay();
					}

					function loadBind() {
						var items = $("#wf-indexContent .check-select-date.day-active");
						var startItem = $(items[0]);
						startItem.addClass("day-active-start");
						if(startItem.find(".day-ac").hasClass("day-right")) {
							startItem.addClass("das-no");
						}

						startItem.find(".box-color").html("开始");
						var endItem = $(items[1]);
						endItem.addClass("day-active-end");
						if(endItem.find(".day-ac").hasClass("day-left")) {
							endItem.addClass("das-no");
						}
						endItem.find(".box-color").html("结束");
						startItem.nextUntil("#wf-indexContent .day-active").addClass("dayg-active");
						endItem.prevUntil("#wf-indexContent .day-active").addClass("dayg-active");
					}

					return {
						initDate: initDate,
						loadBind: loadBind
					}
				})();
			})(window, $);

			function initDateRangeJson(data) {
				var selectDate;
				if(!sysDate) {
					sysDate = new Date();
					if(app.GetResultState(data)) {
						try {
							sysDate = new Date(data.Now.replace(/-/g, "/"));
						} catch(e) {
							sysDate = new Date();
						}
					}
				}
				sysDateJson = data;

				var settings = $c.data('dateRange') || {};
				var yyDestinationDateJson = settings.yyDestinationDateJson;
				var JsonDate;
				if(yyDestinationDateJson) {
					JsonDate = yyDestinationDateJson.JsonDate;
				}
				//验证日期有效�
				loadDates(sysDate, JsonDate);

				var jsonDate = window.WFCustomDate.initDate(JsonDate, sysDate, GroupType);
				var tmplHot = template('wf-date-template', jsonDate);
				$("#wf-indexContent").html('');
				$("#wf-indexContent").html(tmplHot);
				window.WFCustomDate.loadBind();
				//自动选中
				var $_d_curr = $("#wf-indexContent .check-select-date.day-active");
				var $qu = $($_d_curr[0]);
				var $fan = $($_d_curr[1]);
				$qu.find(".box-color").html("开始");
				$fan.find(".box-color").html("结束");
				$("#wf-indexContent .check-select-date").off().on("tap", function() {
					var $active = $("#wf-indexContent .check-select-date.day-active")
					if($active.length == 2) {
						$("#wf-indexContent .box-color").html("");
						$active.removeClass("das-no");
						$active.removeClass("day-active");
						$("#wf-indexContent .check-select-date.dayg-active").removeClass("dayg-active");
						$("#wf-indexContent .check-select-date.day-active-start").removeClass("day-active-start");
						$("#wf-indexContent .check-select-date.day-active-end").removeClass("day-active-end");
					}
					$(this).addClass("day-active");

					if($("#wf-indexContent .check-select-date.day-active").length == 2) {
						$(".wf-date-shade").hide();
						$(".wf-datecalendar").slideToggle(200);
						var items = $("#wf-indexContent .check-select-date.day-active");
						var startItem = $(items[0]);
						startItem.addClass("day-active-start");
						if(startItem.find(".day-ac").hasClass("day-right")) {
							startItem.addClass("das-no");
						}

						startItem.find(".box-color").html("开始");
						var endItem = $(items[1]);
						endItem.addClass("day-active-end");
						if(endItem.find(".day-ac").hasClass("day-left")) {
							endItem.addClass("das-no");
						}
						endItem.find(".box-color").html("结束");
						startItem.nextUntil(".day-active").addClass("dayg-active");
						endItem.prevUntil(".day-active").addClass("dayg-active");

						var startdate = startItem.attr("data-fulldate");
						var enddate = endItem.attr("data-fulldate");
						var iday = app.DateTool.datedifference(startdate, enddate);

						var nea = new Array();
						nea.push(startdate);
						nea.push(enddate);

						SetShowDate(startdate, enddate, sysDate);
						var DepartDate = {}
						DepartDate.date = startdate;
						DepartDate.dateShow = moment(startdate).format('YYYY-MM-DD');
						DepartDate.week = app.DateTool.DateToWeek(new Date(startdate), sysDate);
						var ArriveDate = {}
						ArriveDate.date = enddate;
						ArriveDate.dateShow = moment(enddate).format('YYYY-MM-DD');
						ArriveDate.week = app.DateTool.DateToWeek(new Date(enddate), sysDate);
						var yyDestinationDateJson = {}
						yyDestinationDateJson.JsonDate = nea;
						yyDestinationDateJson.DepartDate = DepartDate
						yyDestinationDateJson.ArriveDate = ArriveDate
						settings.yyDestinationDateJson = yyDestinationDateJson;
						$c.data('dateRange', yyDestinationDateJson);
					}
				});
			}

			function SetShowDate(startDate, endDate, sysDate) {
				var _sDate = typeof startDate == 'string' ? startDate.replace(/-/g, '/') : moment(startDate);
				var tpl = '<div class="start-date">' +
					'									<p>开始</p>' +
					'									<div><span class="date">{0}</span><span class="week">{1}</span></div>' +
					'								</div>' +
					'								<!--<div class="total-date">共<span class="date-num">{4}</span>天</div>-->' +
					'								<div class="total-date"><span>共{4}天</span></div>' +
					'								<div class="end-date">' +
					'									<p>结束</p>' +
					'									<div><span class="date">{2}</span><span class="week">{3}</span></div>' +
					'								</div>';
				$("#Mice_time").html(app.format(tpl,
					moment(_sDate).format('MM月DD日'),
					app.DateTool.DateToWeek(new Date(startDate), sysDate),
					moment(endDate).format('MM月DD日'),
					app.DateTool.DateToWeek(new Date(endDate), sysDate),
					moment(endDate).diff(moment(_sDate), 'days')+1
				));
			}

			function loadDates(mydate, dates) {
				var startdate = '',
					enddate = '';

				if(!!dates && dates.length == 2 && !!dates[0]) {
					if(dates.length == 1 && dates[0].length > 0) {
						startdate = dates[0];
					} else if(dates.length > 1) {
						startdate = dates[0];
						enddate = dates[dates.length - 1];
					}

					var newstart = new Date(startdate.replace(/-/g, "/"));
					var newyears = newstart.getFullYear();
					var newmonth = newstart.getMonth() + 1;
					var newday = newstart.getDate();
					//当天日期
					var year = mydate.getFullYear();
					var month = mydate.getMonth() + 1;
					var day = mydate.getDate();

					var todayDate = new Date((year + "-" + month + "-" + day).replace(/-/g, "/"));

					if(newstart.getTime() < todayDate.getTime() || (newstart.getTime() == todayDate.getTime() && mydate.getHours() >= 14)) {
						var startStr = app.DateTool.DateAdd("d", 0, mydate);
						if(GroupType == 2) {
							if(mydate.getHours() >= 14) {
								startStr = app.DateTool.DateAdd("d", 1, mydate);
							}
						}

						var year2 = app.DateTool.DatePart('y', startStr);
						var month2 = app.DateTool.DatePart('m', startStr);
						var day2 = app.DateTool.DatePart('d', startStr);
						startdate = year2 + "-" + month2 + "-" + day2;
					}

					var newstartdate = new Date(startdate.replace(/-/g, "/"));
					var newstartyear = newstartdate.getFullYear();
					var newstartmonth = newstartdate.getMonth() + 1;
					var newstartday = newstartdate.getDate();

					var newend = new Date(enddate.replace(/-/g, "/"));
					var newendyears = newend.getFullYear();
					var newendmonth = newend.getMonth() + 1;
					var newendday = newend.getDate();

					if(newend <= newstartdate) {
						var endStr = app.DateTool.DateAdd("d", 1, mydate);

						var year = app.DateTool.DatePart('y', endStr);
						var month = app.DateTool.DatePart('m', endStr);
						var day = app.DateTool.DatePart('d', endStr);
						enddate = year + "-" + month + "-" + day;
					}
				} else {
					var startStr = app.DateTool.DateAdd("d", 0, mydate);
					var year = app.DateTool.DatePart('y', startStr);
					var month = app.DateTool.DatePart('m', startStr);
					var day = app.DateTool.DatePart('d', startStr);
					startdate = year + "-" + month + "-" + day;
					var endStr = app.DateTool.DateAdd("d", 1, mydate);
					year = app.DateTool.DatePart('y', endStr);
					month = app.DateTool.DatePart('m', endStr);
					day = app.DateTool.DatePart('d', endStr);
					enddate = year + "-" + month + "-" + day;
				}

				var nea = new Array();
				nea.push(startdate);
				nea.push(enddate);
				var settings = $c.data('dateRange') || {};
				var DepartDate = {}
				DepartDate.date = startdate;
				DepartDate.dateShow = moment(startdate).format('YYYY-MM-DD');
				DepartDate.week = app.DateTool.DateToWeek(new Date(startdate), mydate);
				var ArriveDate = {}
				ArriveDate.date = enddate;
				ArriveDate.dateShow = moment(enddate).format('YYYY-MM-DD');
				ArriveDate.week = app.DateTool.DateToWeek(new Date(enddate), mydate);

				var yyDestinationDateJson = {}
				yyDestinationDateJson.JsonDate = nea;
				yyDestinationDateJson.DepartDate = DepartDate
				yyDestinationDateJson.ArriveDate = ArriveDate
				settings.yyDestinationDateJson = yyDestinationDateJson;
				$c.data('dateRange', yyDestinationDateJson);
			}

			function reCallbackDate(date, type) {
				var that = this;
				getDate(date[0], 'start');
				getDate(date[1], 'end');
			}

			function getDate(date, type) {
				var month = app.DateTool.DateFormat("MM", date);
				var day = app.DateTool.DateFormat("dd", date);
				var week = app.DateTool.DateFormat("w", date);

				var str = month + "月" + day + "日" + '<span class="date-item-week">' + week + '</span>';

				if(type == 'start') {
					$("#startdate").html(str);
				} else if(type == 'end') {
					$("#enddate").html(str);
				}
			}
			
			
			
			return {
				init: function() {
					wfScroll = mui("#wf-dateScroll").scroll();
					$("#Mice_time").off().on('tap', function() {
						$(".wf-date-shade").show();
						$(".wf-datecalendar").slideToggle(200);
					});

					$(".wf-date-shade").off().on("tap", function() {
						$(".wf-date-shade").hide();
						$(".wf-datecalendar").slideToggle(200);
					});
					app.GetServicesTime(initDateRangeJson);
					
					//点击定位
					$("#Mice_dingwei").off().on('tap',function(){
						var self = app.yyMICE;
						self.currentPosition();
					});
				},
				initDateRangeJson: initDateRangeJson,
				SetShowDate: SetShowDate
			}

		})();

		_wfDate.init();
	},
	currentPosition:function()
			{
				plus.geolocation.getCurrentPosition(function(p) {
	
					var cityName = p.address.city;
	
					var searchDetail = {
						Type: 0,
						Id: 0,
						Name: ''
					};
					var sCurrent = {
						url: projectConfig.apiName.GetDestinationList,
						data: {
							DestReqType: "current",
							DestList: []
						}
					};
					searchDetail.Type = 1;
					searchDetail.Name = cityName;
					searchDetail.Id = 0;
					sCurrent.data.DestList.push(searchDetail);
					var sendData = {
						url: sCurrent.url,
						data: sCurrent.data
					}
					app.showWaiting('定位中...', 0);
					app.Post(sendData, null, function(data) {
						var id = data.DestList[0].Id;
						var name = data.DestList[0].Name;
						var type = data.DestList[0].Type;
						var cityId = data.DestList[0].CityId;
						var Dest = {
							Type: data.DestList[0].Type,
							Id: cityId,
							Name: data.DestList[0].Name
						}
						var self = app.yyMICE;
						self.setCity(Dest);
					})
	
				}, function(e) {
					//app.renderNoResult("定位服务被禁用", '', null, null, $("#" + tabId));
					mui.alert("该项服务需要使用定位功能，请重启定位服务", "定位服务被禁用", "知道了");
				});
				
			}	
};