(function(window, $) {
	window.model = (function() {
		/** 
		 * @description 首页搜索接口参数
		 * @example 
		 * Dest 目的地          object(Type: 1, Id: [ 32 ],Name:'');<br/> 
		 * Key 品牌          object(Type: 1, Id: [ 32 ], Name: "如家");<br/>
		 * CheckList 入住日期          ["2017-01-05", "2017-01-06"];<br/>
		 * Price  价格    ['0','0'];<br/>
		 * RoomList 房间数  [1,2];<br/>
		 * StarRateList 星级  [0,1];<br/>
		 * SpecialList  特殊要求 [];<br/>
		 * CityId 城市ID 
		 * IsGroup  1：团购， 0：散购 2 没选择
		 * */
		var indexRequestReq = {
			url: "Demand/SubmitDemandInfoV2",
			data: {
				Dest: {
					Type: 0,
					Id: [],
					Name: ''
				},
				startDest:{
					Type:0,
					Id:[],
					Name:''
				},
				beginDest:{
					Type:0,
					Id:[],
					Name:''
				},
				Key: {
					Type: 0,
					Id: [],
					Name: ""
				}, //{ Type: 1, Id: [ 32 ], Name: "如家" }
				CheckList: [], //["2017-01-05", "2017-01-06"]
				customTime:[],
				Price: ['0','0'],
				RoomList: [], //[{Type:1,Amount:roomOne},{Type:2,Amount:roomTwo},{Type:3,Amount:roomThree},{Type:4,Amount:roomSuite}]
				StarRateList: [],
				SpecialList: [],
				CityId: 0,
				IsGroup: 0,
				ticket:{
					adultNum:5,
					childrenNum:0
				},
				isChange:false
			}
		};

		/** 
		 * @description 目的地
		 * @example 
		 * object(Type: 1, Id: [ 32 ]);<br/> 
		 * 
		 * */
		var indexDest = {
			Type: 0,
			Id: [],
			Name: ''
		};

		/** 
		 * @description Key 品牌        
		 * @example 
		 * object(Type: 1, Id: [ 32 ], Name: "如家");<br/>
		 * 
		 * */
		var indexKey = {
			Type: 0,
			Id: [],
			Name: ""
		};

		/**
		 * @description CheckList 入住日期  
		 * @example 
		 * ["2017-01-05", "2017-01-06"];<br/>
		 **/
		var indexCheckList = [];

		/**
		 * @description  Price  价格   
		 * @example 
		 * ['0','0'];<br/>
		 **/
		var indexPrice = [];

		/**
		 * @description RoomList 房间数  
		 * @example 
		 * [Object(Type:1,Amount:1),Object(Type:1,Amount:1)];<br/> 
		 **/
		var indexRoomList = [];

		/**
		 * @description StarRateList 星级
		 * @example 
		 * [0,1];<br/> 
		 **/
		var indexStarRateList = [];

		/**
		 * @description SpecialList  特殊要求
		 * @example 
		 * [object(Type:1,Desc:'')];<br/>
		 **/
		var indexSpecialList = [];

		return {
			indexRequestReq:indexRequestReq
		}
	})();

})(window, $);