app.model = {
	PriceId: "price_",
	Prices: [{
		minval: 0,
		maxval: 0,
		name: '不限',
		sort: 0
	}, {
		minval: 0,
		maxval: 149,
		name: '￥150以下',
		sort: 1
	}, {
		minval: 151,
		maxval: 300,
		name: '￥150-300',
		sort: 2
	}, {
		minval: 301,
		maxval: 450,
		name: '￥301-450',
		sort: 3
	}, {
		minval: 451,
		maxval: 600,
		name: '￥451-600',
		sort: 4
	}, {
		minval: 601,
		maxval: 1000,
		name: '￥601-1000',
		sort: 5
	}, {
		minval: 1001,
		maxval: 0,
		name: '￥1000以上',
		sort: 6
	}],
	StarId: "Star_",
	Stars: [{
		val: 0,
		name: '不限',
		sort: 0
	}, {
		val: 3,
		name: '三星/准四',
		sort: 2
	}, {
		val: 4,
		name: '四星/准五',
		sort: 3
	}, {
		val: 5,
		name: '五星/豪华',
		sort: 4
	}],
	RoomList: [
		{ name: '大床房', count: 0, sort: 0, Type: 1 },
		{ name: '双床房', count: 0, sort: 0, Type: 2 },
		{ name: '三人间', count: 0, sort: 0, Type: 3 },
		{ name: '套房', count: 0, sort: 0, Type: 4 },
	],
	SpecialList:[
		{name:'机票',Type:1,Desc:"",ShowName:"机&nbsp;&nbsp;&nbsp;票:"},
		{name:'接送车',Type:2,Desc:"",ShowName:"接送车:"},
		{name:'会议室',Type:3,Desc:"",ShowName:"会议室:"},
		{name:'门票',Type:4,Desc:"",ShowName:"门&nbsp;&nbsp;&nbsp;票:"}
	]

};

(function(window, $) {
	window.contrModel = (function() {
		
		/**
		 * @param {Object} Price
		 * @param {Object} StarRateList
		 */
		/**
		 * 
		 */
		function PriceStarFormat(Price, StarRateList) {
			var PriceStarName = "";
			var priceName = PriceFormat(Price);
			var starName = StarFormat(StarRateList);
			if(priceName != "") {
				PriceStarName = priceName;
			}

			if(PriceStarName != "" && starName != "") {
				PriceStarName += "/" + starName;
			}
			
			if(PriceStarName == "" && starName != ""){
				PriceStarName = starName;
			}
			
			return { PriceStarName: PriceStarName };
		}

		/**
		 * 格式化 价格
		 * @param {Object} Price ['0','0']
		 */
		function PriceFormat(Price, type) {
			var priceName = "";
			if(!!Price && Price.length == 2) {
				var minv = parseInt(Price[0]);
				var maxv = parseInt(Price[1]);
				if((minv != 0 && maxv != 0) || (minv == 0 && maxv != 0) || (minv != 0 && maxv == 0)) {
					$.each(app.model.Prices, function(index, price) {
						if(price.minval == minv && price.maxval == maxv) {
							priceName = price.name;
						}
					});
				}
			}
			if(!!type && type == 1) {
				return { priceName: priceName };
			}
			return priceName;
		}

		/**
		 * 格式化 星级
		 * @param {Object} StarRateList [0,1]
		 */
		function StarFormat(StarRateList, type) {
			var starName = "";
			if(!!StarRateList) {
				$.each(StarRateList, function(index, star) {
					if(star != 0) {
						if(starName == "") {
							starName = _getStarName(star);
						} else {
							starName += "," + _getStarName(star);
						}
					}
				});
			}
			if(!!type && type == 1) {
				return { starName: starName };
			}
			return starName;
		}
		
		/**
		 * 根据val获取对象的名称
		 * @param {Object} val 
		 */
		function _getStarName(val) {
			var name = "";
			var valint = parseInt(val);
			$.each(app.model.Stars, function(index, star) {
				if(valint == star.val) {
					name = star.name;
				}
			});
			return name;
		}
		
		return {
			PriceStarFormat:PriceStarFormat,
			PriceFormat:PriceFormat,
			StarFormat:StarFormat
		}
	})();
	
})(window, $);
