app.supplyHotelBind = {
	apiOption: {
		url: projectConfig.apiName.SubmitSupplierHotel,
		data: {
			"HotelId": '',
			"ContactName": '',
			"ContactPhone": '',
			"ProvePhont": '',
		}
	},
	pageConfig: {
		userNameId: 'userName',
		hotelNameId: 'hotelName',
		mobileId: 'mobile',
		imgUploadId: 'imgUpload',
		submitId: 'btn-bind'
	},
	init: function() {
		var self = app.supplyHotelBind;
		self.initBind();
//		self.initUpload();
	},
	initUpload: function() {
		var self = app.supplyHotelBind;
		var $imgUpload = app.gEl(self.pageConfig.imgUploadId);
		$imgUpload.on('click', function() {
			var $this = $(this);
			var $upload = $this.find('input');
			(function() {
				$upload.off('change').on('change', function() {
					var filePath = $(this).val();
					var file = this.files[0];
					//判断是否是图片类型
					if(!/image\/\w+/.test(file.type)) {
						app.showMsg("只能选择图片");
						return false;
					}
					var reader = new FileReader();
					reader.readAsDataURL(file);
					reader.onload = function(e) {
						if($imgUpload.find('img').get(0)) {
							$imgUpload.find('img').attr('src', this.result);
						} else {
							$imgUpload.append('<img src="' + this.result + '" style="max-width:60%;"/>');
						}
						self.apiOption.data.ProvePhont = this.result;
					}
				});
			})();
			$upload.get(0).click();
		})
	},
	initBind: function() {
		var self = app.supplyHotelBind;
		var $hotelName = app.gEl(self.pageConfig.hotelNameId);
		var $userName = app.gEl(self.pageConfig.userNameId);
		var $mobile = app.gEl(self.pageConfig.mobileId);
		var $img = app.gEl(self.pageConfig.imgUploadId);
		var $submit = app.gEl(self.pageConfig.submitId);
		$submit.on('click', function() {
			var mobile = $mobile.val();
			var userName = $userName.val();
			var img = $img.data('imgBase64');
			if(!userName) {
				app.showMsg('联系人不能为空');
				$userName.focus();
				return false;
			}
			if(!mobile) {
				app.showMsg('手机号不能为空');
				$mobile.focus();
				return false;
			}
			if(!app.checkMobile(mobile)) {
				app.showMsg('手机号格式不正确!');
				$mobile.focus();
				return false;
			}
			if(!img){
				app.showMsg('请上传图片!');
				return false;
			}
			self.apiOption.data.ContactName = userName;
			self.apiOption.data.ContactPhone = mobile;
			self.apiOption.data.ProvePhont = img;
			self.ajaxData(self.apiOption, function() {
				var _succ = projectConfig.ViewId.MyHotel.bindSucc;
				app.ShowWebView(_succ.url, {},null,_succ.Id);
			});
		})
	},
	ajaxData: function(apiOption, callbackFn) {
		
		var self = app.supplyHotelBind;
		var _render = function(data) {
			if(app.GetResultState(data)) {
				if(!!callbackFn)callbackFn(data);
			}else{
				app.showMsg('认证失败， 请重试')
			}
			
		};
		app.Post(apiOption, null, _render);
	}
};