app.supplyHotelSearch = {
	apiOption: {
		url: projectConfig.apiName.SearchHotelList,
		data: {
			DataType: [1],
			Dest: { // 目的地
				Type: 1,
				Id: []
			},
			Key: { // 酒店
				Type: 1,
				Id: [],
				Name: "如家"
			}
		},
		Page: {
			Index: 0,
			Size: 10
		}
	},
	pageConfig: {
		addressId: 'address',
		hotelNameId: 'hotelName',
		searchId: 'search',
		listId: 'list'
	},
	init: function() {
		var self = app.supplyHotelSearch;
		self.initSearch();
	},
	setAddressApiOptions: function(options) {
		var self = app.supplyHotelSearch;
		self.apiOption.data.Dest.Key = options.type;
		self.apiOption.data.Dest.Id = [options.id];
	},
	setHotelApiOptions: function(options) {
		var self = app.supplyHotelSearch;
		var self = app.supplyHotelSearch;
		self.apiOption.data.Key.Type = options.type;
		self.apiOption.data.Key.Id = [options.id];
		self.apiOption.data.Key.Name = [options.name];
	},
	initSearch: function() {
		var self = app.supplyHotelSearch;
		var $search = app.gEl(self.pageConfig.searchId);
		var $address = app.gEl(self.pageConfig.addressId);
		var $hotelName = app.gEl(self.pageConfig.hotelNameId);
		$address.on('click', function() {
			app.ShowWebView('../Demand/SearchDestination.html', {
				"citytype": 1,
				"viewId": projectConfig.ViewId.MyHotel.search.Id,
				"isSupply":true
			});
		});
		$hotelName.on('click', function() {
			if(!!addressData.cityId) {
				app.ShowWebView('../Demand/SearchBrand.html', {
					"cityId": addressData.cityId,
					"viewId": projectConfig.ViewId.MyHotel.search.Id,
					"isSupply":true
				});
			} else {
				app.showMsg('请选择目的地');
			}
		});
		$search.on('click', function() {
			if($.isEmptyObject(addressData)) {
				app.showMsg('请选择目的地');
				return false;
			}
			if($.isEmptyObject(hotelNameData)) {
				app.showMsg('请选择酒店');
				return false;
			}
			self.setAddressApiOptions(addressData);
			self.setHotelApiOptions(hotelNameData);
			self.apiOption.Page.Index = 0;
			app.SendFireEvent('searchList.html', 'getSearchTerms',
				self.apiOption);
		});
	},
	getItemHTML: function(data) {
		var self = app.supplyHotelSearch;
		var tmp = '<div class="hotel-list-price-view hotel-list-price-view-first">' +
			'    	<img src="{0}">' +
			'        <div class="hotel-list-price-view-center">' +
			'        	<h3>{1}</h3>' +
			'            <span>{2} {3} {4}</span>' +
			'            <p>{5}</p>' +
			'            <strong>{6}</strong>' +
			'        </div>' +
			'        <div class="hotel-list-price-view-right">' +
			'        	<font>{7}</font>' +
			'            <a href="#" class="hotel-list-price-view-add" data-id="{8}">加入询价</a>' +
			'        </div>' +
			'    </div>';
		var fTmp = '<i class="icon-sike {0}"></i>';
		return app.format(tmp, data.ImageSrc,
			data.Name, data.ReviewScore,
			data.Type, data.Amount,
			(function() {
				var facilitiesListHtml = '';
				$.each(data.FacilityList, function(i, d) {
					facilitiesListHtml += app.format(fTmp, app.GetIcon(d));
				});
				return facilitiesListHtml;
			})(),
			data.Desc,
			data.MinPrice, data.Id
		);
	},
	renderList: function(data) {
		var self = app.supplyHotelSearch;
		var $list = app.gEl(self.pageConfig.listId);
		var tHtml = '';
		$.each(data, function(i, d) {
			tHtml += self.getItemHTML(d);
		});
		$list.append(tHtml);
	},
	renderNoResult: function() {
		var self = app.supplyHotelSearch;
	},
	resetSearchTerms: function() {
		var self = app.supplyHotelSearch;
	},
	ajaxData: function() {
		var self = app.supplyHotelSearch;
		app.Post(self.apiOption, null, _render);
	}
};