app.supplyHotelSearchList = {
	searchTerms: {},
	pageConfig: {
		scrollId: 'pullrefresh',
		listId: 'scroll-list',
		isLastPage: false
	},
	init: function() {
		var self = app.supplyHotelSearchList;
		self.initList();
	},
	getItemHTML: function(data) {
		var self = app.supplyHotelSearchList;
		var tmp = '<div class="hotel-list-price-view hotel-list-price-view-first pr-limit" data-id="{8}">' +
			'    	 <img src="{0}" class="go-hotelDetail">' +
			'        <div class="hotel-list-price-view-center go-hotelDetail limit-width">' +
			'        	<h3>{1}</h3>' +
			'            <span>{2} {3} {4}</span>' +
			'            <p>{5}</p>' +
			'            <strong>{6}</strong>' +
			'        </div>' +
			'        <div class="hotel-list-price-view-right">' +
			'        	<font>{7}</font>' +
			'            <a href="javascript:void(0)" data-name={1} class="hotel-list-price-view-add bind-hotel" data-id="{8}">认领</a>' +
			'        </div>' +
			'    </div>';
		var fTmp = '<i class="icon-sike {0}"></i>';
		return app.format(tmp, data.ImageSrc,
			data.Name, data.ReviewScore,
			data.Type, data.Amount,
			(function() {
				var facilitiesListHtml = '';
				$.each(data.FacilityList, function(i, d) {
					facilitiesListHtml += app.format(fTmp, app.GetIcon(d));
				});
				return facilitiesListHtml;
			})(),
			data.Desc,
			data.MinPrice, data.Id
		);
	},
	renderList: function(data) {
		var self = app.supplyHotelSearchList;
		var $list = app.gEl(self.pageConfig.listId);
		var tHtml = '';
		$.each(data, function(i, d) {
			tHtml += self.getItemHTML(d);
		});
		$list.append(tHtml);
		
		if(self.pageConfig.isLastPage){
			mui(_scrollId).pullRefresh().endPullupToRefresh(true);
			//mui(_scrollId).pullRefresh().disablePullupToRefresh();
		}else{
			mui(_scrollId).pullRefresh().endPullupToRefresh(false);
		}
	},
	initList:function(){
		var self = app.supplyHotelSearchList;
		var $list = app.gEl(self.pageConfig.listId);
		
		$list.on('tap','.bind-hotel',function(){
			var $this = $(this);
			var _bindInfo = projectConfig.ViewId.MyHotel.bindInfo;
			app.ShowWebView(_bindInfo.url, {
				hotelId: $this.attr('data-id'),
				hotelName:$this.attr('data-name'),
			},null,_bindInfo.Id);
		});
		
		$list.on('tap','.go-hotelDetail',function(){
			var $this = $(this);
			var id = $this.parent().attr('data-id');
			if(!!id) {
				var _hotelDetail = projectConfig.ViewId.Hotel.index;
				app.ShowWebView('../Hotel/index.html', {
					HId: id
				}, null, _hotelDetail.Id);
			}
			
		})
	},
	renderNoResult: function() {
		var self = app.supplyHotelSearchList;
	},
	GetNextPageData: function() {
		var self = app.supplyHotelSearchList;
		if($.isEmptyObject(self.searchTerms)) {
			mui(_scrollId).pullRefresh().disablePullupToRefresh();
		} else {
			if(self.pageConfig.isLastPage) {
				//mui(_scrollId).pullRefresh().disablePullupToRefresh();
			} else {
				self.ajaxData(self.searchTerms, self.renderList);
			}
		}
	},
	ajaxData: function(apiOption, callbackFn) {
		var self = app.supplyHotelSearchList;
		var _render = function(data) {
			if(data.Code == "0001"){
				var $list = app.gEl(self.pageConfig.listId);
				mui(_scrollId).pullRefresh().endPullupToRefresh(true);
			}else{

				if(app.GetResultState(data)) {
					self.searchTerms.Page.Index++;
					if(self.searchTerms.Page.Index > data.PageInfo.Amount) {
						self.pageConfig.isLastPage = true;
					}
					
					if(!!callbackFn) callbackFn(data.HotelList);
				} else {
					app.showMsg('查询有误');
				}
			}
		}
		apiOption.data.Page = apiOption.Page;
		app.Post(apiOption, null, _render);
	}
};