(function(window, $) {
	window.Plane = (function() {
		var dcScroll = null,
			wfScroll = null;
		var GroupType = 0;
		var sysDate; 
		var sysDateJson;

		var _dcDate = (function() {
			(function(window, $) {
				window.DCCustomDate = (function() {
					//默认加载多少月数据包括本
					var defaultMonth = 6;
					var selectDate;
					var dateJson = {
						nowYear: 0,
						nowMonth: 0,
						nowDay: 0,
						dateList: []
					}

					function initDate(selectDate1, sysDate) {
						dateJson = {
							nowYear: 0,
							nowMonth: 0,
							nowDay: 0,
							dateList: []
						}
						selectDate = selectDate1;
						var now = new Date();
						if(sysDate)
							now = sysDate

						dateJson.nowYear = now.getFullYear();
						dateJson.nowDay = now.getDate();
						var newnow;
						if(dateJson.nowDay > 28) {
							newnow = app.DateTool.DateAdd("d", -5, now);
						} else {
							newnow = now;
						}
						dateJson.nowMonth = newnow.getMonth() + 1;
						newnow = new Date(newnow)
						for(var i = 0; i < defaultMonth; i++) {
							if(i == 0)
								newnow.setMonth(newnow.getMonth());
							else
								newnow.setMonth(newnow.getMonth() + 1);
							var monthItem = GetItems(newnow, now);
							dateJson.dateList.push(monthItem);
						}

						return dateJson;
					}

					function GetItems(date, sysDate) {
						var dateListItem = {
							year: 0,
							month: 0,
							days: []
						}

						dateListItem.year = date.getFullYear();
						dateListItem.month = date.getMonth() + 1;

						//填充空数�
						var firstDayOfWeek = getFirstDayOfWeek(dateListItem.year, dateListItem.month);
						if(firstDayOfWeek > 0) {
							for(var i = 0; i < firstDayOfWeek; i++) {
								var dayItem = {
									fulldate: "",
									day: 0,
									week: "",
									isSelect: false
								}
								dateListItem.days.push(dayItem);
							}
						}

						//遍历该月数据
						const thisMonthDays = getThisMonthDays(date.getFullYear(), date.getMonth() + 1);
						for(var i = 1; i <= thisMonthDays; i++) {
							var dayItem = {
								fulldate: "",
								day: 0,
								week: "",
								isSelect: false
							}
							var ndate = new Date(date.getFullYear(), date.getMonth(), i);
							var sday;
							if(i < 10) {
								sday = "0" + i;
							} else {
								sday = i;
							}

							var nmonth = date.getMonth() + 1;
							var nmstr;
							if(nmonth < 10) {
								nmstr = "0" + nmonth;
							} else {
								nmstr = nmonth;
							}

							dayItem.fulldate = date.getFullYear() + "-" + nmstr + "-" + sday;

							dayItem.day = i;

							dayItem.week = app.DateTool.DateToWeek(ndate, sysDate);
							if(date.getFullYear() == selectDate.getFullYear() && date.getMonth() == selectDate.getMonth() && i == selectDate.getDate()) {
								dayItem.isSelect = true;
							}
							dateListItem.days.push(dayItem);
						}

						return dateListItem;
					}

					function GetWeekStr(n) {
						var str = "";
						switch(n) {
							case 0:
								str = "周日";
								break;
							case 1:
								str = "周一";
								break;
							case 2:
								str = "周二";
								break;
							case 3:
								str = "周三";
								break;
							case 4:
								str = "周四";
								break;
							case 5:
								str = "周五";
								break;
							case 6:
								str = "周六";
								break;
							default:
								str = "";
								break;
						}

						return str;
					}

					function getThisMonthDays(year, month) {
						return new Date(year, month, 0).getDate();

					}

					function getFirstDayOfWeek(year, month) {
						return new Date(Date.UTC(year, month - 1, 1)).getDay();
					}

					return {
						initDate: initDate,
						GetWeekStr: GetWeekStr
					}
				})();
			})(window, $);

			function initDCDateJson(data) {
				if(!sysDate) {
					sysDate = new Date();
					if(app.GetResultState(data)) {
						sysDate = new Date(data.Now.replace(/-/g, "/"));
					}
					sysDateJson=data;
				}
				var getDate = function(data) {
					var selectDate;

					//获取默认选中数据			
					var settings = app.getSettings();
					var DepartDateJson = settings.DepartDateJson;
					if(!!DepartDateJson) {
						var hdate = DepartDateJson.fulldate;
						var ndate = new Date(hdate.replace(/-/g, "/"));

						if(ndate.getFullYear() < sysDate.getFullYear() || (ndate.getFullYear() == sysDate.getFullYear() && ndate.getMonth() < sysDate.getMonth()) || (ndate.getFullYear() == sysDate.getFullYear() && ndate.getMonth() == sysDate.getMonth() && ndate.getDate() < sysDate.getDate())) {
							selectDate = sysDate;
						} else {
							selectDate = ndate;
						}
					} else {
						selectDate = sysDate;
					}
					return {
						curr: selectDate,
						now: sysDate
					}
				}
				var _date = getDate(data);
				var _render = function() {
					var jsonDate = window.DCCustomDate.initDate(_date.curr, _date.now);
					var tmplHot = template('dc-date-template', jsonDate);
					$("#dc-indexContent").html('');
					$("#dc-indexContent").html(tmplHot);
				}
				SetShowDate(_date.curr, _date.now);
				_render();

				$("#dc-indexContent .check-select-date").off().on("tap", function() {
					$("#dc-indexContent .check-select-date.day-active").removeClass("day-active");
					$(this).addClass("day-active");
					var fulldate = $(this).attr("data-fulldate");
					var week = app.DateTool.DateToWeek(new Date(fulldate.replace(/-/g,'/')), sysDate)
					var ndate = new Date(fulldate.replace(/-/g, "/"));

					SetShowDate(ndate, sysDate);
					var settings = app.getSettings();
					var DepartDateJson = {
						fulldate: fulldate,
						week: week
					};

					settings.DepartDateJson = DepartDateJson;
					app.setSettings(settings);

					(function() {
						var currDate = typeof ndate == 'string' ? (ndate.replace(/-/g, '/')) : ndate;
						var _wfCurr, _wfNext;
						if(moment(currDate).format('YYYY-MM-DD') != moment(settings.PlaneDateJson.DepartDate.date).format('YYYY-MM-DD')) {
							_wfCurr = moment(currDate).format('YYYY-MM-DD');
							_wfNext = moment(_wfCurr).add(1, 'day').format('YYYY-MM-DD');
							settings.PlaneDateJson = {
								"JsonDate": [
									_wfCurr,
									_wfNext
								],
								"DepartDate": {
									"date": _wfCurr,
									"dateShow": _wfCurr,
									"week": app.DateTool.DateToWeek(new Date(_wfCurr.replace(/-/g,'/')), sysDate)
								},
								"ArriveDate": {
									"date": _wfNext,
									"dateShow": _wfNext,
									"week": app.DateTool.DateToWeek(new Date(_wfNext.replace(/-/g,'/')), sysDate)
								}
							};
							app.setSettings(settings);
							_wfDate.initWFDateJson(sysDateJson);
						}

					})()

					$(".dc-date-shade").hide();
					$(".dc-datecalendar").slideToggle(200);
				});
			}

			function SetShowDate(selectDate, systemDate) {
				var currDate = typeof selectDate == 'string' ? (selectDate.replace(/-/g, '/')) : selectDate;
				//设置时间
				var settings = app.getSettings();
				var DepartDateJsone = {
					fulldate: moment(currDate).format('YYYY-M-D'),
					week: app.DateTool.DateToWeek(new Date(currDate),systemDate)
				};
				settings.DepartDateJson = DepartDateJsone;
				app.setSettings(settings);
				// 页面显示时间
				$("#showDCDate").html(moment(selectDate).format('MM月DD日') + "<span>" +
					app.DateTool.DateToWeek(new Date(currDate),systemDate) + "</span>");
			}

			return {
				init: function() {
					LoadDefaultDate();
					//滚动
					dcScroll = mui("#dc-dateScroll").scroll();
					$("#showDCDate").on("tap", function() {
						$(".dc-date-shade").show();
						$(".dc-datecalendar").slideToggle(200);
					});

					$(".dc-date-shade").on("tap", function() {
						$(".dc-date-shade").hide();
						$(".dc-datecalendar").slideToggle(200);
					});

					app.GetServicesTime(initDCDateJson);
				},
				initDCDateJson: initDCDateJson,
				SetShowDate: SetShowDate
			}
		})();

		var _wfDate = (function() {
			(function(window, $) {
				window.WFCustomDate = (function() {
					//默认加载多少月数据包括本
					var defaultMonth = 6;
					var selectDate1;
					var selectDate2;
					var GroupType = 0;
					var dateJson = {
						nowYear: 0,
						nowMonth: 0,
						nowDay: 0,
						nowHours: 0,
						groupType: 0,
						dateList: []
					}

					function initDate(dates, sysDate, Type) {
						dateJson = {
							nowYear: 0,
							nowMonth: 0,
							nowDay: 0,
							nowHours: 0,
							groupType: 0,
							dateList: []
						}
						//团房 14后预订
						GroupType = Type;
						//初始化dates数据
						loadDates(sysDate, dates);

						var now = new Date();
						if(sysDate)
							now = sysDate

						dateJson.groupType = GroupType;
						dateJson.nowYear = now.getFullYear();
						dateJson.nowDay = now.getDate();
						dateJson.nowHours = now.getHours();

						var newnow;
						if(dateJson.nowDay > 28) {
							newnow = app.DateTool.DateAdd("d", -5, now);
						} else {
							newnow = now;
						}
						dateJson.nowMonth = newnow.getMonth() + 1;
						newnow = new Date(newnow)
						for(var i = 0; i < defaultMonth; i++) {
							if(i == 0)
								newnow.setMonth(newnow.getMonth());
							else
								newnow.setMonth(newnow.getMonth() + 1);
							var monthItem = GetItems(newnow, now);
							dateJson.dateList.push(monthItem);
						}
						return dateJson;
					}

					function loadDates(mydate, dates) {
						var startdate = '',
							enddate = '';
						if(!!dates && dates.length == 2 && !!dates[0]) {
							if(dates.length == 1 && dates[0].length > 0) {
								startdate = dates[0];
							} else if(dates.length > 1) {
								startdate = dates[0];
								enddate = dates[dates.length - 1];
							}

							var newstart = new Date(startdate.replace(/-/g, "/"));
							var newyears = newstart.getFullYear();
							var newmonth = newstart.getMonth() + 1;
							var newday = newstart.getDate();
							//当天日期
							var year = mydate.getFullYear();
							var month = mydate.getMonth() + 1;
							var day = mydate.getDate();

							var todayDate = new Date((year + "-" + month + "-" + day).replace(/-/g, "/"));

							if(newstart.getTime() < todayDate.getTime() || (newstart.getTime() == todayDate.getTime() && mydate.getHours() >= 14)) {
								var startStr = app.DateTool.DateAdd("d", 0, mydate);

								var year2 = app.DateTool.DatePart('y', startStr);
								var month2 = app.DateTool.DatePart('m', startStr);
								var day2 = app.DateTool.DatePart('d', startStr);
								startdate = year2 + "-" + month2 + "-" + day2;
							}

							var newstartdate = new Date(startdate.replace(/-/g, "/"));
							var newstartyear = newstartdate.getFullYear();
							var newstartmonth = newstartdate.getMonth() + 1;
							var newstartday = newstartdate.getDate();

							var newend = new Date(enddate.replace(/-/g, "/"));
							var newendyears = newend.getFullYear();
							var newendmonth = newend.getMonth() + 1;
							var newendday = newend.getDate();

							if(newend <= newstartdate) {
								var endStr = app.DateTool.DateAdd("d", 1, mydate);
								if(GroupType == 2) {
									if(mydate.getHours() >= 14) {
										endStr = app.DateTool.DateAdd("d", 2, mydate);
									}
								}

								var year = app.DateTool.DatePart('y', endStr);
								var month = app.DateTool.DatePart('m', endStr);
								var day = app.DateTool.DatePart('d', endStr);
								enddate = year + "-" + month + "-" + day;
							}
						} else {
							var year = app.DateTool.DatePart('y', mydate);
							var month = app.DateTool.DatePart('m', mydate);
							var day = app.DateTool.DatePart('d', mydate);
							startdate = year + "-" + month + "-" + day;
							endStr = app.DateTool.DateAdd("d", 1, mydate);
							year = app.DateTool.DatePart('y', endStr);
							month = app.DateTool.DatePart('m', endStr);
							day = app.DateTool.DatePart('d', endStr);
							enddate = year + "-" + month + "-" + day;
						}

						selectDate1 = new Date(startdate.replace(/-/g, "/"));
						selectDate2 = new Date(enddate.replace(/-/g, "/"));

						SetShowDate(selectDate1, selectDate2, mydate);
					}

					function GetItems(date, sysDate) {
						var dateListItem = {
							year: 0,
							month: 0,
							days: []
						}

						dateListItem.year = date.getFullYear();
						dateListItem.month = date.getMonth() + 1;

						//填充空数
						var firstDayOfWeek = getFirstDayOfWeek(dateListItem.year, dateListItem.month);
						if(firstDayOfWeek > 0) {
							for(var i = 0; i < firstDayOfWeek; i++) {
								var dayItem = {
									fulldate: "",
									day: 0,
									week: "",
									isSelect: false
								}
								dateListItem.days.push(dayItem);
							}
						}

						//遍历该月数据
						const thisMonthDays = getThisMonthDays(date.getFullYear(), date.getMonth() + 1);
						for(var i = 1; i <= thisMonthDays; i++) {
							var dayItem = {
								fulldate: "",
								day: 0,
								week: "",
								isSelect: false
							}
							var ndate = new Date(date.getFullYear(), date.getMonth(), i);
							var sday;
							if(i < 10) {
								sday = "0" + i;
							} else {
								sday = i;
							}

							var nmonth = date.getMonth() + 1;
							var nmstr;
							if(nmonth < 10) {
								nmstr = "0" + nmonth;
							} else {
								nmstr = nmonth;
							}

							dayItem.fulldate = date.getFullYear() + "-" + nmstr + "-" + sday;
							dayItem.day = i;

							dayItem.week = app.DateTool.DateToWeek(ndate, sysDate);
							if(date.getFullYear() == selectDate1.getFullYear() && date.getMonth() == selectDate1.getMonth() && i == selectDate1.getDate()) {
								dayItem.isSelect = true;
							}

							if(date.getFullYear() == selectDate2.getFullYear() && date.getMonth() == selectDate2.getMonth() && i == selectDate2.getDate()) {
								dayItem.isSelect = true;
							}

							dateListItem.days.push(dayItem);
						}

						return dateListItem;
					}

					function getThisMonthDays(year, month) {
						return new Date(year, month, 0).getDate();

					}

					function getFirstDayOfWeek(year, month) {
						return new Date(Date.UTC(year, month - 1, 1)).getDay();
					}

					function loadBind() {
						var items = $("#wf-indexContent .check-select-date.day-active");
						var startItem = $(items[0]);
						startItem.addClass("day-active-start");
						if(startItem.find(".day-ac").hasClass("day-right")) {
							startItem.addClass("das-no");
						}

						startItem.find(".box-color").html("去程");
						var endItem = $(items[1]);
						endItem.addClass("day-active-end");
						if(endItem.find(".day-ac").hasClass("day-left")) {
							endItem.addClass("das-no");
						}
						endItem.find(".box-color").html("返程");
						startItem.nextUntil("#wf-indexContent .day-active").addClass("dayg-active");
						endItem.prevUntil("#wf-indexContent .day-active").addClass("dayg-active");
					}

					return {
						initDate: initDate,
						loadBind: loadBind
					}
				})();
			})(window, $);

			function initWFDateJson(data) {
				var selectDate;
				if(!sysDate) {
					sysDate = new Date();
					if(app.GetResultState(data)) {
						try {
							sysDate = new Date(data.Now.replace(/-/g, "/"));
						} catch(e) {
							sysDate = new Date();
						}
					}
				}
				sysDateJson=data;

				var settings = app.getSettings();
				var PlaneDateJson = settings.PlaneDateJson;
				var JsonDate;
				if(PlaneDateJson) {
					JsonDate = PlaneDateJson.JsonDate;
				}
				//验证日期有效�
				loadDates(sysDate, JsonDate);

				var jsonDate = window.WFCustomDate.initDate(JsonDate, sysDate, GroupType);
				var tmplHot = template('wf-date-template', jsonDate);
				$("#wf-indexContent").html('');
				$("#wf-indexContent").html(tmplHot);
				window.WFCustomDate.loadBind();
				//自动选中
				var $_d_curr = $("#wf-indexContent .check-select-date.day-active");
				var $qu = $($_d_curr[0]);
				var $fan = $($_d_curr[1]);
				$qu.find(".box-color").html("去程");
				$fan.find(".box-color").html("返程");
				$("#wf-indexContent .check-select-date").off().on("tap", function() {
					var $active = $("#wf-indexContent .check-select-date.day-active")
					if($active.length == 2) {
						$("#wf-indexContent .box-color").html("");
						$active.removeClass("das-no");
						$active.removeClass("day-active");
						$("#wf-indexContent .check-select-date.dayg-active").removeClass("dayg-active");
						$("#wf-indexContent .check-select-date.day-active-start").removeClass("day-active-start");
						$("#wf-indexContent .check-select-date.day-active-end").removeClass("day-active-end");
					}
					$(this).addClass("day-active");

					if($("#wf-indexContent .check-select-date.day-active").length == 2) {
						$(".wf-date-shade").hide();
						$(".wf-datecalendar").slideToggle(200);
						var items = $("#wf-indexContent .check-select-date.day-active");
						var startItem = $(items[0]);
						startItem.addClass("day-active-start");
						if(startItem.find(".day-ac").hasClass("day-right")) {
							startItem.addClass("das-no");
						}

						startItem.find(".box-color").html("去程");
						var endItem = $(items[1]);
						endItem.addClass("day-active-end");
						if(endItem.find(".day-ac").hasClass("day-left")) {
							endItem.addClass("das-no");
						}
						endItem.find(".box-color").html("返程");
						startItem.nextUntil(".day-active").addClass("dayg-active");
						endItem.prevUntil(".day-active").addClass("dayg-active");

						var startdate = startItem.attr("data-fulldate");
						var enddate = endItem.attr("data-fulldate");
						var iday = app.DateTool.datedifference(startdate, enddate);

						var nea = new Array();
						nea.push(startdate);
						nea.push(enddate);

						SetShowDate(startdate, enddate, sysDate);
						var DepartDate = {}
						DepartDate.date = startdate;
						DepartDate.dateShow = moment(startdate).format('YYYY-MM-DD');
						DepartDate.week = app.DateTool.DateToWeek(new Date(startdate), sysDate);
						var ArriveDate = {}
						ArriveDate.date = enddate;
						ArriveDate.dateShow = moment(enddate).format('YYYY-MM-DD');
						ArriveDate.week = app.DateTool.DateToWeek(new Date(enddate), sysDate);
						var PlaneDateJson = {}
						settings = app.getSettings();
						PlaneDateJson.JsonDate = nea;
						PlaneDateJson.DepartDate = DepartDate
						PlaneDateJson.ArriveDate = ArriveDate
						settings.PlaneDateJson = PlaneDateJson;
						app.setSettings(settings);
						(function() {
							settings.DepartDateJson = {
								fulldate: moment(DepartDate.date).format('YYYY-MM-DD'),
								week: app.DateTool.DateToWeek(new Date(DepartDate.date.replace(/-/g,'/')), sysDate)
							};
							app.setSettings(settings);
							_dcDate.initDCDateJson(sysDateJson);
						})()
					}
				});
			}

			function SetShowDate(startDate, endDate, sysDate) {
				var _sDate = typeof startDate == 'string' ? startDate.replace(/-/g, '/') : moment(startDate);
				var tpl = '<div class="wf-date-go wf-date-show">{0}<span>{1}</span></div><div class="wf-date-back wf-date-show">{2}<span>{3}</span></div>';
				$("#showWFDate").html(app.format(tpl,
					moment(_sDate).format('MM月DD日'),
					app.DateTool.DateToWeek(new Date(startDate), sysDate),
					moment(endDate).format('MM月DD日'),
					app.DateTool.DateToWeek(new Date(endDate), sysDate)
				));

			}

			function loadDates(mydate, dates) {
				var startdate = '',
					enddate = '';

				if(!!dates && dates.length == 2 && !!dates[0]) {
					if(dates.length == 1 && dates[0].length > 0) {
						startdate = dates[0];
					} else if(dates.length > 1) {
						startdate = dates[0];
						enddate = dates[dates.length - 1];
					}

					var newstart = new Date(startdate.replace(/-/g, "/"));
					var newyears = newstart.getFullYear();
					var newmonth = newstart.getMonth() + 1;
					var newday = newstart.getDate();
					//当天日期
					var year = mydate.getFullYear();
					var month = mydate.getMonth() + 1;
					var day = mydate.getDate();

					var todayDate = new Date((year + "-" + month + "-" + day).replace(/-/g, "/"));

					if(newstart.getTime() < todayDate.getTime() || (newstart.getTime() == todayDate.getTime() && mydate.getHours() >= 14)) {
						var startStr = app.DateTool.DateAdd("d", 0, mydate);
						if(GroupType == 2) {
							if(mydate.getHours() >= 14) {
								startStr = app.DateTool.DateAdd("d", 1, mydate);
							}
						}

						var year2 = app.DateTool.DatePart('y', startStr);
						var month2 = app.DateTool.DatePart('m', startStr);
						var day2 = app.DateTool.DatePart('d', startStr);
						startdate = year2 + "-" + month2 + "-" + day2;
					}

					var newstartdate = new Date(startdate.replace(/-/g, "/"));
					var newstartyear = newstartdate.getFullYear();
					var newstartmonth = newstartdate.getMonth() + 1;
					var newstartday = newstartdate.getDate();

					var newend = new Date(enddate.replace(/-/g, "/"));
					var newendyears = newend.getFullYear();
					var newendmonth = newend.getMonth() + 1;
					var newendday = newend.getDate();

					if(newend <= newstartdate) {
						var endStr = app.DateTool.DateAdd("d", 1, mydate);

						var year = app.DateTool.DatePart('y', endStr);
						var month = app.DateTool.DatePart('m', endStr);
						var day = app.DateTool.DatePart('d', endStr);
						enddate = year + "-" + month + "-" + day;
					}
				} else {
					var startStr = app.DateTool.DateAdd("d", 0, mydate);
					var year = app.DateTool.DatePart('y', startStr);
					var month = app.DateTool.DatePart('m', startStr);
					var day = app.DateTool.DatePart('d', startStr);
					startdate = year + "-" + month + "-" + day;
					var endStr = app.DateTool.DateAdd("d", 1, mydate);
					year = app.DateTool.DatePart('y', endStr);
					month = app.DateTool.DatePart('m', endStr);
					day = app.DateTool.DatePart('d', endStr);
					enddate = year + "-" + month + "-" + day;
				}

				var nea = new Array();
				nea.push(startdate);
				nea.push(enddate);
				var settings = app.getSettings();
				var DepartDate = {}
				DepartDate.date = startdate;
				DepartDate.dateShow = moment(startdate).format('YYYY-MM-DD');
				DepartDate.week = app.DateTool.DateToWeek(new Date(startdate), mydate);
				var ArriveDate = {}
				ArriveDate.date = enddate;
				ArriveDate.dateShow = moment(enddate).format('YYYY-MM-DD');
				ArriveDate.week = app.DateTool.DateToWeek(new Date(enddate), mydate);

				var PlaneDateJson = {}
				PlaneDateJson.JsonDate = nea;
				PlaneDateJson.DepartDate = DepartDate
				PlaneDateJson.ArriveDate = ArriveDate
				settings.PlaneDateJson = PlaneDateJson;
				app.setSettings(settings);
			}

			function reCallbackDate(date, type) {
				var that = this;
				getDate(date[0], 'start');
				getDate(date[1], 'end');
			}

			function getDate(date, type) {
				var month = app.DateTool.DateFormat("MM", date);
				var day = app.DateTool.DateFormat("dd", date);
				var week = app.DateTool.DateFormat("w", date);

				var str = month + "月" + day + "日" + '<span class="date-item-week">' + week + '</span>';

				if(type == 'start') {
					$("#startdate").html(str);
				} else if(type == 'end') {
					$("#enddate").html(str);
				}
			}

			return {
				init: function() {
					wfScroll = mui("#wf-dateScroll").scroll();
					$("#showWFDate").off().on('tap', function() {
						$(".wf-date-shade").show();
						$(".wf-datecalendar").slideToggle(200);
					});

					$(".wf-date-shade").off().on("tap", function() {
						$(".wf-date-shade").hide();
						$(".wf-datecalendar").slideToggle(200);
					});
					app.GetServicesTime(initWFDateJson);
				},
				initWFDateJson: initWFDateJson,
				SetShowDate: SetShowDate
			}

		})();

		function init(_type) {
			GroupType = _type;
			_dcDate.init();
			_wfDate.init();
			initPlaneStartAndEnd();
			initChangePlanePlan();
			initPlaneSwitchPlanTab();
			initSearchPlane();
		}

		function LoadDefaultDate() {
			var settings = app.getSettings();
			var DepartCity = settings.DepartCityIndex;
			if(!!DepartCity) {
				$("#plane-start").addClass("ce-act");
				$("#plane-start").html(DepartCity.AirportName);
			}
			var ArriveCity = settings.ArriveCityIndex;
			if(!!ArriveCity) {
				$("#plane-end").addClass("ce-act");
				$("#plane-end").html(ArriveCity.AirportName);
			}
		}

		function initChangePlanePlan() {
			$("#planef").on("tap", function() {
				var settings = app.getSettings();
				var DepartCity = settings.DepartCityIndex;
				var ArriveCity = settings.ArriveCityIndex;
				settings.DepartCityIndex = ArriveCity;
				settings.ArriveCityIndex = DepartCity;
				app.setSettings(settings);
				LoadDefaultDate();
			});
		}

		function initSearchPlane() {
			$(".seach-list-btn").on("tap", function() {
				//验证
				var settings = app.getSettings();
				var DepartCity = settings.DepartCityIndex;
				if(!!DepartCity) {
					var aName = DepartCity.AirportName;
					if(aName == "") {
						plus.nativeUI.toast('请选择出发城市');
						return;
					}
				} else {
					plus.nativeUI.toast('请选择出发城市');
					return;
				}
				var ArriveCity = settings.ArriveCityIndex;
				if(!!ArriveCity) {
					var bName = ArriveCity.AirportName;
					if(bName == "") {
						plus.nativeUI.toast('请选择目的地城市');
						return;
					}
				} else {
					plus.nativeUI.toast('请选择目的地城市');
					return;
				}

				if(DepartCity.CityId == ArriveCity.CityId) {
					plus.nativeUI.toast('出发地和到达地不能相同');
					return;
				}

				app.ShowWebView(projectConfig.ViewId.Plane.List.url, {
					type: $('.plane-plan .current').attr('data-plan')
				}, null, projectConfig.ViewId.Plane.List.Id);
			});

		}

		function initPlaneStartAndEnd() {
			$("#plane-start").on("tap", function() {
				app.ShowWebView(projectConfig.ViewId.Plane.Departure.url, {
					type: 1
				});
			});

			$("#plane-end").on("tap", function() {
				app.ShowWebView(projectConfig.ViewId.Plane.Departure.url, {
					type: 2
				});
			});
		}

		function ReCallbackCity(CityId, AirportCode, AirportName, type) {
			var settings = app.getSettings();
			if(type == 1) {
				settings.DepartCityIndex = {
					CityId: CityId,
					AirportCode: AirportCode,
					AirportName: AirportName
				}
				app.setSettings(settings);
				$("#plane-start").addClass("ce-act");
				$("#plane-start").html(AirportName);
			}
			if(type == 2) {
				settings.ArriveCityIndex = {
					CityId: CityId,
					AirportCode: AirportCode,
					AirportName: AirportName
				}
				app.setSettings(settings);
				$("#plane-end").addClass("ce-act");
				$("#plane-end").html(AirportName);
			}
		}

		function initPlaneSwitchPlanTab() {
			var currCss = 'current';
			var $dcDate = $('#showDCDate');
			var $wfDate = $('#showWFDate');
			$('.plane-plan').on('tap', 'li', function() {
				var $this = $(this);
				var tab = $this.attr('data-plan');
				if(!$this.hasClass(currCss)) {
					$this.addClass(currCss).siblings().removeClass(currCss);
				}
				if(tab == 'dc') {
					$dcDate.show();
					$wfDate.hide();
				} else {
					$dcDate.hide();
					$wfDate.show();
				}
			});
		}

		return {
			init: init,
			ReCallbackCity: ReCallbackCity
		}

	})();
})(window, $);