(function(window, $) {
	window.ModifyPerson = (function() {

		var GetFlightPassengerList = {
			url: projectConfig.apiName.GetFlightPassengerList,
			data: {
				SerialNo: 0,
				PassengerId: 0
			}
		}

		var FlightPassengersModify = {
			url: projectConfig.apiName.FlightPassengersModify,
			data: {
				SerialNo: 0,
				PassengerList: []
			}
		}

		function init() {
			GetFlightPassengerList.data.SerialNo = _orderSerialNo;
			GetFlightPassengerList.data.PassengerId = _passengerId;

			FlightPassengersModify.data.SerialNo = _orderSerialNo;

			GetFlightPassengerListData();

			$(".person-btn-re").off().on("tap", function() {
				Modify();
			});
		}

		function GetFlightPassengerListData() {
			app.showWaiting('加载中...', 1);
			app.Post(GetFlightPassengerList, null, GetFlightPassengerListCallBack);
		}

		function GetFlightPassengerListCallBack(data) {
			if(app.GetResultState(data)) {
				var tmplHot = template('date-template', data);
				$("#mpitems").html(tmplHot);

			} else {
				plus.nativeUI.toast(data.Msg);
			}
		}

		//验证修改
		function Modify() {
			var isTrue = true;
			FlightPassengersModify.data.PassengerList = [];
			$(".m-p-person-item").each(function() {
				var that = $(this);
				var dataId = that.attr("data-id");
				var name = that.attr("data-name");
				var identityno = that.attr("data-identityno");
				var newname = that.find(".mp-name").val();
				var newidentityno = that.find(".mp-identityno").val();

				if((name != newname && newname != "") && (identityno != newidentityno && newidentityno != "")) {
					plus.nativeUI.toast("姓名和身份证只能修改一项");
					that.find(".mp-name").focus();
					isTrue = false;
					return;
				}

				//验证符合修改的条件
				//姓名为空 身份证不为空，只修改身份证
				if(((newname != "" && name == newname) || newname == "") && newidentityno != "" && newidentityno != identityno) {
					var Passenger = {
						PassengerId: 0,
						Name: "",
						IdentityNo: ""
					}
					Passenger.PassengerId = dataId;
					Passenger.Name = name;
					Passenger.IdentityNo = newidentityno;
					FlightPassengersModify.data.PassengerList.push(Passenger);
				}

				//身份证为空 姓名不为空，只修改姓名
				if(newname != "" && name != newname && (newidentityno == "" || (newidentityno == identityno && newidentityno != ""))) {
					var Passenger = {
						PassengerId: 0,
						Name: "",
						IdentityNo: ""
					}
					Passenger.PassengerId = dataId;
					Passenger.Name = newname;
					Passenger.IdentityNo = identityno;
					FlightPassengersModify.data.PassengerList.push(Passenger);
				}

			});

			if(!isTrue) {
				return;
			}

			if(FlightPassengersModify.data.PassengerList.length == 0) {
				plus.nativeUI.toast("请填写需要修改乘客的信息");
				return;
			}

			// 弹出提示信息对话框
			mui.confirm('确认提交修改的乘客信息吗？', '提示', ['取消', '确认'], function(e) {
				if(e.index == 1) {
					app.Post(FlightPassengersModify, null, function(data) {
						if(app.GetResultState(data)) {
							var param = {
								name: "",
								phone: "",
								isadmin: "",
								type: 5,
								SerialNo: 0
							}

							if(data.IsBoss) {
								if(data.CanPay) {
									app.ShowWebView(projectConfig.ViewId.Payment.Cashier.url, {
										SerialNo: _orderSerialNo,
										ProductType: 5,
										isList: 0
									}, '', projectConfig.ViewId.Payment.Cashier.Id);
								} else {
									app.ShowWebView(projectConfig.ViewId.Plane.OrderDetail.url, {
										SerialNo: _orderSerialNo,
										isList: 0
									}, '', projectConfig.ViewId.Plane.OrderDetail.Id);
								}
							} else {
								if(data.MofifyResponse.AuditStatus == 1) {
									if(data.CanPay) {
										app.ShowWebView(projectConfig.ViewId.Payment.Cashier.url, {
											SerialNo: _orderSerialNo,
											ProductType: 5,
											isList: 0
										}, '', projectConfig.ViewId.Payment.Cashier.Id);
									} else {
										app.ShowWebView(projectConfig.ViewId.Plane.OrderDetail.url, {
											SerialNo: _orderSerialNo,
											isList: 0
										}, 'pop-in', projectConfig.ViewId.Plane.OrderDetail.Id);
									}
								} else {
									param.name = data.MofifyResponse.AuditorName;
									param.phone = data.MofifyResponse.AuditorMobile;
									param.isadmin = data.MofifyResponse.IsAdmin;
									param.SerialNo = _orderSerialNo;
									param.type = 5;
									app.ShowWebView(projectConfig.ViewId.Standard.AppRoval.url, param, 'pop-in', projectConfig.ViewId.Standard.AppRoval.Id);
								}
							}
						} else {
							plus.nativeUI.toast(data.Msg);
						}
					});
				} else {

				}
			})
		}

		return {
			init: init
		}

	})();
})(window, $);