app.responseOffer = {
	GetDemandListEntity: {
		url: projectConfig.apiName.GetSupplyDemandList,
		data: {
			Type: 1,
			Page: {
				Index: 0,
				size: 0
			}
		},
		PageInfo: {
			Index: 0,
			Size: 0,
			Amount: 0,
			ResultAmount: 0
		}
	},
	styles: {
		top: "92px", //内容页面顶部位置,需根据实际页面布局计算，若使用标准mui导航，顶部默认为48px；
		bottom: "45px"
	},
	PageInfos: [],
	SubPages: [],
	currentType: 0,
	currentIndex: 0,
	tabIdprefix: "demandType",
	//获取需求单信息
	GetDemandList: function(callback) {
		var self = app.responseOffer;
		var entity = self.GetDemandListEntity;
		app.Post(entity, null, callback);
	},
	//列表callback
	GetDemandListCallback: function(data) {
		var self = app.responseOffer;
		if(app.GetResultState(data)) {
			var html = "";
			var titleList = data.TitleList;
			var demandList = data.DemandIList;
			var subId = "SupplySubOffer";
			if(titleList != null && titleList.length > 0) {
				self.SetDemandTitle(titleList);
				if(self.currentType == 0)
					self.currentType = titleList[0].Id;
				if(self.SubPages.length <= 0) {
					$.each(titleList, function(i, title) {
						var page = {};
						page.Type = title.Id;
						page.viewId = subId + title.Id;
						page.viewUrl = "offer/Sub_Offer.html";

						page.style = self.styles;
						if(self.currentType == title.Id) {
							page.isLoad = 1;
							page.data = {
								data: demandList
							};
						} else {
							page.isLoad = 0;
						}
						self.SubPages.push(page);
					});
					self.CreateSubView();
				} else {
					var currentpage = self.GetSubPage();
					if(currentpage.isLoad != 1) {
						var pagedata = {
							data: demandList
						};
						currentpage.isLoad = 1;
						app.SendFireEvent(currentpage.viewId, "SetData", pagedata);
					} else {
						app.SendFireEvent(currentpage.viewId, "SetData", null);
					}
				}
				self.SetDemandTitle(titleList);
			}
		} else {

		}
	},
	//创建子页面
	CreateSubView: function() {
		var self = app.responseOffer;
		var selfview = plus.webview.currentWebview();
		for(var i = 0; i < self.SubPages.length; i++) {
			var page = self.SubPages[i];
			var sub = app.CreateView(page.viewUrl, page.viewId, page.style, page.data);
			if(page.Type != self.currentType) {
				sub.hide();
			}
			selfview.append(sub);
		}
	},
	//设置需求单标题
	SetDemandTitle: function(data) {
		var self = app.responseOffer;
		var html = "";
		if(data.length > 0) {
			titlewidth = (99 / data.length) + "%";
			for(var i = 0; i < data.length; i++) {
				var title = data[i];
				var css = "";
				if(self.currentType == title.Id) {
					css = "current";
				}
				html += '<a href="javascript:void(0)" type="' + title.Id + '" class="' + css + '" style="width:' + titlewidth + '">';
				html += self.InitTypeCount(title.Name, title.Amount);
				html += "</a>";
			}
			$("#divTitle").html(html);
			self.TitleClickEvent();
		}
	},
	//title点击事件 
	TitleClickEvent: function() {
		$("#divTitle a").unbind("click");
		$("#divTitle a").click(function() {
			$("#divTitle a").removeClass("current");
			$(this).addClass("current");
			var type = $(this).attr("type");
			var self = app.responseOffer;
			self.currentType = type;
			self.GetDemandListEntity.data.Type = type;
			$.each(self.SubPages, function(i, page) {
				plus.webview.hide(page.viewId);
				if(page.Type == type) {
					self.GetDemandList(self.GetDemandListCallback);
					plus.webview.show(page.viewId);
				}
			});
		});
	},
	//加载选项数量
	InitTypeCount: function(title, count) {
		var html = title;
		if(count > 0)
			html += '(<i>' + count + '</i>)';
		return html;
	},
	InitTypePack: function(type) {
		var html = "";
		var tabId = self.tabIdprefix + type;
		html += '<section class="rob-order-flex" id="' + tabId + '"></section>';
		return html;
	},
	//获取当前类型的子页面
	GetSubPage: function() {
		var self = app.responseOffer;
		var pageview = null;
		$.each(self.SubPages, function(i, page) {
			if(page.Type == self.currentType) {
				pageview = page;
				return;
			}
		});
		return pageview;
	}
}