(function(window, $) {
	window.TrainOrderDetail = (function() {
		var GetTrainOrderDetailEntity = {
			url: projectConfig.apiName.GetTrainOrderDetailV2,
			data: {
				SerialNo: ""
			}
		}

		var GetTrainRefundInfoEntity = {
			url: projectConfig.apiName.GetTrainRefundInfo,
			data: {
				OrderSerialNo: "",
				PassengerId: ""
			}
		}

		var ApplyTrainOrderRefundEntity = {
			url: projectConfig.apiName.ApplyTrainOrderRefund,
			data: {
				SerialNo: "",
				PassengerIdList: []
			}
		}

		var CancelTrainOrderEntity = {
			url: projectConfig.apiName.CancelTrainOrder,
			data: {
				OrderSerialNo: ""
			}
		}

		var backEntity = {}
		var _runPayOrderCountDown;

		function init() {
			getDetail();
			$(".order-detail-out").on("tap", function() {
				$(".ce-detail-rule").show();
			});
			$(".ce-rult-icon").off().on("tap", function() {
				$(".ce-detail-rule").hide();
				$('body').css('pointer-events', 'none');
				setTimeout(function() {
					$('body').css('pointer-events', 'auto');
				}, 400);
			})

			mui("#list-contentScroll").scroll();
		}

		function cancelOrderCallback(data) {
			if(app.GetResultState(data)) {
				var self2 = plus.webview.currentWebview();
				self2.reload();
				getDetail();
			} else {
				app.showMsg(data.Msg)
			}
		}

		function getDetail(callback) {
			app.showWaiting('加载中...', 1);
			if(!callback)
				callback = loadDetailCallback;

			app.Post(GetTrainOrderDetailEntity, null, callback);
		}

		function loadDetailCallback(data) {
			if(app.GetResultState(data)) {
				var state = data.Status;
				$(".state-title").html(state[1]);
				$(".state-intro").html(state[2].replace('ProccessTime', "<span style='color:#ff4c4c'>" + data.ProccessTime + "</span>"));
				
				if(data.CountDownType==1){
					$("#slasttime").html("支付剩余时间:");
				}
				else if(data.CountDownType==2){
					$("#slasttime").html("审批剩余时间:");
				}
				$(".state-img").attr("src", getStateIcon(data.IconType));
				for(var i = 0; i < data.TrainList.length; i++) {
					var train = data.TrainList[i].TrainInfo;
					var leaveDate = train.DepartTime.replace(/-/g, "/");
					var arriveDate = train.ArriveTime.replace(/-/g, "/");
					var expireTime = data.ExpireTime.replace(/-/g, "/");
					var createTime = data.SystemTime.replace(/-/g, "/");

					var leavehour = app.DateTool.DateFormat("hh", leaveDate);
					var leavemuinte = app.DateTool.DateFormat("mm", leaveDate);
					var arrivehour = app.DateTool.DateFormat("hh", arriveDate);
					var arrivemuinte = app.DateTool.DateFormat("mm", arriveDate);
					var week = app.DateTool.DateFormat("w", leaveDate);
					var leavemonth = app.DateTool.DateFormat("MM", leaveDate);
					var leaveday = app.DateTool.DateFormat("dd", leaveDate);
					var arrivemonth = app.DateTool.DateFormat("MM", arriveDate);
					var arriveday = app.DateTool.DateFormat("dd", arriveDate);

					train.leaveTime = leavehour + ":" + leavemuinte;
					train.arriveTime = arrivehour + ":" + arrivemuinte;
					train.leaveDate = leavemonth + "月" + leaveday + "日";
					train.arriveDate = arrivemonth + "月" + arriveday + "日";
					train.week = week;

					data.TrainList[i].TrainInfo = train;
				}

				$(".state-img").attr("src", getStateIcon(data.OrderStatus));

				var amount = data.Price;
				$("#pricetitle").html(amount[0]);
				$(".price-code").html("￥");
				$(".price").html(amount[2]);
				if(data.IsNeedCountDown) {
					var leftTime = new Date(expireTime).getTime() - new Date(createTime).getTime();
					$("#date-content").attr("date", leftTime);
					if(leftTime > 0) {
						runCountdown();
					}
					//$(".button-list").show();
					$(".order-detail-out").hide();
				} else {
					//$(".button-list").hide();
					$(".button-time").hide();
					clearInterval(_runPayOrderCountDown);
					$(".order-detail-out").show();
				}

				var tmplHot = template('trainDetail-template', data);
				$("#trainheader").html(tmplHot);
				initButton(data);
				buttonClick();

				$("#orderno").html(data.OrderSerialNo);
				$("#createtime").html(data.CreateTime);

				var tmplDetail = template('detail-template', data);
				$("#detailContent").html(tmplDetail);

				$(".person-state").on("tap", function() {
					var state = $(this).attr("state");
					if(state == 1) {
						var msg = $(this).attr("msg");
						mui.alert(msg, "失败原因", ["确定"])
					}
				})
			} else {
				app.showMsg(data.Msg)
			}
		}

		function initButton(data) {
			var button = "<div class=\"button-item\"><button class=\"button-detail {2}\" type='{1}' link='{3}'>{0}</button></div>";
			var html = "";
			for(var i = 0; i < data.ButtonList.length; i++) {
				if(data.ButtonList[i].Type != 0) {
					if(data.ButtonList[i].Type == 100 || data.ButtonList[i].Type == 304) {
						html += app.format(button, data.ButtonList[i].Name, data.ButtonList[i].Type, "button-blue", data.ButtonList[i].Link);
					} else {
						html += app.format(button, data.ButtonList[i].Name, data.ButtonList[i].Type, "", data.ButtonList[i].Link);
					}
				} else {
					html += app.format(button, data.ButtonList[i].Name, data.ButtonList[i].Type, "button-back");
				}
			}
			if(html) {
				$(".button-list").show();
				$(".button-list").html(html);
			} else {
				$(".button-list").hide();
			}
		}

		function buttonClick() {
			$(".button-detail").on("tap", function() {
				var type = $(this).attr("type");
				var link = $(this).attr("link");
				var param = {};
				param.SerialNo = GetTrainOrderDetailEntity.data.SerialNo;
				param.ProductType = 6;
				switch(type) {
					case "100":
						app.ShowWebView(projectConfig.ViewId.Payment.Cashier.url, param, 'slide-in-right', projectConfig.ViewId.Payment.Cashier.Id);
						break;
					case "6":
						mui.confirm("确认取消订单？", "提示", ["点错了", "确定"], function(e) {
							if(e.index == 1) {
								app.showWaiting("订单取消中，请稍候...", 1);
								app.Post(CancelTrainOrderEntity, null, cancelOrderCallback);
								getDetail();
							}
						})
						break;
					case "200":
						plus.device.dial(link, true);
						break;
					case "304":
						app.ShowWebView(projectConfig.ViewId.Train.Index.url, {
							type: 1
						}, 'slide-in-right', projectConfig.ViewId.Train.Index.Id);
						break;
				}
			});

			$(".person-button").on("tap", function() {
				var type = $(this).attr("type");
				var link = $(this).attr("link");
				var id = $(this).parent().attr("pid");
				switch(type) {
					case "603":
						app.ShowWebView(projectConfig.ViewId.Train.modifyTrainDate.url, {
							OrderSerialNo: GetTrainOrderDetailEntity.data.SerialNo,
							PassengerId: id
						}, null, projectConfig.ViewId.Train.modifyTrainDate.Id);
						break;
					case "604":
						app.showWaiting('加载中...', 1);
						GetTrainRefundInfoEntity.data.PassengerId = id;
						app.Post(GetTrainRefundInfoEntity, null, getBackCallback)
						getDetail();
						break;
				}
			});
		}

		function getBackCallback(data) {
			if(app.GetResultState(data)) {
				data.RefundInfo.canback = data.RefundInfo.Price - data.RefundInfo.ServiceCharge - data.RefundInfo.RefundServicePrice;
				data.RefundInfo.needback = data.RefundInfo.ServiceCharge + data.RefundInfo.RefundServicePrice;
				data.RefundInfo.personId = GetTrainRefundInfoEntity.data.PassengerId
				var tmplHot1 = template('personback-template', data.RefundInfo);
				$("#popover").html(tmplHot1);

				var pheight = $("#popover").height()
				var pwidth = $("#popover").width()

				var wheight = $(window).height()
				var wwidth = $(window).width()

				var top = (wheight - pheight) / 2
				var left = (wwidth - pwidth) / 2

				$("#popover").css("top", top);
				$("#popover").css("left", left);

				mui('#popover').popover('toggle');
				$(".back-button-left").on("tap", function() {
					mui('#popover').popover('toggle');
				})
				$(".back-button-right").on("tap", function() {
					app.showWaiting('加载中...', 1);
					var pid = $(this).attr("pid");
					ApplyTrainOrderRefundEntity.data.PassengerIdList = []
					ApplyTrainOrderRefundEntity.data.PassengerIdList.push(pid);
					app.Post(ApplyTrainOrderRefundEntity, null, ApplyTrainOrderRefundCallback);
				})
			} else {
				app.showMsg(data.Msg)
			}
		}

		function ApplyTrainOrderRefundCallback(data) {
			if(app.GetResultState(data)) {
				getDetail();
				mui('#popover').popover('toggle');
			} else {
				app.showMsg(data.Msg);
			}
		}

		function getCountdown(leftTime) {
			var leftsecond = parseInt(leftTime / 1000);
			var day1 = Math.floor(leftsecond / (60 * 60 * 24));
			var hour = Math.floor((leftsecond - day1 * 24 * 60 * 60) / 3600);
			var minute = Math.floor((leftsecond - day1 * 24 * 60 * 60 - hour * 3600) / 60);
			var second = Math.floor(leftsecond - day1 * 24 * 60 * 60 - hour * 3600 - minute * 60);

			if(hour > 0) {
				return '<span class="button-time-content">' + hour + '</span>小时<span class="button-time-content">' + minute + '</span>分<span class="button-time-content">' + second + '</span>秒';
			} else if(minute > 0) {
				return '<span class="button-time-content">' + minute + '</span>分<span class="button-time-content">' + second + '</span>秒';
			} else if(second > 0) {
				return '<span class="button-time-content">' + second + '</span>秒';
			} else {
				return false;
			}
		}

		function runCountdown(type) {
			var $countdown = $('#date-content');
			var countdown = 0;
			_runPayOrderCountDown = setInterval(function() {
				countdown = parseInt($countdown.attr('date')) - 1000;
				if(!!getCountdown(countdown)) {
					$countdown.html(getCountdown(countdown)).attr('date', countdown);
					if($("#divtime").css("display") == "none")
						$("#divtime").show();
				} else {
					$(".button-time").hide();
					clearInterval(_runPayOrderCountDown);
					setTimeout(getDetail(),3000);
					return false;
				}
			}, 1000);
		}

		function getStateIcon(state) {
			switch(state) {
				case 0:
					{
						return "../images/plane/dsp.png";
					}
				case 1:
					{
						return "../images/plane/dsp.png";
					}
				case 2:
					{
						return "../images/plane/cpz.png";
					}
				case 3:
					{
						return "../images/plane/ycp.png";
					}
				case 4:
					{
						return "../images/plane/yqx.png";
					}
			}
		}

		return {
			init: init,
			GetTrainOrderDetailEntity: GetTrainOrderDetailEntity,
			GetTrainRefundInfoEntity: GetTrainRefundInfoEntity,
			ApplyTrainOrderRefundEntity: ApplyTrainOrderRefundEntity,
			CancelTrainOrderEntity: CancelTrainOrderEntity
		}
	})();
})(window, $);