(function(window, $){
	var isShowMore = false;
	var needId = '';
	var needType = '';
	var historyData = '';
	window.NewHotelArea = {
		init:function(){
			var wvs = plus.webview.currentWebview();
			var dests = wvs.dest;
			
			//当前的城市需求单
			needId = dests[0].Id;
			needType = dests[0].Type;
			historyData = wvs.historyData;
			var that = this;
			if(plus.os.name.toLowerCase() == 'ios'){
				var headerHeight = $("#header").height();
				var btmHeight = $("#search-btm").height();
				var documentHeight = $(document).height();
				var diffHeight = documentHeight - btmHeight - headerHeight - 100;
				$("#search-result").css({
					'min-height':diffHeight,
					'height':'auto'
				});
				$("#searchKey").bind('focus',function(){
					$(".btm").css('position','relative');
					//$('.search-result-container').css('position','static');
				}).bind('blur',function(){
					$(".btm").css('position','fixed');
					$(".search-result-container").css('position','absolute');
				});
			}
			template.helper('isInSelect',this.isInSelect);
			template.helper('checkExistId',this.checkExistId);
			this.initData(function(data){
				that.initTmpl(data);
			});
			this.initEvent();
		},
		initData:function(callback){
			var wv = plus.webview.currentWebview();
			var dest = wv.dest;
			app.Post({
				url:'Search/SearchAreaAndHotelV2',
				data:{
					keyWord:'',
					Dests:dest
				}
			},null,function(data){
				callback(data);
			});
		},
		initEvent:function(){
			var that = this;
			$("#action").off().on('tap',function(){
				var webViewChildren = plus.webview.currentWebview();
				var webViewParent = webViewChildren.opener();
				webViewChildren.close();
			});
			$("#submit-need").off().on('tap',function(){
				var set = app.getSettings();
				if(historyData.length>0){
					var totalHistory = set.customPackage.hotelAreaSearchHistory;
					
					var state = false;
					var _index = '';
					totalHistory.forEach(function(d, i){
						if(d.id == needId){
							state = true;
							_index = i;
						}
					});
					
					if(state == false){
						//不存在，新增
						totalHistory.push({
							id:needId,
							data:historyData
						});
					}else{
						//存在，替换
						totalHistory[_index].data = historyData;
					}
				
					app.setSettings(set);
					
					
					
					var webViewChildren = plus.webview.currentWebview();
					var webViewParent = webViewChildren.opener();
					webViewParent.evalJS("window.travelDemandDetail.callHotelArea()");
					webViewChildren.close();
				}else{
					plus.nativeUI.toast('请选择酒店区域');
				}
				
			});
			
			var isEndInput = true;
			$('#searchKey').on("input", function() {
				if(isEndInput) {
					that.getHotelAreaSearch($(this).val());
				}
			});
			$('#searchKey').on("compositionstart", function() {
				isEndInput = false;
			});
			$('#searchKey').on("compositionend", function() {
				isEndInput = true;
				if(isEndInput) {
					that.getHotelAreaSearch($(this).val());
				}
			});
			$('#searchKey').keyup(function(event) {
				if(event.keyCode == 13) {
					that.getHotelAreaSearch($(this).val());
				}
			});
			$("#form").on('submit',function(e){
				e.preventDefault();
				return false;
			});
			
			$("#close").off().on('tap',function(){
				$("#searchKey").val('');
				$("#init-container").show();
				$("#search-result").hide();
				$(this).hide();
			});
		},
		initTmpl:function(data){
			var arr = [];
			if(historyData.length>3){
				for(var i=historyData.length-3;i<=historyData.length-1;i++){
					arr.push(historyData[i]);
				}
			}else{
				arr = historyData;
			}
			
			//历史
			this.hotelSearchHistoryTemplate(app.getSettings().customPackage.hotelAreaSearchHistory, false, 0);
			
			//底部搜索池
			this.searchContentTemplate(arr);
			
			//初始化商业，品牌，行政区
			this.commericalListTemplate(data,false,3);
			this.brandListTemplate(data,false,1);
			this.districtListTemplate(data,false,2);
		},
		hotelSearchHistoryTemplate:function(hotelAreaSearchHistoryData, status, index){
			var cityData = [];
			hotelAreaSearchHistoryData.forEach(function(vv, ii){
				if(vv.id == needId){
					cityData = vv.data;
				}
			});
			var result = this.handleSearchData(cityData,status,index);
			var tmpl = template('hotelAreaSearchHistory-template',{
				hotelAreaSearchHistory:result
			});
			$("#hotelAreaSearchHistory").html(tmpl);
			if(result.length<=4){
				$(".history-content-list").css({
					'border-bottom':'none'
				});
			}
			this.initHotelSearchEvent();
		},
		commericalListTemplate:function(data, status, index){
			var result = this.handleSearchData(data.CommericalList,status,index);
			var tmpl = template('CommericalList-template',{
				CommericalList:result
			});
			$("#CommericalList").html(tmpl);
			this.initTmplEvent(data);
		},
		brandListTemplate:function(data, status, index){
			var result = this.handleSearchData(data.BrandList,status,index);
			var tmpl = template('BrandList-template',{
				BrandList:result
			});
			$("#BrandList").html(tmpl);
			this.initTmplEvent(data);
		},
		districtListTemplate:function(data, status, index){
			var result = this.handleSearchData(data.DistrictList,status,index);
			var tmpl = template('DistrictList-template',{
				DistrictList:result
			});
			$("#DistrictList").html(tmpl);
			this.initTmplEvent(data);
		},
		searchContentTemplate:function(data, state){
			var tmpl = template('search-content-template',{
				hotelAreaSearchHistory:data
			});
			$("#searchContent").html(tmpl);
			this.initBottomEvent();
			
			if( state && state == 1 ){
				$(".more").show();
			}else{
				if(data.length > 3){
					$(".more").show();
				}else{
					$('.more').hide();
				}
			}
			
		},
		handleSearchData:function(result, state, flag){
			
			/*
				state : true 全部展示 | false 收起
				flag: 1 品牌区 | 2 行政区 | 3 商业区
			*/
			if(! (result instanceof Array)){
				result = [];
			}
			var len = result.length;
			var num = len % 4;
			var arr = [];
			result.map(function(d){
				arr.push(d);
			})
			if(len > 8){

				if (state == true){
					//全部展示
					var diff = 4 - Number(num);
					for(var i=1; i<=diff; i++){
						if(i != diff){
							//补上空
							arr.push({
								Name:''
							});
						}else{
							//补上箭头
							arr.push({
								Name:'<div class="icon-container" data-status="true" data-index='+flag+'><i class="icon cee-iconfont icon-diankai-copy"></i></div>'
							});
						}
					}
				}else{
					//收起
					arr = [];
					for(var i=0;i< 8; i++){
						if(i != 7){
							arr.push(result[i]);
						}else{
							arr.push({
								Name:'<div class="icon-container" data-status="false" data-index='+flag+'><i class="icon cee-iconfont icon-shouqi"></i></div>'
							})
						}
					}
				}
			}else{
				//不足8但是取余之后补上4倍数之前的空格
				if(len != 0){
					var diff = 4 - Number(num);
					if(num != 0){
						for(var i=1; i<=diff; i++){
							//补上空
							arr.push({
								Name:''
							});
						}
					}
				}
			}
			return arr;
		},
		initBottomEvent:function(){
			var that = this;
			$(".close-icon").off().on('tap',function(){
				var id = $(this).attr('data-id');
				for(var i=0;i<historyData.length;i++){
					if(id == historyData[i].Id){
						historyData.splice(i,1);
						break;
					}
				}
				var _index = $('.close-icon').index(this);
				$(".lists").eq(_index).remove();
				if(historyData.length == 0){
					$("#search-history-content").hide();
				}
				$(".hotel-area-history-list").each(function(vv, ii ){
					if($(this).attr('data-id') == id){
						$(this).removeClass('active-list');
					}
				});
				$(".search-list").each(function(vv, ii ){
					if($(this).attr('data-id') == id){
						$(this).find('i').removeClass('selectd');
						$(this).find('i').removeClass('icon-duoxuan1');
						$(this).find('i').addClass('icon-duoxuan');
					}
				});
				if(isShowMore == true && historyData.length>3){
					that.searchContentTemplate(historyData);
					 
					$(".more").find('i').removeClass('icon-diankai-copy');
					$(".more").find('i').addClass('icon-shouqi');
					 
				}else{
					if(historyData.length>3){
						var arr = [];
						for(var i=historyData.length-3;i<=historyData.length-1;i++){
							arr.push(historyData[i]);
						}
						that.searchContentTemplate(arr,1);
					}else{
						that.searchContentTemplate(historyData);
						isShowMore = false;
					}
				}
				
			});
			
			$(".more").off().on('tap',function(){
				 
				if(isShowMore == false){
					that.searchContentTemplate(historyData);
					isShowMore = true;
					$(".more").find('i').removeClass('icon-diankai-copy');
					$(".more").find('i').addClass('icon-shouqi');
				}else{
					if(historyData.length>3){
						var arr = [];
						for(var i=historyData.length-3;i<=historyData.length-1;i++){
							arr.push(historyData[i]);
						}
						that.searchContentTemplate(arr,1);
					}else{
						that.searchContentTemplate(historyData);
					}
					isShowMore = false;
					$(".more").find('i').addClass('icon-diankai-copy');
					$(".more").find('i').removeClass('icon-shouqi');
				}
				
			});
		},
		initTmplEvent:function(data){
			var that = this;
			$(".icon-container").off().on('tap',function(){
				var state = false;
				var status = $(this).attr('data-status');
				if(status == 'false'){
					state = true;
				}
				var index = $(this).attr('data-index');
				switch(index){
					case "1":
						//品牌
						that.brandListTemplate(data, state, Number(index));
						break;
					case "2":
						//行政
						that.districtListTemplate(data, state, Number(index));
						break;
					case "3":
						//商业区
						that.commericalListTemplate(data, state, Number(index));
						break;
					default:
						//历史
						that.hotelSearchHistoryTemplate(app.getSettings().customPackage.hotelAreaSearchHistory, state, Number(index));
				}
			});
			
			$(".hotel-area-history-list").off().on('tap',function(){
				var id = $(this).attr('data-id');
				var type = $(this).attr('data-type');
				var name = $(this).attr('data-name');
				var starRate = $(this).attr('data-star-rate');
				var obj = {
					Id:Number(id),
					Type:Number(type),
					Name:name,
					StarRate:starRate?Number(starRate):''
				};
				if(id){
					var settings = app.getSettings();
					var state = that.checkId(historyData,id);
					if(state == false){
						if(historyData.length < 6){
							historyData.push(obj);
							
							//that.hotelSearchHistoryTemplate(settings.customPackage.hotelAreaSearchHistory, false, 0);
							$(this).addClass('active-list');
							
							if(isShowMore == true && historyData.length>3){
								that.searchContentTemplate(historyData);
								$(".more").find('i').removeClass('icon-diankai-copy');
								$(".more").find('i').addClass('icon-shouqi');
							}else{
								//底部搜索池
								if(historyData.length>3){
									var arr = [];
									for(var i=historyData.length-3;i<=historyData.length-1;i++){
										arr.push(historyData[i]);
									}
									that.searchContentTemplate(arr,1);
								}else{
									that.searchContentTemplate(historyData);
								}
							}
							
							
						}else{
							plus.nativeUI.toast('最多只能选择6个哦~');	
						}
					}
				}
			});
		},
		initHotelSearchEvent:function(){
			var that = this;
			//清除历史
			$(".hotel-area-title-clear").off().on('tap',function(){
				var settings = app.getSettings();
				
				settings.customPackage.hotelAreaSearchHistory.forEach(function(vv, ii){
					if(vv.id == needId){
						settings.customPackage.hotelAreaSearchHistory.splice(ii,1); 
					}
				});
				app.setSettings(settings);
				that.hotelSearchHistoryTemplate([], false, 0);
				that.searchContentTemplate(historyData);
			});
		},
		checkId:function(data, id){
			var flag = false;
			var id = Number(id);
			for(var i=0;i<data.length;i++){
				if(data[i].Id == id){
					flag = true;
					break;
				}
			}
			return flag;
		},
		isInSelect:function(id){
			var flag = false;
			var id = Number(id);
			var arrData = historyData;
			for(var i=0;i<arrData.length;i++){
				if(arrData[i].Id == id){
					flag = true;
					break;
				}
			}
			return flag;
		},
		getHotelAreaSearch:function(val){
			if(val == ''){
				$("#init-container").show();
				$("#search-result").hide();
				$("#close").hide();
			}else{
				$("#close").show();
				$("#init-container").hide();
				$("#search-result").show();
				this.sendRequest(val);
			}
		},
		sendRequest:function(val){
			var that = this;
			var wv = plus.webview.currentWebview();
			var dest = wv.dest;
			$(".btm").css("opacity",'0');
			app.Post({
				url:'Search/SearchAreaAndHotel',
				data:{
					keyWord:val,
					Dests:dest
				}
			},null,function(data){
				$(".btm").css("opacity",'1');
				if(data.Dests.length == 0){
					$(".btm").css('position','fixed');
					$(".search-result-container").css('position','absolute');
				}
				that.initSearchDestTemplate(data);
				 
			});
		},
		initSearchDestTemplate:function(data){
			var tmpl = template('search-dest-template',data);
			$("#search-result").html(tmpl);
			if(data.Dests.length == 0){
				var noData = '<div class="no-data">无搜索结果</div>';
				$("#search-result").append(noData);
			}
			this.initSearchDestEvent();
		},
		initSearchDestEvent:function(){
			var that = this;
			$(".search-list").off().on('tap',function(){
				$("#searchKey").blur();
				var Name = $(this).attr('data-name');
				var Id = $(this).attr('data-id');
				var Type = $(this).attr('data-type');
				var CityId = $(this).attr('data-city-id');
				var Desc = $(this).attr('data-desc');
				var Amount = $(this).attr('data-amount');
				var list = {
					Type:Type,
					Id:Id,
					Name:Name,
					CityId:CityId,
					Desc:Desc,
					Amount:Amount
				}
				var state = that.checkHasSelect(Id);
				if(state.flag == true){
					//已存在，那么取消
					that.cancleSearchHistory(state.index);
					$(".search-list").each(function(vv,ii){
						if($(this).attr('data-id') == Id){
							$(this).find('i').removeClass('icon-duoxuan1');
							$(this).find('i').removeClass('selectd');
							$(this).find('i').addClass('icon-duoxuan');
						}
					});
				}else{
					//不存在，那么添加
					if(historyData.length >= 6){
						plus.nativeUI.toast('最多只能选择6个哦~');
					}else{
						$(".search-list").each(function(vv,ii){
							if($(this).attr('data-id') == Id){
								$(this).find('i').removeClass('icon-duoxuan');
								$(this).find('i').addClass('icon-duoxuan1');
								$(this).find('i').addClass('selectd');
							}
						});
						
						that.addSearchHistory(list);
					}
					
				}
				that.reloadSearchHistory();
			});
		},
		reloadSearchHistory:function(){
			var that = this;
			if(historyData.length>3){
				var arr = [];
				for(var i=historyData.length-3;i<=historyData.length-1;i++){
					arr.push(historyData[i]);
				}
				that.searchContentTemplate(arr,1);
			}else{
				that.searchContentTemplate(historyData);
			}
		},
		checkHasSelect:function(id){
			var obj = {
				index:-1,
				flag:false
			}
			historyData.forEach(function(value, i){
				if(id == value.Id){
					obj.flag = true;
					obj.index = i;
				}
			});
			return obj;
		},
		cancleSearchHistory:function(index){
			
			historyData.splice(index,1);
			if(historyData.length == 0){
				$("#search-result").hide();
			}
		},
		addSearchHistory:function(list){
			historyData.push(list);
			$("#search-result").show();
		},
		checkExistId:function(id){
			var flag = false;
			historyData.forEach(function(v, i){
				if(v.Id == id){
					flag = true;
				}
			});
			return flag;
		}
	}
})(window, $)
