(function(window, $){
	var scroll = null;
	var scrollTop = 0;
	var speed = 200;
	var regx = /^[0-9]*$/;
	var splitStr = ",";
	var userSelect = {
		Meeting:{
			IsNeed:0,
			MeetingPerson:'',
			MeetingArea:'',
			MeetingPlaces:[],
			MeetingServices:[]
		},
		HotelDests:[],
		Star:[],
		UseCar:'',
		UseCarType:'',
		CarGrade:[],
		Count:'',
		IsGuide:0,
		PlayTypes:[],
		Scenic:'',
		Recommend:1,
		Meals:[],
		Amount:'',
		Other:'',
		//是否含早
		BreakfastIncluded:0,
		//停留几天
		StayDays:'',
		hotelAreaName:''
	};
	window.travelDemandDetail = {
		init:function(){
			scroll = mui("#plan-contentScroll").scroll();
			var wv = plus.webview.currentWebview();
			var data = wv.data;
			$("#areaTitle").text(data.name+'需求');
			$("#travel-area-result").text(data.name);
			$("#hotel-area").attr('data-id',data.id);
			$("#hotel-area").attr('data-type',data.type);
			$(".delete-order").attr('data-id',data.id);
			$(".delete-order").attr('data-name',data.name);
			$("#go-play-view-point").attr('data-id',data.id);
			$("#go-play-view-point").attr('data-type',data.type);
			this.initGuide();
			this.initEvent();
			this.initTmplData(data);
		},
		initEvent:function(){
			$("#is-need-monring").off().on('tap',function(){
				var isActive = document.getElementById("is-need-monring").classList.contains("mui-active");
				if(isActive){
					//需要
					 userSelect.BreakfastIncluded = 1;
				}else{
					//不需要
					 userSelect.BreakfastIncluded = 0;
				}
			});
			$("#go-play-view-point").off().on('tap',function(){
				var id = $(this).attr('data-id');
				var type = $(this).attr('data-type');
				app.ShowWebView('../Travel/newPlayViewPoint.html',{
					Id:id,
					Type:type,
					Recommend:userSelect.Recommend,
					travelViewPoint:$("#travel-view-point").text()
				});
			});
			
			$(".delete-order").off().on('tap',function(){
				var name = $(this).attr('data-name');
				var thisId = $(this).attr('data-id');
				mui.confirm('您确定要删除'+name+'的行程需求嘛？','提示',['取消','确定'],function(e){
					if(e.index == 1){
						var sets = app.getSettings();
						var endPlaceData = sets.customPackage.endPlace;
						endPlaceData.forEach(function(value, index){
							if(value.Id == thisId){
								endPlaceData.splice(index,1);
							}
						});
						sets.endPlace = endPlaceData;
						app.setSettings(sets);
						var webViewChildren = plus.webview.currentWebview();
						var webViewParent = webViewChildren.opener();
						webViewParent.evalJS("window.travelDemand.callDeleteTravel("+thisId+")");
						webViewChildren.close();
					}
				});	
			});
			
			$(".go-back-top").off().on('tap',function(e){
				e.preventDefault();
				mui('.mui-scroll-wrapper').scroll().scrollTo(0,0,100);//100毫秒滚动到顶
			});
			var scrolls = mui('.mui-scroll-wrapper').scroll();
			document.getElementById('plan-contentScroll').addEventListener('scrollend', function() {
				scrollTop = scrolls.y;
				if(scrolls.y<0){
					$(".go-back-top").show();
				}else{
					$(".go-back-top").hide();
				}
			});
			
			$("#mySwitch").off().on('tap',function(){
				var isActive = document.getElementById("mySwitch").classList.contains("mui-active");
				if(isActive){
					//需要
					//$("#mySwitch-style").addClass('my-switch-style');
					$("#join-meet").show();
					$("#need-meet").removeClass('border-bottom-none');
					userSelect.Meeting.IsNeed = 1;
				}else{
					//不需要
					$("#join-meet").hide();
					$("#need-meet").addClass('border-bottom-none');
					userSelect.Meeting.IsNeed = 0;
				}
			});
			
			//酒店区域搜索
			$("#hotel-area").off().on('tap',function(){
				var id = $(this).attr('data-id');
				var type = $(this).attr('data-type');
				var localData = app.getSettings();
				var historyData = localData.customPackage.hotelAreaSearchHistory;
				var thisCityData = [];
				historyData.forEach(function(value, index){
					if(value.id == id){
						thisCityData = value.data;
					}
				});
				app.ShowWebView('../Travel/newHotelArea.html',{
					dest:[
						{
							Id:id,
							Type:type
						}
					],
					historyData:thisCityData
				});
			});
		},
		initTmplData:function(data){
			//把初始化数据加入到内存中
			this.addInitData(data);
			var tmpl = template('travel-list-template',data);
			$("#travel-list-content").html(tmpl);
			this.initTmplEvent();
		},
		initTmplEvent:function(){
			var that = this;
			$("#mc").on('touchend',function(event){
				//event.stopPropagation();
				event.preventDefault();
				
			});
			
			$("#mc").on('touchmove',function(event){
				event.preventDefault();
			});
			
			$("#mc").on('tap',function(){
				$("#mc").hide();
				$(".prevent-default").hide();
				if(scrollTop<0){
					$(".go-back-top").show();
				}
			})
			
			$(".prevent-default").on('touchmove',function(event){
				event.preventDefault();
			});
			$(".prevent-default").on('touchend',function(event){
				event.preventDefault();
			});
			//弹出酒店星级选择
			$("#hotel-star-level").off().on('tap',function(){
				var state = $('#travel-area-result').attr("data-is-click");
				if(state == 'true'){
					$("#mc").show();
					$(".hotel-star-level").slideToggle(speed);
				}
				
				that.memoryState('.hotel-star-list',userSelect.Star);
			});
			
			//酒店星级点击
			$('.hot-star-lists').off().on('tap',function(){
				that.controlListState(".hot-star-lists",this,"#hotel-star-all",".hot-star-svg");
			});
			$("#hotel-star-all").off().on('tap',function(){
				that.controllAllState(this,".hot-star-svg",'.hot-star-lists','#hotel-star-all-svg');
			});
			//酒店星级
			$("#confirm-hotel-star-select").off().on('tap',function(){
				$("#mc").hide();
				$(".hotel-star-level").slideToggle(speed);
				var state = $("#hotel-star-all").attr('data-select');
				if(state == 'true'){
					//不限
					userSelect.Star = [0];
					var name = $("#hotel-star-all").attr('data-name');
					$("#hotel-star-result").text(name);
				}else{
					//非不限
					var hotelStarName = '';
					var idss = [];
					$(".hot-star-lists").each(function(index, value){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							idss.push(Number(id));
							//userSelect.Star = Number(id);
							if(hotelStarName == ''){
								hotelStarName = hotelStarName + name;
							}else{
								hotelStarName = hotelStarName + splitStr + name;
							}
						}
					});
					userSelect.Star = idss;
					$("#hotel-star-result").text(hotelStarName);
				}
				$("#hotel-star-level").attr('data-optional','true');
				that.handleHotelStarEvent();
				that.handleIsShowBackTop();
			});
			
			//弹出参会人数选择
			$("#meet-need-people").off().on('tap',function(){
				$("#mc").show();
				$(".meet-need-people-num").slideToggle(speed);
				that.memorySingleState('.meet-need-people-num-list',userSelect.Meeting.MeetingPerson);
			});
			//会场要求,人数,会场大小
			$(".meet-need-people-num-list").off().on('tap',function(){
				that.controlSingleState('.meet-need-people-num-list','.meet-people-list-svg',this)
			});
			//确认参会人数
			$("#confirm-meet-people-num").off().on('tap',function(){
				$("#mc").hide();
				$(".meet-need-people-num").slideToggle(speed);
				$(".meet-need-people-num-list").each(function(index,value){
					var state = $(this).attr('data-select');
					if(state == 'true'){
						var num = $(this).attr('data-id');
						var name = $(this).attr('data-name');
						userSelect.Meeting.MeetingPerson = Number(num);
						$("#join-meet-people-num").text(name);
					}
				});
				that.handleIsShowBackTop();
			});
			//弹出会场面积选择
			$("#meet-area").off().on('tap',function(){
				$("#mc").show();
				$(".meet-area").slideToggle(speed);
				that.memorySingleState('.meet-area-list',userSelect.Meeting.MeetingArea);
			});
			//会场面积
			$(".meet-area-list").off().on('tap',function(){
				that.controlSingleState('.meet-area-list','.meet-area-list-svg',this)
			});
			
			//会场类型
			$(".meet-type-lists").off().on('tap',function(){
				that.controlListState(".meet-type-lists",this,"#meet-type-unlimit",".meet-type-list-svg");
			});
			
			//回城类型不限
			$("#meet-type-unlimit").off().on('tap',function(){
				that.controllAllState(this,".meet-type-list-svg",'.meet-type-lists','#meet-type-unlimit-svg');
			});
			
			//会场服务
			$(".meet-service-lists").off().on('tap',function(){
				that.controlListState(".meet-service-lists",this,"#meet-service-unlimit",".meet-service-list-svg");
			});
			
			//会场服务不限
			$("#meet-service-unlimit").off().on('tap',function(){
				that.controllAllState(this,".meet-service-list-svg",'.meet-service-lists','#meet-service-unlimit-svg');
			});
			//确认会场面积
			$("#confirm-meet-area").off().on('tap',function(){
				$("#mc").hide();
				$(".meet-area").slideToggle(speed);
				$(".meet-area-list").each(function(index,value){
					var state = $(this).attr('data-select');
					if(state == 'true'){
						var id = $(this).attr('data-id');
						var name = $(this).attr('data-name');
						userSelect.Meeting.MeetingArea = Number(id);
						$("#meet-area-result").text(name);
					}
				});
				that.handleIsShowBackTop();
			});
			
			//弹出会场面积选择
			$("#meet-area").off().on('tap',function(){
				$("#mc").show();
				$(".meet-area").slideToggle(speed);
				that.memorySingleState('.meet-area-list',userSelect.Meeting.MeetingArea);
			});
			
			//会场类型确认
			$("#confirm-meet-type-select").off().on('tap',function(){
				$("#mc").hide();
				$(".meet-type").slideToggle(speed);
				var state = $("#meet-type-unlimit").attr('data-select');
				if(state == 'false'){
					//没有不限
					var arr = [];
					var resultStr = '';
					$(".meet-type-lists").each(function(index,value){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							arr.push(Number(id));
							if(resultStr == ''){
								resultStr = resultStr + name;
							}else{
								resultStr = resultStr + splitStr + name;
							}
						}
					});
					userSelect.Meeting.MeetingPlaces = arr;
					$("#meet-type-result").text(resultStr);
				}else{
					//不限
					userSelect.Meeting.MeetingPlaces = [0];
					var name = $("#meet-type-unlimit").attr('data-name');
					$("#meet-type-result").text(name);
				}
				that.handleIsShowBackTop();
			});
			
			//弹出会场类型选择
			$("#meet-type").off().on('tap',function(){
				$("#mc").show();
				$(".meet-type").slideToggle(speed);
				that.memoryState('.meet-type-list',userSelect.Meeting.MeetingPlaces);
			});
			
			//会场服务确认
			$("#confirm-meet-service-select").off().on('tap',function(){
				$("#mc").hide();
				$(".meet-service").slideToggle(speed);
				var state = $("#meet-service-unlimit").attr('data-select');
				if(state == 'true'){
					//不限
					userSelect.Meeting.MeetingServices = [0];
					var name = $("#meet-service-unlimit").attr('data-name');
					$("#meet-service-result").text(name);
				}else{
					var arr = [];
					var resultName = '';
					$(".meet-service-lists").each(function(index,value){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							arr.push(Number(id));
							if(resultName == ''){
								resultName = resultName + name;
							}else{
								resultName = resultName + splitStr + name;
							}
						}
					});
					userSelect.Meeting.MeetingServices = arr;
					$("#meet-service-result").text(resultName);
				}
				that.handleIsShowBackTop();
			});
			
			//会场服务弹框
			$("#meet-service").off().on('tap',function(){
				$("#mc").show();
				$(".meet-service").slideToggle(speed);
				that.memoryState('.meet-service-list',userSelect.Meeting.MeetingServices);
			});
			//车辆用途确定
			$("#confirm-car-purpose").off().on('tap',function(){
				$("#mc").hide();
				$(".car-purpose").slideToggle(speed);
				$(".car-purpose-list").each(function(index, value){
					var state = $(this).attr('data-select');
					if(state == 'true'){
						var id = $(this).attr('data-id');
						var name = $(this).attr('data-name');
						userSelect.UseCar = Number(id);
						$("#car-purpose-result").text(name);
					}
				});
				if(userSelect.UseCar != 0){
					$("#get-seat-num").removeAttr('readonly');
					$('#is-use-car-container').show();
					$("#car-purpose").removeClass('border-bottom-none');
					$("#is-need-dy").removeClass('border-top');
					$("#is-need-dy").addClass('travel-need-list');
				}else{
					$("#get-seat-num").attr('readonly','true');
					$('#is-use-car-container').hide();
					$("#car-purpose").addClass('border-bottom-none');
					$("#is-need-dy").addClass('border-top');
					$("#is-need-dy").removeClass('travel-need-list');
				}
				that.handleIsShowBackTop();
			});
			
			//车辆用途弹出层
			$("#car-purpose").off().on('tap',function(){
				$("#mc").show();
				$(".car-purpose").slideToggle(speed);
				that.memorySingleState('.car-purpose-list',userSelect.UseCar);
			});
			
			//确认车辆档次
			$("#confirm-car-level-select").off().on('tap',function(){
				$("#mc").hide();
				$(".car-level").slideToggle(speed);
				var state = $('#car-level-unlimit').attr('data-select');
				if(state == 'true'){
					//不限
					userSelect.CarGrade = [0];
					var name = $('#car-level-unlimit').attr('data-name');
					$("#car-level-result").text(name);
				}else{
					var ids = [];
					var resultName = '';
					$(".car-level-lists").each(function(index, value){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							ids.push(Number(id));
							if(resultName == ""){
								resultName = resultName + name;
							}else{
								resultName = resultName + splitStr + name;
							}
						}
					});
					userSelect.CarGrade = ids;
					$("#car-level-result").text(resultName);
				}
				that.handleIsShowBackTop();
			});
			
			//车辆档次弹出
			$("#car-level").off().on('tap',function(){
				var useType = userSelect.UseCar;
				if(useType != 0){
					$("#mc").show();
					$(".car-level").slideToggle(speed);
					that.memoryState('.car-level-list',userSelect.CarGrade);
				}
				
			});
			
			//游玩类型
			$("#confirm-play-type-select").off().on('tap',function(){
				$("#mc").hide();
				$(".play-type").slideToggle(speed);
				var state = $("#play-type-unlimit").attr('data-select');
				if(state == 'true'){
					//不限
					userSelect.PlayTypes = [0];
					var name = $("#play-type-unlimit").attr('data-name');
					$("#play-type-result").text(name);
					$("#is-need-play").hide();
					$("#play-type").addClass('border-bottom-none');
				}else{
					var ids = [];
					var resultName = '';
					$(".play-type-lists").each(function(){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							ids.push(Number(id));
							if(resultName == ''){
								resultName = resultName + name;
							}else{
								resultName = resultName + splitStr + name;
							}
						}
					});
					userSelect.PlayTypes = ids;
					$("#play-type-result").text(resultName);
					$("#is-need-play").show();
					$("#play-type").removeClass('border-bottom-none');
				}
				that.handleIsShowBackTop();
			});
			
			//游玩类型弹框
			$("#play-type").off().on('tap',function(){
				$("#mc").show();
				$(".play-type").slideToggle(speed);
				that.memoryState('.play-type-list',userSelect.PlayTypes);
			});
			
			//用餐类型
			$("#confirm-eat-type-area").off().on('tap',function(e){

				$("#mc").hide();
				$(".eat-type").slideToggle(speed);
				
				var state = $("#eat-type-unlimit").attr('data-select');
				if(state == 'true'){
					//不限
					userSelect.Meals = [0];
					var name = $("#eat-type-unlimit").attr('data-name');
					$("#eat-type-result").text(name);
					$("#is-eat-type").hide();
					$("#eat-type").addClass('border-bottom-none');
				}else{
					//非不限
					var ids = [];
					var resultStr = '';
					$(".eat-type-lists").each(function(index, value){
						var status = $(this).attr('data-select');
						if(status == 'true'){
							var id = $(this).attr('data-id');
							var name = $(this).attr('data-name');
							ids.push(id);
							if(resultStr == ''){
								resultStr = resultStr + name;
							}else{
								resultStr = resultStr + splitStr + name;
							}
						}
					});
					$("#eat-type-result").text(resultStr);
					userSelect.Meals = ids;
					$("#is-eat-type").show();
					$("#eat-type").removeClass('border-bottom-none');
					$("#eat-money-num").focus();
				}
				that.handleIsShowBackTop();
			});
			
			//用餐类型弹出框
			$("#eat-type").off().on('tap',function(){
				$("#mc").show();
				$(".eat-type").slideToggle(speed);
				that.memoryState('.eat-type-list',userSelect.Meals);
			});
			//车辆用途
			$(".car-purpose-list").off().on('tap',function(){
				that.controlSingleState('.car-purpose-list','.car-purpose-list-svg',this);
			});
			
			//车辆档次
			$(".car-level-lists").off().on('tap',function(){
				that.controlListState(".car-level-lists",this,"#car-level-unlimit",".car-level-list-svg");
			});
			
			//车辆不限
			$("#car-level-unlimit").off().on('tap',function(){
				that.controllAllState(this,".car-level-list-svg",'.car-level-lists','#car-level-unlimit-svg');
			});
			
			//游玩类型
			$(".play-type-lists").off().on('tap',function(){
				that.controlListState(".play-type-lists",this,"#play-type-unlimit",".play-type-list-svg");
			});
			
			//游玩类型不限
			$("#play-type-unlimit").off().on('tap',function(){
				that.controllAllState(this,".play-type-list-svg",'.play-type-lists','#play-type-unlimit-svg');
			});
			
			//用餐类型
			$(".eat-type-list").off().on('tap',function(){
				that.controlListState(".eat-type-lists",this,"#eat-type-unlimit",".eat-type-list-svg");
			});
			
			//用餐自理
			$("#eat-type-unlimit").off().on('tap',function(){
				that.controllAllState(this,".eat-type-list-svg",'.eat-type-lists','#eat-type-unlimit-svg');
			});
			$("#other-need-textarea").on('input',function(e){
				var len = $(this).val().toString().length;
				len = Number(len);
				if(Number(len)<=500){
					$("#has-enter-word-num").text(len);
				}else{
					var content = $(this).val().toString();
					content = content.substr(0,499);
					$(this).val(content);
				}
			});
			
			$("#isNeedCar").off().on('tap',function(){
				var isActive = document.getElementById("isNeedCar").classList.contains("mui-active");
				if(isActive){
					userSelect.IsGuide = 1;
				}else{
					userSelect.IsGuide = 0;
				}
			});
			
			$("#save").off().on('tap',function(){
				that.authInfo(function(){
					//Persons 大人,小孩
					userSelect.Persons = [
						{
							PersonType:1,
							PersonCount:Number($("#adult-seat-num").val()),
							TypeName:null
						},
						{
							PersonType:2,
							PersonCount:Number($("#children-seat-num").val()),
							TypeName:null
						}
					];
					//用车座位数量
					userSelect.Count = $("#get-seat-num").val();
					
					//旅游景点
					userSelect.Scenic = $("#travel-view-point").text() + $("#select-view").text();
					
					//用餐标准
					userSelect.Amount = $("#eat-money-num").val();
					
					//预算
					userSelect.Budget = $("#every-people-money").val();
					
					//其他需求
					userSelect.Other = $("#other-need-textarea").val();
					
					//添加停留天数
					userSelect.StayDays = Number($("#stay-delay").val());
					
					//酒店区域名称
					userSelect.hotelAreaName = $("#travel-area-result").text();
					
					var thisId = $("#hotel-area").attr('data-id');
					var thisType = $("#hotel-area").attr('data-type');
					var webViewChildren = plus.webview.currentWebview();
					var webViewParent = webViewChildren.opener();
					webViewParent.evalJS('window.travelDemand.callSaveDemand(' + JSON.stringify(userSelect) + ', ' + thisId + ', ' + thisType + ')');
					webViewChildren.close();
				});
			});
		},
		memoryState:function(classDom, data){
			$(classDom).each(function(index, value){
				var _this = this;
				var id = $(this).attr('data-id');
				$(this).attr('data-select','false');
				if(id == 0){
					$(this).find('use').attr('xlink:href','');
				}else{
					$(this).find('use').attr('xlink:href','#icon-duoxuan');
				}
				
				$(this).removeClass('active-word');
				data.forEach(function(vv,ii){
					if(id == vv){
						$(_this).attr('data-select','true');
						if(id == 0){
							$(_this).find('use').attr('xlink:href','#icon-yixuan1');
						}else{
							$(_this).find('use').attr('xlink:href','#icon-duoxuan1');
						}
						
						$(_this).addClass('active-word');
					}
				});
			});
			this.handleBackTop();
		},
		controlListState:function(listDom, _this, unlimitDom, listSvgDom){
			var index = $(listDom).index(_this);
			var state = $(_this).attr('data-select');
			var isSelectAll = $(unlimitDom).attr('data-select');
			if(!isSelectAll || isSelectAll == 'false'){
				if(state == 'false'){
					$(listSvgDom).eq(index).attr('xlink:href','#icon-duoxuan1');
					$(_this).attr('data-select','true');
					$(_this).addClass('active-word');
				}else{
					$(listSvgDom).eq(index).attr('xlink:href','#icon-duoxuan');
					$(_this).attr('data-select','false');
					$(_this).removeClass('active-word');
				}
			}else{
				$(unlimitDom).attr('data-select','false');
				$(_this).attr('data-select','true');
				$(_this).addClass('active-word');
				$(listSvgDom).eq(index).attr('xlink:href','#icon-duoxuan1');
				$(unlimitDom).find('use').attr('xlink:href','');
				$(unlimitDom).removeClass('active-word');
			}
		},
		controllAllState:function(_this, listSvgDom, listDom, unLimitSvgDom){
			var state = $(_this).attr('data-select');
			if(state == 'false'){
				$(listSvgDom).each(function(index,value){
					$(this).attr('xlink:href','#icon-duoxuan');
					$(listDom).eq(index).attr('data-select','false');
					$(listDom).eq(index).removeClass('active-word');
				})
				$(_this).attr('data-select','true');
				$(_this).addClass('active-word');
				$(unLimitSvgDom).attr('xlink:href','#icon-yixuan1');
			}else{
				$(_this).attr('data-select','false');
				$(unLimitSvgDom).attr('xlink:href','');
			}
		},
		handleHotelStarEvent:function(){
			var state = $("#hotel-star-level").attr('data-optional');
			if(state == 'true'){
				$("#optional").show();
			}else{
				$("#optional").hide();
			}
		},
		memorySingleState:function(classDom, data){
			$(classDom).each(function(index, value){
				var _this = this;
				var id = $(this).attr('data-id');
				$(this).attr('data-select','false');
				 
				$(this).find('use').attr('xlink:href','');
				
				$(this).removeClass('meet-people-num-active');
				 
				if(id == data){
					$(_this).attr('data-select','true');
					 
						$(_this).find('use').attr('xlink:href','#icon-yixuan1');
					 
					
					$(_this).addClass('meet-people-num-active');
				}
				 
			});
			this.handleBackTop();
		},
		controlSingleState:function(listDom, listSvg, _this){
			$(listDom).each(function(index,value){
				$(this).attr('data-select','false');
				$(listSvg).eq(index).attr('xlink:href','');
			});
			$(_this).attr('data-select','true');
			var index = $(listDom).index(_this);
			$(listDom).removeClass('meet-people-num-active');
			$(_this).addClass('meet-people-num-active');
			$(listSvg).eq(index).attr('xlink:href','#icon-yixuan1');
		},
		addInitData:function(data){
			userSelect.HotelDests = [
				{
					Type:Number(data.type),
					Id:Number(data.id)
				}
			];
			var setData = app.getSettings().customPackage;
			$("#adult-seat-num").val(setData.ticket.adultNum);
			$("#children-seat-num").val(setData.ticket.childrenNum);
			
			//在data之前加入之前填写过的记忆数据
			if(data.existData){
				//酒店区域
				userSelect.HotelDests = data.existData.Hotel.Dests;
				userSelect.hotelAreaName = data.existData.hotelAreaName;
				$("#travel-area-result").text(userSelect.hotelAreaName);
				
				//记忆酒店星级
				this.memoryUserData(data.Hotel.HotelStar,data.existData.Hotel.Star);

				//记忆参会人数
				this.memoryUserSingleData(data.Hotel.MeetingPerson,data.existData.Hotel.Meeting.MeetingPerson);
				
				//会场面积
				this.memoryUserSingleData(data.Hotel.MeetingArea,data.existData.Hotel.Meeting.MeetingArea);
				
				//会场类型
				this.memoryUserData(data.Hotel.MeetingPlace,data.existData.Hotel.Meeting.MeetingPlaces);
				
				//会场服务
				this.memoryUserData(data.Hotel.MeetingService,data.existData.Hotel.Meeting.MeetingServices);
				
				//车辆用途
				this.memoryUserSingleData(data.UseCar.UseCarType,data.existData.UseCar.UseCar);
				
				//车辆档次
				this.memoryUserData(data.UseCar.CarGrade,data.existData.UseCar.CarGrade);
				
				//游玩类型
				this.memoryUserData(data.Play.PlayType,data.existData.Play.PlayTypes);
				
				//用餐类型
				this.memoryUserData(data.Meals.MealsType,data.existData.Meals.Meals);
				
				//是否需要会场
				userSelect.Meeting.IsNeed = data.existData.Hotel.Meeting.IsNeed;
				if(userSelect.Meeting.IsNeed == 1){
					$("#join-meet").show();
					$("#need-meet").removeClass('border-bottom-none');
					$("#mySwitch").addClass('mui-active');
				}
				
				
				//是否需要导游
				userSelect.IsGuide = data.existData.UseCar.IsGuide;
				if(userSelect.IsGuide == 1){
					$("#isNeedCar").addClass('mui-active');
				}
				
				//座位数量
				userSelect.Count = data.existData.UseCar.Count;
				$("#get-seat-num").val(userSelect.Count);
				
				//游玩需求 成人+儿童
				var ad = '';
				var cl = '';
				data.existData.Play.person.map(function(item){
					if(item.PersonType == 1){
						//成人
						ad = item.PersonCount;
					}
					if(item.PersonType == 2){
						cl = item.PersonCount;
					}
				});
				$("#adult-seat-num").val(ad);
				$("#children-seat-num").val(cl);
				
				//用餐标准
				userSelect.Amount = data.existData.Meals.Amount;
				$("#eat-money-num").val(userSelect.Amount);
				
				//停留几天
				userSelect.StayDays = data.existData.StayDays;
				$("#stay-delay").val(userSelect.StayDays);
				
				//需要含早
				userSelect.BreakfastIncluded = data.existData.Hotel.BreakfastIncluded;
				if(userSelect.BreakfastIncluded == 1){
					//含早
					$("#is-need-monring").addClass('mui-active');
				}
				//其他需求
				userSelect.Other = data.existData.Other;
				$("#other-need-textarea").val(userSelect.Other);
				$("#has-enter-word-num").text(userSelect.Other.length);
			}
			
			
			
			//酒店星级
			var HotelStar = data.Hotel.HotelStar;
			var flag = false;
			HotelStar.forEach(function(v){
				if(v.IsSelect == 1){
					flag = true;
				}
			});
			
			if(flag == true){
				$("#hotel-star-level").attr('data-optional','true');
			}
			
			//参会人数
			var MeetingPerson = data.Hotel.MeetingPerson;
			
			//会场面积
			var MeetingArea = data.Hotel.MeetingArea;
			
			//参会类型
			var MeetingPlace = data.Hotel.MeetingPlace;
			
			//会场服务
			var MeetingServices = data.Hotel.MeetingService;
			
			//车辆用途
			var UseCarType = data.UseCar.UseCarType;
			
			var isUseId = '';
			UseCarType.forEach(function(vv){
				if(vv.IsSelect == 1){
					isUseId = vv.Id;
				}
			});
			if(isUseId == 0){
				$("#get-seat-num").attr('readonly','true');
				$('#is-use-car-container').hide();
				$("#car-purpose").addClass('border-bottom-none');
			}
			
			//车辆档次
			var CarGrade = data.UseCar.CarGrade;
			
			//游玩类型
			var PlayType = data.Play.PlayType;
			
			//用餐类型
			var MealsType = data.Meals.MealsType;
			//用餐标准
			var MealsPrice = data.Meals.MealsPrice;
			if(MealsPrice != 0){
				$("#eat-money-num").val(MealsPrice);
				userSelect.Amount = MealsPrice;
			}
			var isPlayType = [];
			PlayType.forEach(function(vv){
				if(vv.IsSelect == 1){
					isPlayType.push(vv.Id);
				}
			});
			if($.inArray(0,isPlayType)>=0){
				$("#is-need-play").hide();
				$("#play-type").addClass('border-bottom-none');
			}
			
			var isMealTypes = [];
			MealsType.forEach(function(vv){
				if(vv.IsSelect == 1){
					isMealTypes.push(vv.Id);
				}
			});
			
			if($.inArray(0,isMealTypes)>=0){
				$("#is-eat-type").hide();
				$("#eat-type").addClass('border-bottom-none');
			}
			
			
			this.insertDomData(HotelStar,'#hotel-star-result','Star','请选择酒店星级');
			this.insertSingleData(MeetingPerson,'#join-meet-people-num','Meeting.MeetingPerson','请选择参会人数');
			this.insertSingleData(MeetingArea,'#meet-area-result','Meeting.MeetingArea','请选择会场面积');
			this.insertDomData(MeetingPlace,'#meet-type-result','Meeting.MeetingPlaces','请选择会场类型');
			this.insertDomData(MeetingServices,'#meet-service-result','Meeting.MeetingServices','请选择会场服务');
			this.insertSingleData(UseCarType,'#car-purpose-result','UseCar','请选择车辆用途');
			this.insertDomData(CarGrade,'#car-level-result','CarGrade','请选择车辆档次');
			this.insertDomData(PlayType,'#play-type-result','PlayTypes','请选择游玩类型');
			this.insertDomData(MealsType,'#eat-type-result','Meals','请选择用餐类型');
		},
		insertDomData:function(arr, dom, listObj, word){
			var str = '';
			var ids = [];
			arr.forEach(function(v){
				if(v.IsSelect == 1){
					if(str == ''){
						str = str + v.Name;
					}else{
						str = str + splitStr + v.Name;
					}
					ids.push(v.Id);
				}
			});
			if(str != ''){
				$(dom).text(str);
			}else{
				$(dom).html("<span style='color:#999'>"+ word +"</span>");
			}
			
			if(ids.length>0){
				if(listObj.split('.').length>1){
					userSelect[listObj.split('.')[0]][listObj.split('.')[1]] = ids;
				}else{
					userSelect[listObj] = ids;
				}
			}
		},
		insertSingleData:function(arr, dom, listObj, word){
			var str = '';
			var id = '';
			arr.forEach(function(v){
				if(v.IsSelect == 1){
					if(str == ''){
						str = str + v.Name;
					}else{
						str = str + splitStr + v.Name;
					}
					id = v.Id;
				}
			});
			if(str != ''){
				$(dom).text(str);
			}else{
				$(dom).html("<span style='color:#999'>"+ word +"</span>");
			}
			//userSelect[listObj] = Number(id);
			if(id != ''){
				if(listObj.split('.').length>1){
					userSelect[listObj.split('.')[0]][listObj.split('.')[1]] = Number(id);
				}else{
					userSelect[listObj] = Number(id);
				}
			}
		},
		authInfo:function(callback){
			//验证用户填写信息
			if(userSelect.HotelDests.length == 0){
				plus.nativeUI.toast('请选择酒店区域');
				return;
			}
			if(userSelect.Star.length == 0){
				plus.nativeUI.toast('请选择酒店星级');
				return;
			}
			if(userSelect.Meeting.IsNeed == 1){
				if(userSelect.Meeting.MeetingPerson == ''){
					plus.nativeUI.toast('请选择参会人数');
					return;
				}
			}
			if(userSelect.UseCar != 0){
				if(userSelect.CarGrade.length == 0){
					plus.nativeUI.toast('请选择车辆档次');
					return;
				}
				if($("#get-seat-num").val() == ''){
					plus.nativeUI.toast('请填写座位数量');
					return;
				}
				if(!regx.test($("#get-seat-num").val())){
					plus.nativeUI.toast('座位数量须为数字');
					return;
				}
			}
			if( $.inArray(0,userSelect.PlayTypes) < 0 ){
//				if($("#adult-seat-num").val() == ''){
//					plus.nativeUI.toast('请填写成人游玩人数');
//					return;
//				}
//				if($("#children-seat-num").val() == ''){
//					plus.nativeUI.toast('请填写儿童出游人数');
//					return;
//				}
				if($("#adult-seat-num").val() != ''){
					if(!regx.test($("#adult-seat-num").val())){
						plus.nativeUI.toast('成人游玩人数必须为数字');
						return;
					}
				}
				if($("#children-seat-num").val() != ''){
					if(!regx.test($("#children-seat-num").val())){
						plus.nativeUI.toast('儿童出游人数必须为数字');
						return;
					}
				}
				
			}
			
			if($.inArray(0,userSelect.Meals)<0){
				if($("#eat-money-num").val() == ''){
					plus.nativeUI.toast('请填写用餐标准');
					return;
				}
				if(!regx.test($("#eat-money-num").val())){
					plus.nativeUI.toast('用餐标准必须为数字');
					return;
				}
			}
//			if( $("#stay-delay").val() == '' ){
//				plus.nativeUI.toast('请填写停留天数');
//				return;
//			}
			if($("#stay-delay").val() != ''){
				if( !regx.test($("#stay-delay").val()) ){
					plus.nativeUI.toast('停留天数必须为数字');
					return;
				}
			}
			
			callback();
		},
		callHotelArea:function(){
			var id = $("#hotel-area").attr('data-id');
			var set = app.getSettings();
			var hotelArea = [];
			set.customPackage.hotelAreaSearchHistory.forEach(function(vv, ii){
				if(vv.id == id){
					hotelArea = vv.data;
				}
			});
			//如果用户选择的酒店区域为多个，那么酒店星级不做任何处理
			if(hotelArea.length>1){
				var str = '';
				hotelArea.forEach(function(v){
					if(str == ''){
						str = str + v.Name;
					}else{
						str = str + splitStr + v.Name;
					}
				});
				$("#travel-area-result").text(str);
				$("#hotel-star-result").text('');
				var arr = [];
				hotelArea.forEach(function(value, index){
					arr.push({
						Type:value.Type,
						Id:value.Id
					});
				});
				userSelect.HotelDests = arr;
				userSelect.Star = [];
			}else{
				//为单个酒店区域,那么绑上星级，但是用户还是可以手动修改星级Star
				var starNum = hotelArea[0].StarRate;
				if(starNum){
					userSelect.Star = [Number(starNum)];
					$("#hotel-star-result").text(this.getStarName(starNum));
				}
				$("#travel-area-result").text(hotelArea[0].Name);
				var arr = [];
				hotelArea.forEach(function(value, index){
					arr.push({
						Type:value.Type,
						Id:value.Id
					});
				});
				userSelect.HotelDests = arr;
			}
		},
		getStarName:function(starRate){
			var starRate = Number(starRate);
			var starRateName = '';
			switch(starRate){
				case 1:
					starRateName = '一星级';
					break;
				case 2:
					starRateName = '二星级';
					break;
				case 3:
					starRateName = '三星级';
					break;
				case 4:
					starRateName = '四星级';
					break;
				case 5:
					starRateName = '五星级';
					break;
				case 6:
					starRateName = '六星级';
					break;
			}
			return starRateName;
		},
		callhotView:function(Scenic, isRecommand){
			userSelect.Scenic = Scenic;
			var thatId = $("#hotel-area").attr('data-id');
			
			var str = '';
			var playViewHistory = app.getSettings().customPackage.playViewHistory;
			playViewHistory.forEach(function(value, index){
				if(value.id == thatId){
					value.data.map(function(item){
						if(str == ''){
							str = str + item.SightName;
						}else{
							str = str + splitStr + item.SightName;
						}
					});
				}
			});
			$("#travel-view-point").text(Scenic);
			$("#select-view").text(str); 
			if(isRecommand == "true"){
				userSelect.isRecommand = 1;
				userSelect.Recommend = 1;
				$("#local-travel").text('地接社推荐');
			}else{
				userSelect.isRecommand = 0;
				userSelect.Recommend = 0;
				$("#local-travel").text('');
			}
		},
		memoryUserData:function(data, hasSelect){
			//data 原来后台拉去的初始化数据结构
			//hasSelect已经选择过的list
			data.forEach(function(v, i){
				data[i].IsSelect = 0;
			})
			hasSelect.forEach(function(valueId, index){
				data.forEach(function(vv, ii){
					if(valueId == vv.Id){
						data[ii].IsSelect = 1;
					}
				})
			});
		},
		memoryUserSingleData:function(data, hasSelect){
			data.forEach(function(value, index){
				if(value.Id == hasSelect){
					data[index].IsSelect = 1;
				}else{
					data[index].IsSelect = 0;
				}
			});
		},
		initGuide:function(){
			var settings = app.getSettings();
			var isFirstSeeTravelDetail = settings.customPackage.isFirstSeeTravelDetail;
			if(isFirstSeeTravelDetail == true){
				$("#modal").show();
				$(".delete-travel-container").show();
				$(".next-complete").off().on('tap',function(){
					$("#modal").hide();
					$(".delete-travel-container").remove();
					settings.customPackage.isFirstSeeTravelDetail = false;
					app.setSettings(settings);
				});
				
			}
		},
		handleBackTop:function(){
			$(".go-back-top").hide();
		},
		handleIsShowBackTop:function(){
			if(scrollTop<0){
				$(".go-back-top").show();
			}
		}
	}
})(window, $);
