(function(window, $) {
	window.Trip = (function() {
		var idConfig = {
			back: 'Trip_back',
			startDest: 'custom-start-position',
			endDest: 'custom-end-position'
		}

		function init() {
			initParam();
			initEvent();
		}

		function initEvent() {
			initBack();
			initChooseCity("s", idConfig.startDest);
			initChooseCity("e", idConfig.endDest);
			initPerson();
			goNext();
		}

		function initBack() {
			var $back = app.$el(idConfig.back);
			$back.off().on('tap', function() {
				mui.back();
			})
		}

		function initChooseCity(sore, city) {
			app.$el(city).off().on('tap', function() {
				var $this = $(this);
				app.ShowWebView(projectConfig.viewid.MICE.destination.url, {
					Id: $this.attr('data-id'),
					Type: $this.attr('data-type'),
					fnName: 'window.Trip.setCity',
					sore: sore
				}, null, projectConfig.viewid.MICE.destination.Id);
			});
			$(".destination-icon").off().on('tap', function() {
				var $this = $(this);
				app.ShowWebView(projectConfig.viewid.MICE.destination.url, {
					Id: $this.attr('data-id'),
					Type: $this.attr('data-type'),
					fnName: 'window.Trip.setCity',
					sore: sore
				}, null, projectConfig.viewid.MICE.destination.Id);
			});
		}

		function setCity(data) {
			var $city;
			if(data.sore == "s")
				$city = app.$el(idConfig.startDest);
			else if(data.sore == "e")
				$city = app.$el(idConfig.endDest);
			var dest = data;
			var settings = app.getSettings();
			var tripParam = settings.tripParam;
			if(!tripParam)
				tripParam = {};
			if(data.sore == "s") {
				tripParam.fromDest = data;
				settings.tripParam = tripParam;
				$("#custom-start-position").val(data.Name);
			} else if(data.sore == "e") {
				tripParam.toDest = data;
				settings.tripParam = tripParam;
				$("#custom-end-position").val(data.Name);
			}
			app.setSettings(settings);
		}

		function initParam() {
			var settings = app.getSettings();
			var tripParam = settings.tripParam;
			if(tripParam) {
				if(tripParam.fromDest) {
					$("#custom-start-position").val(tripParam.fromDest.Name);
				}
				if(tripParam.toDest) {
					$("#custom-end-position").val(tripParam.toDest.Name);
				}

				if(tripParam.isChange) {
					$('#sure-icon').addClass('icon-weixuan');
				} else {
					$('#sure-icon').removeClass('icon-yixuan');
				}

				if(tripParam.tickte) {
					$("#adult-num-tmpl").text(tripParam.tickte.adultNum);
					$("#adult-num").text(tripParam.tickte.adultNum)
					$("#children-num-tmpl").text(tripParam.tickte.childrenNum);
					$("#children-num").text(tripParam.tickte.childrenNum)
				} else {
					$("#adult-num-tmpl").text(5);
					$("#adult-num").text(5)
					$("#children-num-tmpl").text(0);
					$("#children-num").text(0)
					settings.tripParam.ticket = {
						adultNum: 5,
						childrenNum: 0
					};
					app.setSettings(settings);
				}

				window.TripDate.initDate(dateCallback, tripParam.Dates);
			} else {
				app.postion(postionCallback);
				window.TripDate.initDate(dateCallback, []);
			}
		}

		function initDateEvent() {
			$("#time-container").off().on("tap", function() {
				$(".newdateback").show();
				$(".datecalendar").slideToggle(200);
			});
			$(".newdateback").off().on("tap", function() {
				$(".newdateback").hide();
				$(".datecalendar").slideToggle(200);
			});

			$("#sure-change").off().on('tap', function() {
				var status = $(this).attr('data-sure');
				if(status == 'false') {
					$(this).addClass('sured');
					$('#sure-icon').removeClass('icon-weixuan');
					$('#sure-icon').addClass('icon-yixuan');
					$(this).attr('data-sure', 'true');
					var settings = app.getSettings();
					settings.tripParam.isChange = true;
					app.setSettings(settings);
				} else {
					$(this).removeClass('sured');
					$('#sure-icon').removeClass('icon-yixuan');
					$('#sure-icon').addClass('icon-weixuan');
					$(this).attr('data-sure', 'false');
					var settings = app.getSettings();
					settings.tripParam.isChange = false;
					app.setSettings(settings);
				}
			});
		}

		function postionCallback(data) {
			var id = data.DestList[0].Id;
			var name = data.DestList[0].Name;
			var type = data.DestList[0].Type;
			var cityId = data.DestList[0].CityId;
			var Dest = {
				Type: type,
				Id: cityId,
				Name: name
			}

			var settings = app.getSettings();
			var tripParam = settings.tripParam;
			if(!tripParam)
				tripParam = {};
			tripParam.fromDest = Dest;
			settings.tripParam = tripParam;
			app.setSettings(settings);
			$("#custom-start-position").val(data.DestList[0].Name);
		}

		function dateCallback(data) {
			var datas = data;
			var startdate = datas[0];
			var enddate = datas[1];

			var month = app.DateTool.DateFormat("MM", startdate);
			var day = app.DateTool.DateFormat("dd", startdate);
			var sweek = app.DateTool.DateFormat("w", startdate);
			var smonth = month + "月";
			var sday = day + "日";
			var month = app.DateTool.DateFormat("MM", enddate);
			var day = app.DateTool.DateFormat("dd", enddate);
			var eweek = app.DateTool.DateFormat("w", enddate);
			var emonth = month + "月";
			var eday = day + "日";
			var iday = app.DateTool.datedifference(startdate, enddate) + 1;
			var showdata = {
				sweek: sweek,
				smonth: smonth,
				sday: sday,
				eweek: eweek,
				emonth: emonth,
				eday: eday,
				days: iday
			}

			var settings = app.getSettings();
			var tripParam = settings.tripParam;
			if(!tripParam)
				tripParam = {};
			tripParam.Dates = datas;
			settings.tripParam = tripParam;
			
			app.setSettings(settings);

			var tmplHot1 = template('customdate-template', showdata);
			$("#custom-room-date").html(tmplHot1);
			initDateEvent();
		}

		function initPerson() {
			$("#home-types").off().on('tap', function() {

				$("#mc").show();
				$(".select-people").slideToggle(200);
			});

			$("#mc").on('touchend', function(event) {
				event.preventDefault();
			});

			$("#mc").on('touchmove', function(event) {
				event.preventDefault();
			});

			$("#mc").off().on('tap', function() {
				$("#mc").hide();
				$(".select-people").hide();
			});

			//成人++
			$("#adult-add").off().on('tap', function() {
				$("#adult-num").addClass('default-color');
				//$(".adult-name").eq(0).addClass('default-color');
				var num = $("#adult-num").text();
				if(Number(num) >= 99) {
					num = 99;
				} else {
					num = Number(num) + 1;
				}

				$("#adult-num").text(num);
			});
			//成人--
			$("#adult-reduce").off().on('tap', function() {
				var num = $("#adult-num").text();
				if(Number(num) <= 4) {
					$("#adult-num").text(3);
					$("#adult-num").removeClass('default-color');
				} else {
					num = Number(num) - 1;
					$("#adult-num").text(num);
				}
			});

			//儿童++
			$("#children-add").off().on('tap', function() {
				$("#children-num").addClass('default-color');
				var num = $("#children-num").text();
				num = Number(num) + 1;
				$("#children-num").text(num);
			});
			//儿童--
			$("#children-reduce").off().on('tap', function() {
				var num = $("#children-num").text();
				if(Number(num) <= 1) {
					$("#children-num").text(0);
					$("#children-num").removeClass('default-color');
				} else {
					num = Number(num) - 1;
					$("#children-num").text(num);
				}
			});

			//人数选择确认
			$(".confirm-btn").off().on('tap', function() {
				$("#mc").hide();
				$(".select-people").slideToggle(200);
				var settings = app.getSettings();
				$("#adult-num-tmpl").text($("#adult-num").text());
				$("#children-num-tmpl").text($("#children-num").text());
				settings.tripParam.ticket = {
					adultNum: $("#adult-num").text(),
					childrenNum: $("#children-num").text()
				};
				if(settings.tripParam) {
					settings.tripParam.ticket = settings.tripParam.ticket;
				}
				app.setSettings(settings);
			});
		}

		function goNext() {
			$("#btnNext").off().on("tap", function() {
				if($(this).attr("isClick") == 1) {
					return;
				} else {
					$(this).attr("isClick", 1);
				}
				var settings = app.getSettings();
				var tripParam = settings.tripParam;

				if(tripParam.fromDest.Id == '') {
					plus.nativeUI.toast('出发地不能为空');
					$(this).attr("isClick", 0);
					return;
				}
				if(!tripParam.toDest || tripParam.toDest.Id == 0) {
					plus.nativeUI.toast('目的地不能为空');
					$(this).attr("isClick", 0);
					return;
				}
				//				if(tripParam.toDest.Id==tripParam.fromDest.Id){
				//					plus.nativeUI.toast('出发地和目的地不能相同');
				//					$(this).attr("isClick",0);
				//					return;
				//				}
				$(this).attr("isClick", 0);
				app.ShowWebView(projectConfig.viewid.Trip.Detail.url, {}, "", projectConfig.viewid.Trip.Detail.Id);
			})
		}

		return {
			init: init,
			setCity: setCity
		}
	})();
})(window, $);