app.invoiceDetail = {
	init: function(tid, type,isSelected) {
		var self = app.invoiceDetail;
		self.render(tid, type,isSelected);
		self.initSave(tid);
	},
	render: function(tid, type,isSelected) {
		var self = app.invoiceDetail;
		var _render = function(data) {
			$('#invoice_detail_form').html(template('t_invoice_detail', data));
			self.initCompany();
		};
		if(tid != null) {
			$('#detail_title').html('编辑发票抬头');
			$('#del_invoice').show();
			self.initDel(tid, type,isSelected);

			app.Post({
				url: projectConfig.apiName.GetInvoiceTitleInfo,
				data: {
					"Tid": tid
				}
			}, null, function(res) {
				if(app.GetResultState(res)) {
					_render({
						title: res.TitleInfo.Title,
						No: res.TitleInfo.No,
						tid: tid,
						type: res.TitleInfo.Type
					});
				}
			});
		} else {
			_render({
				title: '',
				No: '',
				tid: '',
				type: 0
			});
		}

	},
	initSave: function(tid) {
		$('#invoice_save').off().on('tap', function() {
			var $title = $('#invoice_title');
			var $Name = $('#input_i_name');
			var $No = $('#input_i_code'); // 税号
			var data = {
				Tid: tid || 0,
				Type: $title.attr('data-type'),
				Title: $Name.val(),
				No: $No.val() || ''
			};
			app.showWaiting("加载中...",1);
			app.Post({
				url: projectConfig.apiName.SubmitInvoiceTitleInfo,
				data: data
			}, null, function(res) {
				if(app.GetResultState(res)) {
					app.invoiceDetail.refreshListAndBack();
				} else {
					mui.alert(res.Msg, "提示", null, function() {})
				}
			});
		});
	},
	refreshListAndBack:function(){
		var subView = plus.webview.getWebviewById(projectConfig.ViewId.Invoice.List.Id);
		subView.evalJS("app.invoiceList.render()");
		mui.back();
	},
	initDel: function(tid,type,isSelected) {
		$('#del_invoice').off().on('tap', function() {
			if(isSelected){
				mui.alert("该发票抬头正在被使用，不可删除！", "提示", null, function() {})
			}else{
				mui.confirm('确定删除该发票抬头吗？', '删除发票', ['确认', '取消'], function(e) {
				if(e.index == 1) {
					
				} else {
					app.Post({
						url: projectConfig.apiName.DelInvoiceTitleInfo,
						data: {
							Tid: tid
						}
					}, null, function(res) {
						if(app.GetResultState(res)) {
							app.invoiceDetail.refreshListAndBack();
						} else {
							mui.alert(res.Msg, "提示", null, function() {})
						}
					});
				}
			})
			}
		});
	},
	initCompany: function() {
		var $invoice_title = $('#invoice_title')
		$invoice_title.off("click").on("click", function() {
			var type = $(this).attr('data-type');
			console.log(type)
			layer.open({
				content: app.format('<p class="i-title-item i-company" style="border-bottom:1px solid #e4e4e4;{0}">公司</p>' +
					'<p class="i-title-item i-self" style="{1}">个人</p>',
					type == "1" ? "color:#ff4c4c;" : "", type == "0" ? "color:#ff4c4c;" : ""),
				btn: ['关闭'],
				skin: 'footer',
				yes: function() {
					layer.closeAll();
				}
			});
			$('.i-title-item').off().on('tap', function() {
				var $this = $(this);
				if($this.hasClass('i-company')) {
					$('#invoice_code').show();
					$invoice_title.html($this.html()).attr('data-type', '1');
				}
				if($this.hasClass('i-self')) {
					$('#invoice_code').hide();
					$invoice_title.html($this.html()).attr('data-type', '0');
				}
				layer.closeAll();
			})
		});
	},
	getData: function() {
		return [{
			name: 'xxxx123公司名称',
			code: '123',
			type: '0'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}]
	}
};