app.invoiceList = {
	currTid:null,
	init: function(tid) {
		var self = app.invoiceList;
		self.currTid = tid;
		self.render();
		self.initGoToAdd();
		self.initChooseAndEdit();
	},
	render: function() {
		var self = app.invoiceList;
		var $c = $('#invoice_list');
		var _render = function(data) {
			$c.html(template('t_invoice_list_item', {
				list: self.dataToUI(data) || [],
				tid: app.invoiceList.currTid || null
			}));
		};
		app.showWaiting("加载中...",1);
		app.Post({
			url: projectConfig.apiName.GetInvoiceTitleList,
			data: {
				"Page": {
					"Index": 0,
					"Size": 100
				}
			}
		}, null, function(res) {
			if(app.GetResultState(res)) {
				_render(res.TitleList);
			} else {
				_render([]);
			}
		});

	},
	initGoToAdd: function() {
		$('.goto-add-invoice').off().on('tap', function() {
			app.invoiceList.gotoDetail(null, null);
		});
	},
	gotoDetail: function(tid, type) {
		var detail = projectConfig.ViewId.Invoice.Detail;
		app.ShowWebView(detail.url, {
			tid: tid,
			type: type,
			isSelected:(tid == app.invoiceList.currTid && tid != null)
		}, null, detail.Id);
	},
	initChooseAndEdit: function() {
		var $c = $('#invoice_list');
		$c.off().on('tap', '.event-item', function() {
			var $this = $(this);
			var tid = $this.attr('data-tid'),
				name = $this.attr('data-name'),
				code = $this.attr('data-code'),
				type = $this.attr('data-type');
			if($this.hasClass('edit')) {
				app.invoiceList.gotoDetail(tid, type);
			}
			if($this.hasClass('invoice-title')) {
				var subView = plus.webview.getWebviewById(projectConfig.ViewId.Invoice.DetailHotel.Id);

				var v = JSON.stringify({
					tid: tid,
					name: name,
					code: code
				});
				subView.evalJS("app.invoiceDetailHotel.renderInvoiceName(" + v + ")");
				mui.back();
			}
		});
	},
	dataToUI: function(data) {
		return data;
	},
	getData: function() {
		return [{
			Title: 'xxxx123公司名称',
			No: '123',
			Type: '0',
			Tid: '1001'
		}]
	}
};