app.invoicePlaneList = {
	isLoading: false,
	GetInvoiceOrderListEntity: {
		url: projectConfig.apiName.GetInvoiceOrderList,
		data: {
			Page: {
				Index: 1,
				Size: 10
			},
			ProcductType: 5,
			NextPageDate: ""
		}
	},

	init: function() {
		var self = app.invoicePlaneList;
		self.getData();
	},
	render: function(data) {
		var self = app.invoicePlaneList;
		var $c = $('#invoice_hotel_list');
		if(data.InvoiceList && data.InvoiceList.List.length > 0) {
			for(var i = 0; i < data.InvoiceList.List.length; i++) {
				var m = app.DateTool.DateFormat("MM", data.InvoiceList.List[i].Date.replace(/-/g, "/"));
				data.InvoiceList.List[i].Month = m + "月";
			}
		}

		$c.html(template('t_invoice_hotel__item', data.InvoiceList));
		var iscroll = new IScroll("#scroll_run", {
			preventDefault: false,
			tap: true,
			click: true,
			probeType: 3,
			mouseWheel: true, //鼠标滑轮开启
			scrollbars: false, //滚动条可见
			fadeScrollbars: true, //滚动条渐隐
			interactiveScrollbars: true, //滚动条可拖动
			shrinkScrollbars: 'scale', // 当滚动边界之外的滚动条是由少量的收缩
			useTransform: true, //CSS转化
			useTransition: true, //CSS过渡
			bounce: true, //反弹
			freeScroll: true, //只能在一个方向上滑动
			preventDefaultException: {
				tagName: /^(INPUT|TEXTAREA|BUTTON|SELECT|A)$/
			},
			startX: 0,
			startY: 0
		});
		iscroll.enableStickyHeaders('.month');
		iscroll.on("scroll", function() {
			if(self.isLoading == false) {
				if(this.y < (this.maxScrollY - 14)) { //上拉加载更多
					pullUp.addClass("refresh").show();
					pullUpLabel.text("正在载入");
					self.GetNextPageData();
				}
			}
		});
		self.initChoose();
	},
	initChoose: function() {
		var $c = $('#invoice_hotel_list');
		var check = 'choose-check';
		var $tChoose = $('.t-choose');
		var $chooses = $c.find('.choose-item');
		var $num = $('#order_num');
		var $price = $('#total_price');
		var $last = $('#last');
		var setTotal = function() {
			$num.html($c.find('.' + check).length || 0);
		};
		var setPrice = function() {
			var total = 0;
			var $checks = $c.find('.' + check) || [];
			$.each($checks, function(i, d) {
				total += parseFloat($(d).parent().attr('data-price'));
			});
			$price.html(total);
		};

		var afterFn = function() {
			setTotal();
			setPrice();
		}
		$(".h-item").off().on('click', function() {
			var $this = $(this);
			var $choose = $this.find('.choose-item');
			if($choose.hasClass(check)) {
				$choose.removeClass(check);
				$tChoose.removeClass(check);
				if($c.find('.' + check).length == 0) {
					$last.addClass('disabled');
				}
			} else {
				$choose.addClass(check);
				$last.removeClass('disabled');
				if($c.find('.' + check).length == $chooses.length) {
					$tChoose.addClass(check);
				}
			}
			afterFn();
		});
		$('.choose-info').off().on('tap', function() {
			if($tChoose.hasClass(check)) {
				$tChoose.removeClass(check);
				$chooses.removeClass(check);
				$last.addClass('disabled');
			} else {
				$tChoose.addClass(check);
				$chooses.addClass(check);
				$last.removeClass('disabled');
			}
			afterFn();
		});
		$last.off().on('tap', function() {
			if($last.hasClass('disabled')) {
				app.showMsg("请选择需要开票的订单");
				return false;
			}
			app.invoicePlaneList.createInvoice();
		});
	},
	createInvoice: function() {
		var data = [];
		var $c = $('#invoice_hotel_list');
		$.each($c.find('.choose-check') || [], function(i, d) {
			data.push($(d).parent().attr('data-serialno'));
		});
		var gotoDetail = function() {
			var detailPlane = projectConfig.ViewId.Invoice.DetailPlane;
			app.ShowWebView(detailPlane.url, {
				List: data,
				Total: $('#total_price').text()
			}, null, detailPlane.Id);
		};

		gotoDetail();
	},
	getData: function() {
		var self = app.invoicePlaneList;
		var nomsg = '<div class="no-list-msg" style="background:#fff">' +
			'<div class="no-icon">' +
			'	<img src="../images/no-list-icon.png" />' +
			'</div>' +
			'<div class="no-msg">' +
			'	暂无机票订单可开票' +
			'</div>' +
			'</div>';
		app.showWaiting("加载中...", 1);
		app.Post(self.GetInvoiceOrderListEntity, null, function(data) {
			if(app.GetResultState(data)) {
				self.render(data);
			} else {
				if(self.GetInvoiceOrderListEntity.data.Page.Index == 1) {
					$('#invoice_hotel_list').html(nomsg);
				}
			}
		})
	},
	GetNextPageData: function() {
		var self = app.invoiceHotelList;
		if(self.isLoading == true)
			return;

		self.GetInvoiceOrderListEntity.data.pageIndex += 1;
		self.getData();
	}
}