(function(window, $) {
	window.TrainOrderDetail = (function() {
		var tabId0 = projectConfig.ViewId.User.Sub_MyApproval.Id + "0";
		var tabId1 = projectConfig.ViewId.User.Sub_MyApproval.Id + "1";
		var GetTrainOrderDetailEntity = {
			url: projectConfig.apiName.TMCGetTrainOrderDetail,
			data: {
				SerialNo: "",
				BookerMemberId:"",
				TravelBusinessId:0
				
			}
		}
		var TMCApprovalTravelBusinessOrderEntity = {
			url: projectConfig.apiName.TMCApprovalTravelBusinessOrder,
			data: {
				IsAgree: false,
				OrderSerialNo: "",
				TravelBusinessId:0
			}
		}

		function init() {
			getDetail();
			initEvent();
			TMCApprovalTravelBusinessOrderEntity.data.OrderSerialNo=GetTrainOrderDetailEntity.data.SerialNo;
		}

		function getDetail() {
			app.showWaiting('加载中...', 1);
			app.Post(GetTrainOrderDetailEntity, null, loadDetailCallback);
		}

		function loadDetailCallback(data) {
			if(app.GetResultState(data)) {
				var state = data.Status;
				$(".state-title").html(state[1]);
				$(".state-intro").html(state[2].replace('ProccessTime', "<span style='color:#fc9b16'>" + data.ProccessTime + "</span>"));
				$(".state-img").attr("src", getStateIcon(data.OrderStatus));
				for(var i=0;i<data.TrainList.length;i++){
					var train=data.TrainList[i].TrainInfo;
					var leaveDate = train.DepartTime.replace(/-/g, "/");
					var arriveDate = train.ArriveTime.replace(/-/g, "/");
					var expireTime = data.ExpireTime.replace(/-/g, "/");
					var createTime = data.SystemTime.replace(/-/g, "/");
					
					var leavehour = app.DateTool.DateFormat("hh", leaveDate);
					var leavemuinte = app.DateTool.DateFormat("mm", leaveDate);
					var arrivehour = app.DateTool.DateFormat("hh", arriveDate);
					var arrivemuinte = app.DateTool.DateFormat("mm", arriveDate);
					var week = app.DateTool.DateFormat("w", leaveDate);
					var leavemonth = app.DateTool.DateFormat("MM", leaveDate);
					var leaveday = app.DateTool.DateFormat("dd", leaveDate);
					var arrivemonth = app.DateTool.DateFormat("MM", arriveDate);
					var arriveday = app.DateTool.DateFormat("dd", arriveDate);
	
					train.leaveTime = leavehour + ":" + leavemuinte;
					train.arriveTime = arrivehour + ":" + arrivemuinte;
					train.leaveDate = leavemonth + "月" + leaveday + "日";
					train.arriveDate = arrivemonth + "月" + arriveday + "日";
					train.week = week;
					
					data.TrainList[i].TrainInfo=train;
				}
				
				
				$(".state-img").attr("src", getStateIcon(data.OrderStatus));

				var amount = data.TotalPrice;
				$("#pricetitle").html(amount[0]);
				$(".price-code").html("￥");
				$(".price").html(amount[2]);
				
				var tmplHot = template('trainDetail-template', data);
				$("#trainheader").html(tmplHot);
				$("#orderno").html(data.OrderSerialNo);
				$("#createtime").html(data.CreateTime);
				
				var tmplDetail = template('detail-template', data);
				$("#detailContent").html(tmplDetail);
				$(".button-list1").html(getButtonList(data.ButtonList));
				ButtonEvent();
			} else {
				app.showMsg(data.Msg)
			}
		}
		
		function initEvent(){
			$(".order-detail-out").on("tap", function() {
				$(".ce-detail-rule").show();
			});
			$(".ce-rult-icon").off().on("tap", function() {
				$(".ce-detail-rule").hide();
				$('body').css('pointer-events', 'none');
				setTimeout(function() {
					$('body').css('pointer-events', 'auto');
				}, 400);
			})
			
		}
		function getButtonList(buttons) {
			var buttonshtml = "";
			var button = '<div class="button-item"><button type="{2}" class="button-detail button-detail-color {0}" link="{3}">{1}</button></div>';
			if(buttons && buttons.length > 0) {
				for(var i = 0; i < buttons.length; i++) {
					if(buttons[i].Type == 605) {
						buttonshtml += app.format(button, "", buttons[i].Name, buttons[i].Type, buttons[i].Link);
					} else if(buttons[i].Type == 606) {
						buttonshtml += app.format(button, "", buttons[i].Name, buttons[i].Type, buttons[i].Link);
					}
				}
			}
			return buttonshtml;
		}
		
		function getStateIcon(state) {
			switch(state) {
				case 0:
					{
						return "../images/plane/dsp.png";
					}
				case 1:
					{
						return "../images/plane/cpz.png";
					}
				case 2:
					{
						return "../images/plane/cpz.png";
					}
				case 10:
					{
						return "../images/plane/cpz.png";
					}
				case 11:
					{
						return "../images/plane/ycp.png";
					}
				case 20:
					{
						return "../images/plane/yqx.png";
					}
				case 21:
					{
						return "../images/plane/yqx.png";
					}
				case 31:
					{
						return "../images/plane/yqx.png";
					}
				case 32:
					{
						return "../images/plane/yqx.png";
					}
				case 33:
					{
						return "../images/plane/yqx.png";
					}
				case 51:
					{
						return "../images/plane/yqx.png";
					}
				case 52:
					{
						return "../images/plane/yqx.png";
					}
			}
		}
		function ButtonEvent() {
			$(".button-detail").on("tap", function() {
				var id = $(this).attr("type");
				TMCApprovalTravelBusinessOrderEntity.data.TravelBusinessId=GetTrainOrderDetailEntity.data.TravelBusinessId;
				switch(id) {
					case "605":
						mui.confirm("确定审批通过此订单嘛？", "提示", ["取消", "确定"], function(e) {
							if(e.index == 1) {
								app.showWaiting('加载中...', 1);
								TMCApprovalTravelBusinessOrderEntity.data.IsAgree = true;
								app.Post(TMCApprovalTravelBusinessOrderEntity, null, ButtonEventCallback)
								$(".button-detail").attr("val", "0");
							}
						})
						break;
					case "606":
						//审批不通过
						mui.confirm("确定审批不通过此订单嘛？", "提示", ["取消", "确定"], function(e) {
							if(e.index == 1) {
								app.showWaiting('加载中...', 1);
								TMCApprovalTravelBusinessOrderEntity.data.IsAgree = false;
								app.Post(TMCApprovalTravelBusinessOrderEntity, null, ButtonEventCallback)
								$(".button-detail").attr("val", "0");
							}
						})
						break;
				}
			})
		}

		function ButtonEventCallback(data) {
			if(app.GetResultState(data)) {
				getDetail();
				var ziview = plus.webview.getWebviewById(tabId0);
				ziview.evalJS("window.Sub_MyApproval.reload(0)");
				var ziview1 = plus.webview.getWebviewById(tabId1);
				ziview1.evalJS("window.Sub_MyApproval.reload(1)");
			} else {
				app.showMsg(data.Msg)
			}
		}

		return {
			init: init,
			GetTrainOrderDetailEntity: GetTrainOrderDetailEntity
		}
	})();
})(window, $);