app.userAddAddress = {
	pageConfig: {
		titleId: 'add-title',
		formId: 'form-container',
		chooseAddressId: 'chooseAddress',
		addAddressId: 'addAddress',
		delId: 'del-address'
	},
	apiParams: [{
			name: 'ContactName',
			tip: '请输入名称'
		}, {
			name: 'ContactPhone',
			tip: '请输入手机号'
		}, {
			name: 'CityId',
			tip: '请选择省/市/区'
		}, {
			name: 'DisAreaId',
			tip: ''
		}, {
			name: 'Address',
			tip: '请输入详细地址'
		}
		//	, {
		//		name: 'postalcode',
		//		tip: '请输入邮政编码'
		//	}
	],
	init: function() {
		var self = app.userAddAddress;
		self.saveAddress();
		self.removeAddress();
		self.render();
	},
	render: function() {
		var self = app.userAddAddress;
		var $form = app.gEl(self.pageConfig.formId);
		if(_Mid != 0) {
			app.gEl(self.pageConfig.delId).show();
			app.gEl(self.pageConfig.titleId).html('编辑邮寄地址');
			var _render = function(data) {
				for(var i = 0, len = self.apiParams.length; i < len; i++) {
					var d = self.apiParams[i];
					var $input = $form.find('input[name="' + d.name + '"]');
					//console.log(data[d.name]);
					$input.val(data[d.name] || '');
				}
				self.initAddressCascade(data.ProvinceId, data.CityId, data.DisAreaId);
				if($("input[name=ContactName]").val() != "")
					$("input[name=ContactName]").parent().find('.rnclose').show();
				if($("input[name=ContactPhone]").val() != "")
					$("input[name=ContactPhone]").parent().find('.rnclose').show();
				if($("input[name=Address]").val() != "")
					$("input[name=Address]").parent().find('.rnclose').show();
				$('#chooseAddress span').html(data.AreaName);
			}
			var mask = mui.createMask();
			mask.show();
			app.Post({
				url: projectConfig.apiName.GetMailInfo,
				data: {
					Mid: _Mid
				}
			}, null, function(data) {
				mask.close();
				//console.log('编辑邮寄地址');
				//console.log(JSON.stringify(data));
				if(app.GetResultState(data)) {
					_render(data.MailInfo);
				}
			});
		}
		else{
			$('#chooseAddress span').html("<label style='color:#999;'>省/市/区</label>");
		}
	},
	initAddressCascade: function(provinceId, cityId, townId) {
		new AddressCascade({
			id: 'chooseAddress',
			province: {
				url: projectConfig.apiName.GetProvinceList,
				apiParamName: '',
				valueName: 'Id',
				value: provinceId
			},
			city: {
				url: projectConfig.apiName.GetCityList,
				apiParamName: 'Pid',
				valueName: 'Id',
				value: cityId
			},
			town: {
				url: projectConfig.apiName.GetDisAreaList,
				apiParamName: 'Cid',
				valueName: 'Id',
				value: townId
			},
			dataToUI: function(data) {
				return {
					name: data.Name,
					value: data.Id
				}
			},
			popup: function(id) {
				mui('#' + id).popover('toggle');
			},
			chooseCallbackFn: function(data) {
				$('#chooseAddress span').html(data.p.name + data.c.name + data.t.name);
				$('#cityId').val(data.c.value);
				$('#townId').val(data.t.value);
			}
		});
	},
	saveAddress: function() {
		var self = app.userAddAddress;
		var $add = app.gEl(self.pageConfig.addAddressId);
		var apiParams = self.apiParams;
		var $form = app.gEl(self.pageConfig.formId);
		$add.on('tap', function() {
			var data = {};
			for(var i = 0, len = apiParams.length; i < len; i++) {
				var d = apiParams[i];
				var $input = $form.find('input[name="' + d.name + '"]');
				var _value = $input.val();
				if(!_value && !!d.tip) {
					app.showMsg(d.tip);
					$input.focus();
					return false;
				} else {
					if(d.name == 'ContactPhone') {
						if(!app.checkMobile(_value)) {
							app.showMsg('手机号格式不正确!');
							//$input.focus();
							return false;
						}
					}
					data[d.name] = _value || 0;
				}
			}
			data.Mid = _Mid || 0;
			var apiOption = {
				url: projectConfig.apiName.SubmitMailInfo,
				data: data
			};
			app.Post(apiOption, null, function(data) {
				if(_Mid != 0) {
					app.confirmMsg('编辑成功', function() {
						self.afterPost();
					});
				} else {
					app.confirmMsg('添加成功', function() {
						self.afterPost();
					});
				}
			})
		});
	},
	afterPost: function() {
		var sonView = plus.webview.getWebviewById('../user/commonInfo.html');
		sonView.evalJS('app.userCommonInfo.init();');
		mui.back();
	},
	removeAddress: function() {
		var self = app.userAddAddress;
		var $del = app.gEl(self.pageConfig.delId);
		$del.on('tap', function() {
			app.Post({
				url: projectConfig.apiName.DelMailInfo,
				data: {
					Mid: _Mid
				}
			}, null, function(data) {
				//console.log(JSON.stringify(data))
				app.confirmMsg('删除成功', function() {
					self.afterPost();
				});
			});
		});
	}

}