app.addressList = {
	mid: null,
	source: null,
	init: function(mid, source) {
		var self = app.addressList;
		app.addressList.mid = mid;
		app.addressList.source = source;
		self.render();
		self.initGoToAdd();
		self.initChooseAndEdit();

	},
	render: function() {
		var self = app.addressList;
		var $c = $('#address_list');
		var _render = function(data) {
			$c.html(template('t_address_list_item', {
				list: data,
				mid: app.addressList.mid
			}));
		}
		app.showWaiting("加载中...",1);
		app.Post({
			url: projectConfig.apiName.GetMailList,
			data: {
				"Page": {
					"Index": 0,
					"Size": 100
				}
			}
		}, null, function(res) {
			if(app.GetResultState(res)) {
				_render(res.MailList);
			} else {
				_render([]);
			}
		});
	},
	initGoToAdd: function() {
		$('.goto-add-address').off().on('tap', function() {
			app.addressList.gotoDetail(null);
		});
	},
	gotoDetail: function(mid) {
		var adt = projectConfig.ViewId.User.addressDetail;
		app.ShowWebView(adt.url, {
			mid: mid,
			isSelected: (mid == app.addressList.mid && mid != null)
		}, null, adt.Id);
	},
	initChooseAndEdit: function() {
		var $c = $('#address_list');
		$c.off().on('tap', '.event-item', function() {
			var $this = $(this);
			var subView,mid = $this.attr('data-mid'),
				contact = $this.attr('data-contact'),
				address = $this.attr('data-address'),
				v = JSON.stringify({
						mid: mid,
						contact: contact,
						address: address
					});
			if($this.hasClass('edit')) {
				app.addressList.gotoDetail(mid);
			}
			if($this.hasClass('address-title')) {
				if(app.addressList.source == 'hotel') {
					subView = plus.webview.getWebviewById(projectConfig.ViewId.Invoice.DetailHotel.Id);
					subView.evalJS("app.invoiceDetailHotel.renderInvoiceAddress(" + v + ")");
					mui.back();
				}
				if(app.addressList.source == 'plane') {
					subView = plus.webview.getWebviewById(projectConfig.ViewId.Invoice.DetailPlane.Id);
					subView.evalJS("app.invoiceDetailPlane.renderInvoiceAddress(" + v + ")");
					mui.back();
				}
			}
		});
	}
};