app.addressDetail = {
	init: function(mid, isSelected) {
		var self = app.addressDetail;
		self.render(mid, isSelected);
		self.initSave(mid);
	},
	getCascadeData: function(fn) {
		var data = [];
		var curr = ($('#address_title').data('data') || {
				p: 0,
				c: 0,
				t: 0
			}),
			pIndex, cIndex;
		app.Post({
			url: projectConfig.apiName.GetProvinceList,
			data: {}
		}, null, function(p) {
			if(curr.p == 0) curr.p = p.List[0].Id;
			$.each(p.List, function(pi, p) {
				if(p.Id == curr.p) {
					data.push({
						value: p.Id,
						text: p.Name,
						children: []
					});
					pIndex = pi;
				} else {
					data.push({
						value: p.Id,
						text: p.Name
					});
				}

			});

			app.Post({
				url: projectConfig.apiName.GetCityList,
				data: {
					Pid: curr.p
				}
			}, null, function(c) {
				if(curr.c == 0) curr.c = c.List[0].Id;
				$.each(c.List, function(ci, c) {
					if(c.Id == curr.c) {
						cIndex = ci;
						data[pIndex].children.push({
							value: c.Id,
							text: c.Name,
							children: []
						});
					} else {
						data[pIndex].children.push({
							value: c.Id,
							text: c.Name
						});
					}
				});

				app.Post({
					url: projectConfig.apiName.GetDisAreaList,
					data: {
						Cid: curr.c
					}
				}, null, function(t) {
					$.each(t.List, function(ti, t) {
						data[pIndex].children[cIndex].children.push({
							value: t.Id,
							text: t.Name
						});
					});
					fn(data);
				});
			});
		});
	},
	render: function(mid, isSelected) {
		var self = app.addressDetail;
		var _getParam = function(obj, param) {
			return obj[param] || '';
		};
		var _render = function(data) {
			$('#address_detail_form').html(template('t_address_detail', data));
			var $area = $('#address_title');
			$area.data('data', {
				p: data.ProvinceId || 0,
				c: data.CityId || 0,
				t: data.DisAreaId || 0
			});
			self.getCascadeData(function(data) {
				var cityPicker3 = new mui.PopPicker({
					layer: 3
				});
				cityPicker3.setData(data);
				$area.off().on('tap', function() {
					if($area.data('data').p != 0) {
						cityPicker3.pickers[0].setSelectedValue($area.data('data').p, 1000);
					}
					cityPicker3.show(function(items) {
						$area.data('data', {
							p: items[0].value,
							c: items[1].value,
							t: items[2].value
						});
						$area.html(items[0].text+items[1].text+items[2].text);
						console.log("你选择的城市是:" + _getParam(items[0], 'text') + " " + _getParam(items[1], 'text') + " " + _getParam(items[2], 'text'));
						//返回 false 可以阻止选择框的关闭
						//return false;
					});
				});
			})
		};
		if(mid != null) {
			$('#detail_title').html('编辑配送地址');
			$('#del_address').show();
			app.Post({
				url: projectConfig.apiName.GetMailInfo,
				data: {
					"Mid": mid
				}
			}, null, function(res) {
				if(app.GetResultState(res)) {
					_render(res.MailInfo);
				}
			});
			self.initDel(mid, isSelected);

		} else {
			_render({
				Mid: mid
			});
		}
	},
	addressChoose: function(data) {
		console.log("data=>" + JSON.stringify(data));
		$('#address_title').data('data', {
			p: data.p.value,
			c: data.c.value,
			t: data.t.value
		}).html(data.p.name + data.c.name + data.t.name);
	},
	refreshListAndBack: function() {
		var subView = plus.webview.getWebviewById(projectConfig.ViewId.User.address.Id);
		subView.evalJS("app.addressList.render()");
		mui.back();
	},
	initSave: function(mid) {
		$('#address_save').off().on('tap', function() {
			var ContactName = $('#input_a_name').val();
			var ContactPhone = $('#input_a_mobile').val();
			var DisAreaId = ($('#address_title').data('data')|| {}) .t;
			var Address = $('#input_a_aDetail').val();
			if(!ContactName) {
				mui.alert("收件人姓名不能为空！", "提示", null, function() {})
				return false;
			}
			if(!ContactPhone) {
				mui.alert("手机号不能为空！", "提示", null, function() {})
				return false;
			}
			if(!DisAreaId) {
				mui.alert("所在地区不能为空！", "提示", null, function() {})
				return false;
			}
			if(!Address) {
				mui.alert("详细地址不能为空！", "提示", null, function() {})
				return false;
			}

			var data = {
				Mid: mid || 0,
				ContactName: ContactName,
				ContactPhone: ContactPhone,
				CityId: $('#address_title').data('data').c,
				DisAreaId: DisAreaId,
				Address: Address
			};
			app.Post({
				url: projectConfig.apiName.SubmitMailInfo,
				data: data
			}, null, function(res) {
				if(app.GetResultState(res)) {
					app.addressDetail.refreshListAndBack();
				} else {
					mui.alert(res.Msg, "提示", null, function() {})
				}
			});
		});
	},
	initDel: function(mid, isSelected) {
		$('#del_address').off().on('tap', function() {
			if(isSelected) {
				mui.alert("该邮寄地址正在被使用，不可删除！", "提示", null, function() {})
			} else {
				mui.confirm('确定删除该邮寄地址吗？', '删除邮寄地址', ['确认', '取消'], function(e) {
					if(e.index == 1) {

					} else {
						app.Post({
							url: projectConfig.apiName.DelMailInfo,
							data: {
								Mid: mid
							}
						}, null, function(res) {
							if(app.GetResultState(res)) {
								app.addressDetail.refreshListAndBack();
							} else {
								mui.alert(res.Msg, "提示", null, function() {})
							}
						});
					}
				})
			}
		});
	},
	getData: function() {
		return [{
			name: 'xxxx123公司名称',
			code: '123',
			type: '0'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}, {
			name: 'xxxx333公司名称',
			code: '12344444',
			type: '0'
		}, {
			name: 'xxxx4444公司名称',
			code: '1235556',
			type: '0'
		}, {
			name: '妄自尊',
			type: '1'
		}]
	}
};