(function(window, $) {
	window.UserIndex = (function() {
		var isManager = false;
		var canEditUser = false;

		var UserIndexEntity = {
			url: projectConfig.apiName.GetCustomerIndexInfo,
			data: {}
		}

		function init() {
			mui("#indexview").scroll();
			app.showWaiting("加载中...", 1);
			app.Post(UserIndexEntity, null, LoadIndexCallback)
		}

		function LoadIndexCallback(data) {
			if(app.GetResultState(data)) {
				var customerInfo = data.CustomerInfo;
				
//				customerInfo.IsManager = false;
				
				var expireStr = "";
				isManager = customerInfo.IsManager;
				canEditUser = (!customerInfo.IsTrial && !customerInfo.IsExpired);
				
				var settings = app.getSettings();
				settings.IsTrial = customerInfo.IsTrial;
				app.setSettings(settings);
				
				if(customerInfo.IsManager) {
					if(customerInfo.IsExpired) {
						expireStr = "使用期已过，请充值购买";
					} else {
						expireStr = "使用有效期至";
						var date = new Date(customerInfo.ServiceExpireTime.replace(/-/g, "/"));
						expireStr += app.DateTool.DateFormat("yyyy", date);
						expireStr += "-";
						expireStr += app.DateTool.DateFormat("MM", date);
						expireStr += "-";
						expireStr += app.DateTool.DateFormat("dd", date);
					}

					$("#sDateStr").html(expireStr);
					if(!customerInfo.IsTrial) {
						var settings = app.getSettings();
						if(settings.ExpireShow == 1) {
							$("#divexpireshow").show();
						} else {
							$("#divexpirehide").show();
							$("#divexpireshow").css("left", "-100%");
						}
					}
					
					$("#usericon").hide();
					$("#UserManager").show();
				}else{
					$("#usericon").show();
					$("#UserManager").hide();
					//$("#approval").hide();
				}

				if(customerInfo.IsApprover && !customerInfo.IsManager) {
					$("#approval").show();
					$('.user-point-tip').show();
				} else {
					$("#approval").hide();
				}

				if(customerInfo.IsNeedInvoice) {
					$("#divInvoice").show();
				}else{
					$("#divInvoice").hide();
				}

				if(!customerInfo.IsManager) {
					$(".user-name").html(customerInfo.Name);
				}else{
					$(".user-amount").html(customerInfo.AccountBalance);
				}
				
				if(!customerInfo.IsExistRechargeRecord)
				{
					$(".user-order-detail-pay").show();
				}
				
				if(customerInfo.IsAgent)
				{
					$("#yjtjDiv").show();
				}
				
				var orders = []
				for(var i = 0; i < data.OrderList.length; i++) {
					var entity = {}
					if(data.OrderList[i].Id != 0) {
						entity.Id = data.OrderList[i].Id;
						entity.Name = data.OrderList[i].Name;
						entity.Src = GetOrderIcon(entity.Id);
						orders.push(entity)
					}
				}

				data.Orders = orders;
				//				var tmplHot = template('orderlist-template', data);
				//				$(".user-order-list").html(tmplHot);
				initEvent();
			} else {
				app.showMsg(data.Msg);
				initEvent();
			}
		}

		function GetOrderIcon(id) {
			switch(id) {
				case 1:
					return "../images/dfk.png";
					break;
				case 2:
					return "../images/dcx.png";
					break;
				case 3:
					return "../images/dqr.png";
					break;
				case 4:
					return "../images/tk.png";
					break;
			}
		}

		function initEvent() {
			$("#orderdiv").on("tap", ".user-order-detail", function() {
				var Id = $(this).attr("val");
				var pagedata = {};
				pagedata.Type = Id;
				app.ShowWebView("../Order/MyOrder.html", pagedata, "Order.MyOrder", "slide-in-right");
			})

			$(".user-nav-list").on("tap", function() {
				var Id = $(this).attr("val") + '';
				switch(Id) {
					case '1':
						var data = {}
						data.type = 0;
						app.ShowWebView(projectConfig.ViewId.User.CommonPassenger.url, data, "slide-in-right", projectConfig.ViewId.User.CommonPassenger.Id)

						break;
					case '2':
						app.ShowWebView('../user/setting.html');
						break;
					case '3':
						app.ShowWebView('../user/myCollect.html');
						break;
					case '4':
						app.ShowWebView(projectConfig.ViewId.User.MyApproval.url, {}, "slide-in-right", projectConfig.ViewId.User.MyApproval.Id)
						break;
					case '5':
						app.ShowWebView('../invoice/index.html');
						break;
					case '6':
						app.ShowWebView(projectConfig.ViewId.Enterprise.Statistics.url,{},"",projectConfig.ViewId.Enterprise.Statistics.Id);
						break;
					default:
						break;
				}

			})

			$(".user-order-header").on("tap", function() {
				var pagedata = {};
				pagedata.Type = 0;
				app.ShowWebView("../Order/MyOrder.html", pagedata, "slide-in-right", "Order.MyOrder");
			})

			$("#divshouqi").off().on("tap", function() {
				$(".user-info-date").animate({
					left: "-100%"
				}, function() {
					//$(".user-info-date").css("margin-left", "-100%");
					$(".user-info-date1").show();

					var settings = app.getSettings();
					settings.ExpireShow = 1;
					app.setSettings(settings);
				});
			});

			$("#divzhankai").off().on("tap", function() {
				$(".user-info-date1").hide();
				$(".user-info-date").show();
				$(".user-info-date").animate({
					left: "0"
				}, function() {
					var settings = app.getSettings();
					settings.ExpireShow = 0;
					app.setSettings(settings);
				});
			})

			$(".user-header-view").on("tap", function() {
				app.ShowWebView('../user/setting.html');
			})

			$("#divmanage").off().on("tap", ".user-order-detail", function() {
				var val = $(this).attr("val");
				var settings = app.getSettings();
				var IsTrial = settings.IsTrial;
				if(val == 1) {
					if(IsTrial)
					{
						app.ShowWebView(projectConfig.viewid.home.rechargerule.url, {}, "", projectConfig.viewid.home.rechargerule.Id);
					}else{
						app.ShowWebView(projectConfig.viewid.home.voucherCenter.url, {}, "", projectConfig.viewid.home.voucherCenter.Id);
					}
					
				} else if(val == 2) {
					if(isManager && canEditUser) {
						app.ShowWebView(projectConfig.viewid.Enterprise.Account.url, {}, "", projectConfig.viewid.Enterprise.Account.Id);
					} else {
						mui.confirm("充值成为正式会员，可使用此功能", "", ["知道了", "去充值"], function(e) {
							if(e.index == 1) {
								app.ShowWebView(projectConfig.viewid.home.rechargerule.url, {}, "", projectConfig.viewid.home.rechargerule.Id);
							}
						});
					}
				} else if(val == 4) {
					if(isManager && canEditUser) {
						app.ShowWebView(projectConfig.ViewId.User.MyApproval.url, {}, "slide-in-right", projectConfig.ViewId.User.MyApproval.Id);
					} else {
						mui.confirm("充值成为正式会员，可使用此功能", "", ["知道了", "去充值"], function(e) {
							if(e.index == 1) {
								app.ShowWebView(projectConfig.viewid.home.rechargerule.url, {}, "", projectConfig.viewid.home.rechargerule.Id);
							}
						});
					}

				} else if(val == 3) {
					if(isManager && canEditUser) {
						app.ShowWebView(projectConfig.ViewId.Enterprise.Bill.url, {}, "slide-in-right", projectConfig.ViewId.Enterprise.Bill.Id);
					} else {
						mui.confirm("充值成为正式会员，可使用此功能", "", ["知道了", "去充值"], function(e) {
							if(e.index == 1) {
								app.ShowWebView(projectConfig.viewid.home.rechargerule.url, {}, "", projectConfig.viewid.home.rechargerule.Id);
							}
						});
					}
				}
			})
		}

		return {
			init: init
		}
	})();
})(window, $);