app.userSettle = {
	GetSettleListEntity: {
		url: projectConfig.apiName.GetHotelOrderFinanceList,
		data: {
			Type: 0,
			Page: {
				Index: 0,
				size: 0
			}
		}
	},
	pageInfos: [],
	packprefix: "scroll_",
	packsonprefix: "detail_",
	currentType: 0,
	tabCount: 0,
	IsFirst:true,
	GetFinanceList: function(callback) {
		var self = app.userSettle;
		app.Post(self.GetSettleListEntity, null, callback);
	},
	loadagain: function() {
		app.userSettle.IsFirst = true;
		var self = app.userSettle;
		app.showWaiting('加载中...',0);
		app.Post(self.GetSettleListEntity, null, self.GetFinanceListCallback);
	},
	GetFinanceListCallback: function(data) {
		var self = app.userSettle;
		if(app.GetResultState(data)) {
			self.HandleData(data);
		} else {
			if(data.Code == "0001") {
				self.HandleData(data);
			} else {
				app.ShowResultErr(data.Msg, app.userSettle.loadagain, $("#wrapperContent"));
			}
		}
		if(app.userSettle.IsFirst == true){
			var width = $(window).width();
			var count = $("#divTitle a").length;
			var flipsnap = Flipsnap(".wapper-list", {
				distance: width,
				maxPoint: (count - 1),
				 disableTouch: true 
			});
			flipsnap.moveToPoint(app.userSettle.currentType);//滑动到index页面
		}
		
	},
	HandleData: function(data) {
		var self = app.userSettle;
		var html = "";
		var titleList = data.TitleList;
		var financeList = data.FinanceList;
		var pagedata = data.PageInfo;
		if(titleList != null && titleList.length > 0) {
			if(self.currentType == 0)
				self.currentType = titleList[0].Id;
			self.SetTitle(titleList);
		}
		if(pagedata != null) {
			self.loadPages(pagedata);
		}
		if(financeList != null && financeList.length > 0) {
			self.initFinanceList(financeList);
		}
		$("#no-result").hide();
		if(pagedata == null && financeList == null){
			$("#no-result").show();
			app.renderNoResultList(data.Msg,null,null,null,"#no-result")
		}
	},
	//创建容器
	initSubPack: function(data) {
		var html = "";
		var self = app.userSettle;
		var length = $("#wrapperContent").find("section").length;

		if(length <= 0) {
			html += '<div class="wapper-list" id="wapperlist">';
			if(data != null && data.length > 0) {
				for(var i = 0; i < data.length; i++) {
					var title = data[i];
					html += '<section class="wapper-detail" type="' + title.Id + '" id="' + self.packprefix + title.Id + '">';
					html += '<div>';
					html += '<div id="' + self.packsonprefix + title.Id + '">';
					html += '</div>';
					html += '</div>';
					html += "</section>";
				}
			}
			html += '</div>';
			$("#wrapperContent").html(html);
//			$.each($("#wrapperContent").find("section"), function(index, section) {
//				var type = $(section).attr("type");
//				app.renderNoResult("暂无结算单", "请耐心等待", null, null, $("#" + self.packsonprefix + type));
//			});
			self.initcrossscroll();
		}
	},
	//设置标题
	SetTitle: function(data) {
		var self = app.userSettle;
		var html = "";
		var packhtml = "";
		if(self.tabCount == 0) {
			if(data.length > 0) {
				titlewidth = (99 / data.length) + "%";
				for(var i = 0; i < data.length; i++) {
					var title = data[i];
					var css = "";
					if(self.currentType == title.Id) {
						css = "current";
					}
					html += '<a href="javascript:void(0)" type="' + title.Id + '" class="' + css + '" style="width:' + titlewidth + '">';
					html += title.Name + "</a>";
				}
				$("#divTitle").html(html);
				self.initSubPack(data);
				self.tabCount = data.length;
			}
		}
	},
	//加载横向滚动
	initcrossscroll: function() {
		var width = $(window).width();
		$(".wapper-detail").css("width", width);
		app.scroll.initflipsnap(".wapper-list", $("#divTitle a"), "current", app.userSettle.tabClickCallback);
	},
	initFinanceList: function(data) {
		var html = "";
		var self = app.userSettle;
		var packId = self.packsonprefix + self.currentType;

		var obj = $("#" + packId);
		if(data != null && data.length > 0) {
			for(var i = 0; i < data.length; i++) {
				var finance = data[i];
				html += '<div class="progress-top proress-item" iswait="' + finance.IsWait + '" serialNo="' + finance.SerialNo + '">';
				html += '<i class="right-arrow"></i>';
				html += app.format('<div><font>{0}</font>{1}</div>', finance.Name, finance.Desc);
				html += app.format('<span><font>{0}</font>{1}</span>', finance.Cost, finance.Status);
				html += '</div>';
			}
			if(self.GetSettleListEntity.data.Page.Index <= 1) {
				obj.html(html);
			} else {
				obj.append(html);
			}
			self.initiscroll(self.packprefix + self.currentType);
			//$(".progress-top proress-item").off("tap");
			$(".proress-item").off().on("tap", function() {
				var iswait = $(this).attr("iswait");
				var serialNo = $(this).attr("serialNo");
				var pagedata = {};
				pagedata.serialNo = serialNo;
				console.log(iswait);
				if(iswait == 1) {
					//跳转到订单
					app.ShowWebView('../Order/supplyOrderDetail.html', {
						SerialNo: serialNo,
						isList:0,
					}, 'pop-in', 'order.supplyOrderDetail');
				} else {
					app.ShowWebView('settleDetail.html', pagedata, "", 'user.settleDetail');
				}
			});
		} else {
			app.renderNoResult("暂无结算信息", "请耐心等待", null, null, obj);
		}
	},
	//加载page信息
	loadPages: function(pagedata) {
		if(pagedata != null && pagedata.Index) {
			var self = app.userSettle;
			var pages = self.pageInfos;
			var page = {};
			var isexsit = false;
			page.Type = self.currentType;
			page.Index = pagedata.Index;
			page.Size = pagedata.Size;
			page.Amount = pagedata.Amount;
			page.ResultAmount = pagedata.ResultAmount;

			if(pages.length > 0) {
				$.each(pages, function(i, rpage) {
					if(rpage.Type == self.currentType) {
						isexsit = true;
						$.extend(true, rpage, page);
					}
				});
			}
			if(!isexsit) {
				pages.push(page);
			}
		}
	},
	//获取当前页码信息
	getcurrentpageinfo: function() {
		var page = {};
		var self = app.userSettle;
		var pages = self.pageInfos;
		$.each(pages, function(i, rpage) {
			if(rpage.Type == self.currentType) {
				page = rpage;
				return;
			}
		});
		return page;
	},
	initiscroll: function(pakeId) {
		var iscroll = {};
		var entity = iscroll.iscroll;
		var self = app.userSettle;
		var height = $(window).height() - 100;
		iscroll.packIdone = "wrapperContent";
		iscroll.packIdtwo = "wapperlist";
		iscroll.detailId = pakeId;
		iscroll.detailtype = self.currentType;
		iscroll.packheight = height;
		var page = self.getcurrentpageinfo();
		iscroll.pageinfo = page;
		iscroll.downcallback = self.pullDownEvent;
		iscroll.upcallback = self.pullUpEnent;
		iscroll.isneeddown = true;
		iscroll.isneedup = true;

		app.scroll.initiscroll(iscroll);
	},
	//下拉事件
	pullDownEvent: function() {
		app.userSettle.IsFirst = false;
		var self = app.userSettle;
		var entity = self.GetSettleListEntity;
		entity.data.Page.Index = 0;
		entity.data.Page.size = 0;
		self.GetFinanceList(self.GetFinanceListCallback);
	},
	//上拉事件
	pullUpEnent: function() {
		app.userSettle.IsFirst = false;
		var self = app.userSettle;
		var pages = self.pageInfos;
		var entity = self.GetSettleListEntity;
		$.each(pages, function(i, page) {
			if(self.currentType == page.Type) {
				if(page.Index <= page.Amount) {
					entity.data.Page.Index = page.Index + 1;
					entity.data.Page.size = page.Size;
					self.GetFinanceList(self.GetFinanceListCallback);
					return;
				}
			}
		});
	},
	tabClickCallback: function(index) {
		app.userSettle.IsFirst = false;
		var self = app.userSettle;
		var obj = $("#divTitle a").eq(index);
		var type = $(obj).attr("type");
		self.currentType = type;
		self.GetSettleListEntity.data.Type = type;
		self.GetFinanceList(self.GetFinanceListCallback);
	}
}