app.userSettlementAccount = {
	isNeedBranch: false,
	init: function() {
		var self = app.userSettlementAccount;
		self.renderPage();
		self.send();
	},
	postParmas: [{
		name: 'password',
		tip: '密码不能为空'
	}, {
		name: 'TypeId',
		tip: '请选择账户类型'
	}, {
		name: 'Number',
		tip: '帐户不能为空'
	}, {
		name: 'Holder',
		tip: '所有者不能为空'
	}, {
		name: 'CityId',
		tip: '请选择开户地'
	}, {
		name: 'Branch',
		tip: '分支行不能为空'
	}],
	initAccountType: function(data) {
		var self = app.userSettlementAccount;
		var $type = $('#checkAccountType');
		var $branches = $('.branch-item');
		var dataToUI = function(data) {
			var result = [];
			$.each(data, function(i, d) {
				if(d.IsSelect != 0) {
					$type.find('span').html(d.Name);
					$type.find('input[name="TypeId"]').val(d.Id);
					if(d.HasBranch == 1) {
						$branches.show();
						self.isNeedBranch = true;
					}
				}
				result.push({
					value: d.Id,
					text: d.Name
				});
			})
			return result;
		}
		var userPicker = new mui.PopPicker();
		userPicker.setData(dataToUI(data));

		var isShowBranch = function(value) {
			var result = false;
			$.each(data, function(i, d) {
				if(d.Id == value && d.HasBranch == 1) {
					result = true;
					self.isNeedBranch = true;
				}
			});
			return result;
		}
		$type.off('click').on('click', function(event) {
			userPicker.show(function(result) {
				var text = result[0].text;
				var value = result[0].value;
				$type.find('span').html(text);
				$type.find('input[name="TypeId"]').val(value);
				if(isShowBranch(value)) {
					self.isNeedBranch = true;
					$branches.show();
				} else {
					self.isNeedBranch = false;
					$branches.hide();
				}
			});
		})
	},
	renderPage: function() {
		var self = app.userSettlementAccount;
		var $form = $('#form-container');
		var formNames = self.postParmas;

		var mask = mui.createMask();
		mask.show();
		app.Post({
			url: projectConfig.apiName.GetFinanceAccountInfo,
			data: {}
		}, null, function(data) {
			mask.close();
			//console.log(JSON.stringify(data));
			self.initAccountType(data.Info.TypeList);
			if(!!data.Info.Number) {
				for(var i = 0, len = formNames.length; i < len; i++) {
					var d = formNames[i];
					var $input = $form.find('input[name="' + d.name + '"]');
					if(!!data.Info[d.name]) {
						if(d.name == 'CityId') {
							$('#chooseAddress span').html(data.Info.CityName);
						} 
						$input.val(data.Info[d.name]);
						
					}

				}
			}
		})
	},
	send: function() {
		var self = app.userSettlementAccount;
		var $send = $('#btn-send');
		var $form = $('#form-container');
		var formNames = self.postParmas;
		$send.on('click', function() {
			var apiOption = {
				url: projectConfig.apiName.SubmitFinanceAccount,
				data: {}
			};
			for(var i = 0, len = formNames.length; i < len; i++) {
				var d = formNames[i];
				var $input = $form.find('input[name="' + d.name + '"]');
				var _value = $input.val();
				switch(d.name) {
					case 'CityId':
					case 'Branch':
						if(self.isNeedBranch) {
							if(!_value) {
								app.showMsg(d.tip);
								$input.focus();
								return false;
							}
							apiOption.data[d.name] = _value;
							break;
						}
						break;
					case 'Number':
						if(!_value) {
								app.showMsg(d.tip);
								$input.focus();
								return false;
						}
						if(self.isNeedBranch){
							if(_value.length<16){
								app.showMsg('帐号至少为16位');
								$input.focus();
								return false;
							}
							apiOption.data[d.name] = _value;
						}else{
							if(_value.length<6){
								app.showMsg('帐号至少为6位');
								$input.focus();
								return false;
							}
							apiOption.data[d.name] = _value;
						}
						break;
					default:
						if(!_value) {
							app.showMsg(d.tip);
							$input.focus();
							return false;
						}
						apiOption.data[d.name] = _value;
						break;
				}

			}
			//console.log(JSON.stringify(apiOption))
			app.Post(apiOption, null, function(result) {
				if(result.Code == '0000') {
					app.confirmMsg('设置成功', function() {
						mui.back();
					});
				} else {
					app.showMsg(result.Msg);
				}

			});
		})
	}
}