(function(window, $) {
	window.Sub_MyApproval = (function() {
		var isLoading = false;
		var pullId = "#pullrefresh";
		var GetOrderListEntity = {
			url: projectConfig.apiName.GetApproveOrderList,
			data: {
				IsApproved: false,
				Page: {
					Index: 1,
					Size: 10
				}
			},
			PageInfo: {
				Index: 0,
				Size: 0,
				Amount: 0,
				ResultAmount: 0
			}
		}
		var listType = 0;

		function init(type) {
			listType = type;
			loadList();
		}

		function loadList() {
			if(isLoading){
				return;
			}
			app.showWaiting('加载中...', 1);
			if(listType == 0) {
				GetOrderListEntity.data.IsApproved = false;
			} else {
				GetOrderListEntity.data.IsApproved = true;
			}
			isLoading = true;
			app.Post(GetOrderListEntity, null, loadListCallBack)
		}

		function loadListCallBack(data) {
			if(app.GetResultState(data)) {
				if(data.OrderList && data.OrderList.length > 0) {
					for(var i = 0; i < data.OrderList.length; i++) {
						var item = data.OrderList[i];
						var sDate = item.TravelDateStart.replace(/-/g, "/");
						var eDate = item.TravelDateEnd.replace(/-/g, "/");

						var sMonth = app.DateTool.DateFormat("MM", sDate);
						var sDay = app.DateTool.DateFormat("dd", sDate);
						var sHour = app.DateTool.DateFormat("hh", sDate);
						var sMinute = app.DateTool.DateFormat("mm", sDate);

						var eMonth = app.DateTool.DateFormat("MM", eDate);
						var eDay = app.DateTool.DateFormat("dd", eDate);
						var eHour = app.DateTool.DateFormat("hh", eDate);
						var eMinute = app.DateTool.DateFormat("mm", eDate);

						var item = data.OrderList[i]
						if(item.ProductType == 1) {
							item.PName = "酒店";
							item.Dest = sMonth + "-" + sDay + "入住 " + eMonth + "-" + eDay + "离店 " + "共" + item.Nights + "晚";
						} else if(item.ProductType == 2) {
							item.PName = "定制";
							item.Dest = sMonth + "-" + sDay + "开始 " + eMonth + "-" + eDay + "结束";
						} else if(item.ProductType == 5) {
							item.PName = "机票";
							item.Dest = sMonth + "-" + sDay + " " + sHour + ":" + sMinute + "起飞" + eHour + ":" + eMinute + "抵达";
						} else if(item.ProductType == 6) {
							item.PName = "火车票";
							item.Dest = sMonth + "-" + sDay + " " + sHour + ":" + sMinute + "出发" + eHour + ":" + eMinute + "抵达";
						}

						data.OrderList[i] = item;
					}
					GetOrderListEntity.PageInfo = data.PageInfo;
					var tmplHot = template('orderList-template', data);
					if(data.PageInfo.PageIndex == 1) {
						$(".approval-list-view").html(tmplHot);
						mui(pullId).pullRefresh().enablePullupToRefresh();

					} else {
						$(".approval-list-view").append(tmplHot);
					}
					
					initEvent();
					if(data.PageInfo.PageIndex == data.PageInfo.PageCount || data.PageInfo.PageSize > data.OrderList.length) {
						mui(pullId).pullRefresh().disablePullupToRefresh();
					} else {
						isLoading = false;
					}
				}
			} else {
				if(data.Code == "0001") {
					$(".approval-list-view").html(loadNoResult());
					LoadPage = false;
				} else {
					if(GetOrderListEntity.PageInfo.Index == 1) {
						$(".approval-list-view").html(loadNoResult());
					}
				}
			}
		}

		function loadNoResult() {
			return '<div class="no-list-msg" style="margin-top:5rem;width:100%; ">' +
				'<div class="no-icon">' +
				'	<img src="../images/no-list-icon.png" />' +
				'</div>' +
				'<div class="no-msg" style="color:#666;">' +
				'暂无订单' +
				'</div>' +
				'</div>';
		}

		function GetNextPageData() {
			GetOrderListEntity.data.Page.Index = GetOrderListEntity.data.Page.Index + 1;
			loadList();
		}

		function initEvent() {
			$(".my-order-center-orderinfo").off().on("tap", function() {
				var orderType = $(this).attr("OrderType");
				var serialNo = $(this).attr("SerialNo");
				var memberId = $(this).attr("MemberId");
				var tid=$(this).attr("TravelBusinessId");
				var data = {};
				data.serialNo = serialNo;
				data.memberId = memberId;
				data.tid=tid;
				if(orderType == 1) {
					app.ShowWebView(projectConfig.ViewId.User.HotelOrderDetail.url, data, "slide-in-right", projectConfig.ViewId.User.HotelOrderDetail.Id);
				} else if(orderType == 5) {
					app.ShowWebView(projectConfig.ViewId.User.PlaneOrderDetail.url, data, "slide-in-right", projectConfig.ViewId.User.PlaneOrderDetail.Id);
				} else if(orderType == 6) {
					app.ShowWebView(projectConfig.ViewId.User.TrainOrderDetail.url, data, "slide-in-right", projectConfig.ViewId.User.TrainOrderDetail.Id);
				}
			})
		}

		function reload(type) {
			isLoading=false;
			listType = type;
			$(".approval-list-view").html("");
			mui(pullId).pullRefresh().refresh(true);
			GetOrderListEntity.data.Page.Index = 1;
			loadList();
		}
		
		function down(){
			isLoading=false;
			$(".approval-list-view").html("");
			//mui(pullId).pullRefresh().refresh(true);
			GetOrderListEntity.data.Page.Index = 1;
			loadList();
		}
		
		return {
			init: init,
			reload: reload,
			GetNextPageData: GetNextPageData,
			down:down
		}
	})();
})(window, $);