app.version = {
	reqRep: {
		getVersion: {
			url: '/Common/GetVersionInfo',
			data: {
				type: 1,
				VersionType:2,
				RefId:0
			}
		}
	},
	checkVersion: function() {
		var self = app.version;
		//获取类型
		var time = (new Date()).getTime(); //请求当前时间
		var systemName = plus.os.name;
		if(systemName == "Android") {
			self.reqRep.getVersion.data.type = 5;
		} else {
			self.reqRep.getVersion.data.type = 6; 
		}
		self.reqRep.getVersion.data.RefId=app.appRefId;
		self.reqRep.getVersion.data.VersionType = app.appType;
		var version = plus.os.version;
			var vs = version.split('.');
			if(vs[0] < 9) {
				app.apiUrl=app.apiUrl.replace("https","http");
			}
		mui.ajax(app.apiUrl + self.reqRep.getVersion.url, {
			data: self.reqRep.getVersion.data,
			dataType: 'json', //服务器返回json格式数据
			type: 'post', //HTTP请求类型
			timeout: 60000, //超时时间设置�秒�
			headers: {
				'Content-Type': 'application/json'
			}, 
			success: function(data) {
				time2 = (new Date()).getTime(); //响应当前时间
				self._callBack(data);
			},
			error: function(xhr, type, errorThrown) {
				app.index.init();
			}
		});
	},
	_callBack: function(data) {
		var self = app.version;
		if(data.Code == "0000") {
			var Version = data.Version;
			var VersionInfo = data.VersionInfo;
			var AppId = data.AppId || "";
			var ApkAddress = data.ApkAddress;
			var curVer = app.appVersion;
			if(self.compareVersion(curVer, Version)) {
				var showmsg = VersionInfo.join("\r\n");

				if(data.IsForce == 1) {
					var btnArray = ['立即更新'];
					mui.confirm(showmsg, '新版本更新' , btnArray, function(e) {
						if(e.index == 0) {
							var systemName = plus.os.name;
							if(systemName == "Android") {
								self.downWgt(ApkAddress);
							} else {
								if(app.appType == 2){ 
									plus.runtime.openURL("itms-apps://itunes.apple.com/app/id" + AppId, function(e) {}, ""); 
								}
								if(app.appType == 1){
									plus.runtime.openURL("itms-services://?action=download-manifest&url=" + ApkAddress, function(e) {}, "");
								}
							}
						}
					})
				} else {
					var btnArray = ['暂时不更新', '立即更新'];
					mui.confirm(showmsg, '新版本更新', btnArray, function(e) {
						if(e.index == 1) {
							var systemName = plus.os.name;
							if(systemName == "Android") {
								self.downWgt(ApkAddress);
							} else {
								if(app.appType == 2){
									plus.runtime.openURL("itms-apps://itunes.apple.com/app/id" + AppId, function(e) {}, "");
								}
								if(app.appType == 1){
									plus.runtime.openURL("itms-services://?action=download-manifest&url=" + ApkAddress, function(e) {}, "");
								}
							}
						}else if(e.index==0){
							app.index.init();
						}
					})
				}
			}else{
				app.index.init();
			}
		}else{
			app.index.init();
		}
	},
	downWgt: function(wgtUrl) {
		var self = app.version;
		plus.nativeUI.showWaiting("下载中.");
		plus.downloader.createDownload(wgtUrl, {
			filename: "_doc/apk/"
		}, function(d, status) {
			if(status == 200) {
				self.installWgt(d.filename);
			} else {
				mui.toast("下载失败");
			}
			plus.nativeUI.closeWaiting();
		}).start();
	},
	installWgt: function(path) {
		plus.nativeUI.showWaiting("安装中.");
		plus.runtime.install(path, {}, function() {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.alert("应用资源更新完成", function() {
				plus.runtime.restart();
			});
		}, function(e) {
			plus.nativeUI.closeWaiting();
			plus.nativeUI.alert("安装失败[" + e.code + "]"+ e.message);
		});
	},
	compareVersion: function(ov, nv) {
		if(!ov || !nv || ov == "" || nv == "") {
			return false;
		}
		var b = false,
			ova = ov.split(".", 3),
			nva = nv.split(".", 3);
		for(var i = 0; i < ova.length && i < nva.length; i++) {
			var so = ova[i],
				no = parseInt(so),
				sn = nva[i],
				nn = parseInt(sn);
			if(nn > no || sn.length > so.length) {
				return true;
			} else if(nn < no) {
				return false;
			}
		}
		if(nva.length > ova.length && 0 == nv.indexOf(ov)) {
			return true;
		}
	}
}

mui.plusReady(function() {
	app.version.checkVersion();
});