var yyFramework = (function() {

	function GUID() {
		this.date = new Date();
		/* 判断是否初始化过，如果初始化过以下代码，则以下代码将不再执行，实际中只执行一次 */
		if(typeof this.newGUID != 'function') {

			/* 生成GUID码 */
			GUID.prototype.newGUID = function() {
				this.date = new Date();
				var guidStr = '';
				sexadecimalDate = this.hexadecimal(this.getGUIDDate(), 16);
				sexadecimalTime = this.hexadecimal(this.getGUIDTime(), 16);
				for(var i = 0; i < 9; i++) {
					guidStr += Math.floor(Math.random() * 16).toString(16);
				}
				guidStr += sexadecimalDate;
				guidStr += sexadecimalTime;
				while(guidStr.length < 32) {
					guidStr += Math.floor(Math.random() * 16).toString(16);
				}
				return this.formatGUID(guidStr);
			};

			/*
			 * 功能：获取当前日期的GUID格式，即8位数的日期：19700101
			 * 返回值：返回GUID日期格式的字条串
			 */
			GUID.prototype.getGUIDDate = function() {
				return this.date.getFullYear() + this.addZero(this.date.getMonth() + 1) + this.addZero(this.date.getDay());
			};

			/*
			 * 功能：获取当前时间的GUID格式，即8位数的时间，包括毫秒，毫秒为2位数：12300933
			 * 返回值：返回GUID日期格式的字条串
			 */
			GUID.prototype.getGUIDTime = function() {
				return this.addZero(this.date.getHours()) + this.addZero(this.date.getMinutes()) + this.addZero(this.date.getSeconds()) + this.addZero(parseInt(this.date.getMilliseconds() / 10));
			};

			/*
			 * 功能: 为一位数的正整数前面添加0，如果是可以转成非NaN数字的字符串也可以实现
			 * 参数: 参数表示准备再前面添加0的数字或可以转换成数字的字符串
			 * 返回值: 如果符合条件，返回添加0后的字条串类型，否则返回自身的字符串
			 */
			GUID.prototype.addZero = function(num) {
				if(Number(num).toString() != 'NaN' && num >= 0 && num < 10) {
					return '0' + Math.floor(num);
				} else {
					return num.toString();
				}
			};

			/*
			 * 功能：将y进制的数值，转换为x进制的数值
			 * 参数：第1个参数表示欲转换的数值；第2个参数表示欲转换的进制；第3个参数可选，表示当前的进制数，如不写则为10
			 * 返回值：返回转换后的字符串
			 */
			GUID.prototype.hexadecimal = function(num, x, y) {
				if(y != undefined) {
					return parseInt(num.toString(), y).toString(x);
				} else {
					return parseInt(num.toString()).toString(x);
				}
			};

			/*
			 * 功能：格式化32位的字符串为GUID模式的字符串
			 * 参数：第1个参数表示32位的字符串
			 * 返回值：标准GUID格式的字符串
			 */
			GUID.prototype.formatGUID = function(guidStr) {
				var str1 = guidStr.slice(0, 8) + '-',
					str2 = guidStr.slice(8, 12) + '-',
					str3 = guidStr.slice(12, 16) + '-',
					str4 = guidStr.slice(16, 20) + '-',
					str5 = guidStr.slice(20);
				return str1 + str2 + str3 + str4 + str5;
			};
		}
	}

	var footer = {
		id: 'yy_footer_menu',
		iconCurr: '_s',
		curr: 'curr',
		data: [{
				icon: 'shouye',
				url: '',
				id: '',
				name: '首页'
			},
			{
				icon: 'dingdan',
				url: '',
				id: '',
				name: '订单'
			}, {
				icon: 'kefu',
				url: '',
				id: '',
				name: '客服'
			}, {
				icon: 'wode',
				url: '',
				id: '',
				name: '我的'
			}
		],
		init: function(type) {
			this.render(type);
		},
		render: function(type) {
			var html, data = this.data;
			if(!$('#' + this.id).get(0)) {
				html = '<div id="' + this.id + '"><ul>' +
					(function() {
						var listHtml = '';
						$.each(data, function(i, d) {
							listHtml += '<li data-id="' + d.id + '" data-url="' + d.url + '"><div class="yy-i-box"><i data-default="' + d.icon + '" class=" icon ceekeefont yy-footer-menu-icon ' + d.icon + '"></i></div><p>' + d.name + '</p></li>';
						});
						return listHtml;
					})() + '</ul></div>';
				$('body').append(html);
			}
			this.active(type);
		},
		active: function(type) {
			var $menu = $('#' + this.id);
			var $menus = $menu.find('li');
			var $curr = $($menus[type - 1]);
			var $icons = $menu.find('.yy-footer-menu-icon');
			$menus.removeClass(this.curr);
			$curr.addClass(this.curr);
		}
	};

	var destinationHistroy = {
		cookieName: 'yy_MICE_destinationHistroy',
		set: function(data) {
			var _list = this.get();
			var index = -1;
			// 去重
			$.each(_list, function(i, d) {
				if(d.Id == data.Id) {
					index = i;
				}
			});
			if(index != -1) {
				_list.splice(index, 1);
			}
			// 插入新数据
			_list.unshift(data);
			// 截断 保持六条
			if(_list.length > 6) {
				_list = _list.splice(0, 6);
			}
			var settings = app.getSettings();
			settings[this.cookieName] = _list;
			app.setSettings(settings);
		},
		get: function() {
			return app.getSettings()[this.cookieName] || [];
		},
		isEmpty: function() {
			return this.get().length == 0;
		}
	};

	function debounce(fn, delay) {
		var _timer;
		return function() {
			var scope = this;
			var args = arguments;
			clearTimeout(_timer);
			_timer = setTimeout(function() {
				fn.apply(scope, args)
			}, delay);
		}
	}

	function pressCopy(id, copyColor, resetColor) {
		var copyBack = function(touch, dom) {
			var val = dom.value || dom.innerHTML;
			if(mui.os.ios) {
				var UIPasteboard = plus.ios.importClass("UIPasteboard");
				var generalPasteboard = UIPasteboard.generalPasteboard();
				generalPasteboard.setValueforPasteboardType(val, "public.utf8-plain-text");
			} else {
				var Context = plus.android.importClass("android.content.Context");
				var main = plus.android.runtimeMainActivity();
				var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
				plus.android.invoke(clip, "setText", val);
			}
			dom.setSelectionRange(0, val.length);
			plus.nativeUI.toast('选中内容已复制到黏贴板!');
		}

		var _pressCopy = {
			_xy: [0, 0],
			init: function(id, callback) {
				var obj = document.getElementById(id);
				obj.addEventListener('touchstart', function(event) {
					plus.nativeUI.toast('长按2秒完成复制。');
					obj.style.background = copyColor;
					if(event.targetTouches.length == 1) {　
						//设置如果长按1秒
						_pressCopy.timeid = setTimeout(function() {
							//准备进行复制........
							typeof callback == 'function' && callback(touch, obj);
						}, 2000);
						event.preventDefault();
						var touch = event.targetTouches[0];
						_pressCopy._xy[0] = touch.pageX;
						_pressCopy._xy[1] = touch.pageY;
					}
				}, false);
				obj.addEventListener('touchmove', function(event) {
					if(event.targetTouches.length == 1) {　　　　
						clearTimeout(_pressCopy.timeid);
						event.preventDefault();
						var touch = event.targetTouches[0];
						//移动超过10个像素判断为选中文字
						if((Math.abs(touch.pageX - _pressCopy._xy[0])) > 10) {
							//准备进行复制........
							typeof callback == 'function' && callback(touch, obj);
						}
					}
				}, false);
				obj.addEventListener('touchend', function(event) {
					clearTimeout(_pressCopy.timeid);
					obj.style.background = resetColor;
					_pressCopy._xy[0] = 0;
					_pressCopy._xy[1] = 0;
				}, false);
			}
		};
		_pressCopy.init(id, copyBack);
	}

	return {
		pressCopy: pressCopy,
		GUID: GUID,
		footer: footer,
		debounce: debounce,
		destinationHistroy: destinationHistroy // MICE历史目的地
	}
})();